/* Database.c generated by valac 0.40.6, the Vala compiler
 * generated from Database.vala, do not modify */

/*
 * Copyright 2015-2017 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <stdarg.h>
#include <sqlite3.h>


#define DRTDB_TYPE_QUERYABLE (drtdb_queryable_get_type ())
#define DRTDB_QUERYABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DRTDB_TYPE_QUERYABLE, DrtdbQueryable))
#define DRTDB_IS_QUERYABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DRTDB_TYPE_QUERYABLE))
#define DRTDB_QUERYABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), DRTDB_TYPE_QUERYABLE, DrtdbQueryableIface))

typedef struct _DrtdbQueryable DrtdbQueryable;
typedef struct _DrtdbQueryableIface DrtdbQueryableIface;

#define DRTDB_TYPE_QUERY (drtdb_query_get_type ())
#define DRTDB_QUERY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DRTDB_TYPE_QUERY, DrtdbQuery))
#define DRTDB_QUERY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DRTDB_TYPE_QUERY, DrtdbQueryClass))
#define DRTDB_IS_QUERY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DRTDB_TYPE_QUERY))
#define DRTDB_IS_QUERY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DRTDB_TYPE_QUERY))
#define DRTDB_QUERY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DRTDB_TYPE_QUERY, DrtdbQueryClass))

typedef struct _DrtdbQuery DrtdbQuery;
typedef struct _DrtdbQueryClass DrtdbQueryClass;

#define DRTDB_TYPE_OBJECT_QUERY (drtdb_object_query_get_type ())
#define DRTDB_OBJECT_QUERY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DRTDB_TYPE_OBJECT_QUERY, DrtdbObjectQuery))
#define DRTDB_OBJECT_QUERY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DRTDB_TYPE_OBJECT_QUERY, DrtdbObjectQueryClass))
#define DRTDB_IS_OBJECT_QUERY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DRTDB_TYPE_OBJECT_QUERY))
#define DRTDB_IS_OBJECT_QUERY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DRTDB_TYPE_OBJECT_QUERY))
#define DRTDB_OBJECT_QUERY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DRTDB_TYPE_OBJECT_QUERY, DrtdbObjectQueryClass))

typedef struct _DrtdbObjectQuery DrtdbObjectQuery;
typedef struct _DrtdbObjectQueryClass DrtdbObjectQueryClass;

#define DRTDB_TYPE_DATABASE (drtdb_database_get_type ())
#define DRTDB_DATABASE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DRTDB_TYPE_DATABASE, DrtdbDatabase))
#define DRTDB_DATABASE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DRTDB_TYPE_DATABASE, DrtdbDatabaseClass))
#define DRTDB_IS_DATABASE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DRTDB_TYPE_DATABASE))
#define DRTDB_IS_DATABASE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DRTDB_TYPE_DATABASE))
#define DRTDB_DATABASE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DRTDB_TYPE_DATABASE, DrtdbDatabaseClass))

typedef struct _DrtdbDatabase DrtdbDatabase;
typedef struct _DrtdbDatabaseClass DrtdbDatabaseClass;
typedef struct _DrtdbDatabasePrivate DrtdbDatabasePrivate;

#define DRTDB_TYPE_ORM_MANAGER (drtdb_orm_manager_get_type ())
#define DRTDB_ORM_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DRTDB_TYPE_ORM_MANAGER, DrtdbOrmManager))
#define DRTDB_ORM_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DRTDB_TYPE_ORM_MANAGER, DrtdbOrmManagerClass))
#define DRTDB_IS_ORM_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DRTDB_TYPE_ORM_MANAGER))
#define DRTDB_IS_ORM_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DRTDB_TYPE_ORM_MANAGER))
#define DRTDB_ORM_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DRTDB_TYPE_ORM_MANAGER, DrtdbOrmManagerClass))

typedef struct _DrtdbOrmManager DrtdbOrmManager;
typedef struct _DrtdbOrmManagerClass DrtdbOrmManagerClass;

#define DRTDB_TYPE_CONNECTION (drtdb_connection_get_type ())
#define DRTDB_CONNECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DRTDB_TYPE_CONNECTION, DrtdbConnection))
#define DRTDB_CONNECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DRTDB_TYPE_CONNECTION, DrtdbConnectionClass))
#define DRTDB_IS_CONNECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DRTDB_TYPE_CONNECTION))
#define DRTDB_IS_CONNECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DRTDB_TYPE_CONNECTION))
#define DRTDB_CONNECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DRTDB_TYPE_CONNECTION, DrtdbConnectionClass))

typedef struct _DrtdbConnection DrtdbConnection;
typedef struct _DrtdbConnectionClass DrtdbConnectionClass;
enum  {
	DRTDB_DATABASE_0_PROPERTY,
	DRTDB_DATABASE_DB_FILE_PROPERTY,
	DRTDB_DATABASE_ORM_PROPERTY,
	DRTDB_DATABASE_OPENED_PROPERTY,
	DRTDB_DATABASE_NUM_PROPERTIES
};
static GParamSpec* drtdb_database_properties[DRTDB_DATABASE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _t_destroy_func0(var) (((var == NULL) || (t_destroy_func == NULL)) ? NULL : (var = (t_destroy_func (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _sqlite3_close0(var) ((var == NULL) ? NULL : (var = (sqlite3_close (var), NULL)))

typedef enum  {
	DRTDB_DATABASE_ERROR_UNKNOWN,
	DRTDB_DATABASE_ERROR_IOERROR,
	DRTDB_DATABASE_ERROR_DATABASE_NOT_OPENED,
	DRTDB_DATABASE_ERROR_GENERAL,
	DRTDB_DATABASE_ERROR_RANGE,
	DRTDB_DATABASE_ERROR_DATA_TYPE,
	DRTDB_DATABASE_ERROR_NAME,
	DRTDB_DATABASE_ERROR_MISMATCH,
	DRTDB_DATABASE_ERROR_MISUSE,
	DRTDB_DATABASE_ERROR_DOES_NOT_EXIST,
	DRTDB_DATABASE_ERROR_TOO_MANY_RESULTS
} DrtdbDatabaseError;
#define DRTDB_DATABASE_ERROR drtdb_database_error_quark ()
struct _DrtdbQueryableIface {
	GTypeInterface parent_iface;
	void (*exec) (DrtdbQueryable* self, const gchar* sql, GCancellable* cancellable, GError** error);
	DrtdbQuery* (*query) (DrtdbQueryable* self, const gchar* sql, GCancellable* cancellable, GError** error);
	DrtdbObjectQuery* (*get_objects) (DrtdbQueryable* self, GType t_type, GBoxedCopyFunc t_dup_func, GDestroyNotify t_destroy_func, GCancellable* cancellable, GError** error);
	gpointer (*get_object) (DrtdbQueryable* self, GType t_type, GBoxedCopyFunc t_dup_func, GDestroyNotify t_destroy_func, GValue* pk, GCancellable* cancellable, GError** error);
	const gchar* (*get_last_error_message) (DrtdbQueryable* self);
};

struct _DrtdbDatabase {
	GObject parent_instance;
	DrtdbDatabasePrivate * priv;
};

struct _DrtdbDatabaseClass {
	GObjectClass parent_class;
	void (*open) (DrtdbDatabase* self, GCancellable* cancellable, GError** error);
	void (*close) (DrtdbDatabase* self, GCancellable* cancellable, GError** error);
};

struct _DrtdbDatabasePrivate {
	GFile* _db_file;
	DrtdbOrmManager* _orm;
	gboolean _opened;
	GRecMutex __lock__opened;
	DrtdbConnection* master_connection;
};


static gpointer drtdb_database_parent_class = NULL;
static DrtdbQueryableIface * drtdb_database_drtdb_queryable_parent_iface = NULL;

const gchar* sqlite3_errstr (gint errcode);
GQuark drtdb_database_error_quark (void);
GType drtdb_query_get_type (void) G_GNUC_CONST;
GType drtdb_object_query_get_type (void) G_GNUC_CONST;
GType drtdb_queryable_get_type (void) G_GNUC_CONST;
GType drtdb_database_get_type (void) G_GNUC_CONST;
GType drtdb_orm_manager_get_type (void) G_GNUC_CONST;
GType drtdb_connection_get_type (void) G_GNUC_CONST;
#define DRTDB_DATABASE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), DRTDB_TYPE_DATABASE, DrtdbDatabasePrivate))
DrtdbDatabase* drtdb_database_new (GFile* db_file,
                                   DrtdbOrmManager* orm);
DrtdbDatabase* drtdb_database_construct (GType object_type,
                                         GFile* db_file,
                                         DrtdbOrmManager* orm);
DrtdbOrmManager* drtdb_orm_manager_new (void);
DrtdbOrmManager* drtdb_orm_manager_construct (GType object_type);
void drtdb_database_open (DrtdbDatabase* self,
                          GCancellable* cancellable,
                          GError** error);
static void drtdb_database_real_open (DrtdbDatabase* self,
                               GCancellable* cancellable,
                               GError** error);
void drtdb_throw_if_cancelled (GCancellable* cancellable,
                               const gchar* method,
                               const gchar* file,
                               gint line,
                               GError** error);
gboolean drtdb_database_get_opened (DrtdbDatabase* self);
GFile* drtdb_database_get_db_file (DrtdbDatabase* self);
DrtdbConnection* drtdb_database_open_connection_internal (DrtdbDatabase* self,
                                                          GCancellable* cancellable,
                                                          gboolean master,
                                                          GError** error);
static void drtdb_database_set_opened (DrtdbDatabase* self,
                                gboolean value);
void drtdb_database_close (DrtdbDatabase* self,
                           GCancellable* cancellable,
                           GError** error);
static void drtdb_database_real_close (DrtdbDatabase* self,
                                GCancellable* cancellable,
                                GError** error);
static void drtdb_database_real_exec (DrtdbQueryable* base,
                               const gchar* sql,
                               GCancellable* cancellable,
                               GError** error);
static DrtdbConnection* drtdb_database_get_master_connection (DrtdbDatabase* self,
                                                       GError** error);
void drtdb_queryable_exec (DrtdbQueryable* self,
                           const gchar* sql,
                           GCancellable* cancellable,
                           GError** error);
static DrtdbQuery* drtdb_database_real_query (DrtdbQueryable* base,
                                       const gchar* sql,
                                       GCancellable* cancellable,
                                       GError** error);
DrtdbQuery* drtdb_queryable_query (DrtdbQueryable* self,
                                   const gchar* sql,
                                   GCancellable* cancellable,
                                   GError** error);
DrtdbQuery* drtdb_database_query_with_values (DrtdbDatabase* self,
                                              GCancellable* cancellable,
                                              const gchar* sql,
                                              GError** error,
                                              ...);
DrtdbQuery* drtdb_connection_query_with_values_va (DrtdbConnection* self,
                                                   GCancellable* cancellable,
                                                   const gchar* sql,
                                                   va_list args,
                                                   GError** error);
DrtdbQuery* drtdb_database_query_with_values_va (DrtdbDatabase* self,
                                                 GCancellable* cancellable,
                                                 const gchar* sql,
                                                 va_list args,
                                                 GError** error);
static DrtdbObjectQuery* drtdb_database_real_get_objects (DrtdbQueryable* base,
                                                   GType t_type,
                                                   GBoxedCopyFunc t_dup_func,
                                                   GDestroyNotify t_destroy_func,
                                                   GCancellable* cancellable,
                                                   GError** error);
DrtdbObjectQuery* drtdb_queryable_get_objects (DrtdbQueryable* self,
                                               GType t_type,
                                               GBoxedCopyFunc t_dup_func,
                                               GDestroyNotify t_destroy_func,
                                               GCancellable* cancellable,
                                               GError** error);
DrtdbObjectQuery* drtdb_database_query_objects (DrtdbDatabase* self,
                                                GType t_type,
                                                GBoxedCopyFunc t_dup_func,
                                                GDestroyNotify t_destroy_func,
                                                GCancellable* cancellable,
                                                const gchar* sql_filter,
                                                GError** error,
                                                ...);
DrtdbObjectQuery* drtdb_connection_query_objects_va (DrtdbConnection* self,
                                                     GType t_type,
                                                     GBoxedCopyFunc t_dup_func,
                                                     GDestroyNotify t_destroy_func,
                                                     GCancellable* cancellable,
                                                     const gchar* filter,
                                                     va_list args,
                                                     GError** error);
static gpointer drtdb_database_real_get_object (DrtdbQueryable* base,
                                         GType t_type,
                                         GBoxedCopyFunc t_dup_func,
                                         GDestroyNotify t_destroy_func,
                                         GValue* pk,
                                         GCancellable* cancellable,
                                         GError** error);
gpointer drtdb_queryable_get_object (DrtdbQueryable* self,
                                     GType t_type,
                                     GBoxedCopyFunc t_dup_func,
                                     GDestroyNotify t_destroy_func,
                                     GValue* pk,
                                     GCancellable* cancellable,
                                     GError** error);
static const gchar* drtdb_database_real_get_last_error_message (DrtdbQueryable* base);
const gchar* drtdb_queryable_get_last_error_message (DrtdbQueryable* self);
static inline void drtdb_database_throw_if_not_opened (DrtdbDatabase* self,
                                         GError** error);
DrtdbConnection* drtdb_database_open_connection (DrtdbDatabase* self,
                                                 GCancellable* cancellable,
                                                 GError** error);
gboolean drtdb_is_sql_error (gint result_code);
GError* drtdb_convert_sqlite_error (gint errno,
                                    const gchar* message,
                                    const gchar* sql,
                                    sqlite3_stmt* stm);
DrtdbOrmManager* drtdb_database_get_orm (DrtdbDatabase* self);
DrtdbConnection* drtdb_connection_new (sqlite3* db,
                                       DrtdbOrmManager* orm);
DrtdbConnection* drtdb_connection_construct (GType object_type,
                                             sqlite3* db,
                                             DrtdbOrmManager* orm);
static void drtdb_database_set_db_file (DrtdbDatabase* self,
                                 GFile* value);
static void drtdb_database_set_orm (DrtdbDatabase* self,
                             DrtdbOrmManager* value);
static void drtdb_database_finalize (GObject * obj);
static void _vala_drtdb_database_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec);
static void _vala_drtdb_database_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec);


/**
 * Creates new database object
 * 
 * @param db_file    corresponding database file
 * @param orm        Object Relationship Mapping manager
 */
static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


DrtdbDatabase*
drtdb_database_construct (GType object_type,
                          GFile* db_file,
                          DrtdbOrmManager* orm)
{
	DrtdbDatabase * self = NULL;
	DrtdbOrmManager* _tmp0_ = NULL;
	DrtdbOrmManager* _tmp1_;
	g_return_val_if_fail (db_file != NULL, NULL);
	_tmp1_ = _g_object_ref0 (orm);
	_tmp0_ = _tmp1_;
	if (_tmp0_ == NULL) {
		DrtdbOrmManager* _tmp2_;
		_tmp2_ = drtdb_orm_manager_new ();
		_g_object_unref0 (_tmp0_);
		_tmp0_ = _tmp2_;
	}
	self = (DrtdbDatabase*) g_object_new (object_type, "db-file", db_file, "orm", _tmp0_, NULL);
	_g_object_unref0 (_tmp0_);
	return self;
}


DrtdbDatabase*
drtdb_database_new (GFile* db_file,
                    DrtdbOrmManager* orm)
{
	return drtdb_database_construct (DRTDB_TYPE_DATABASE, db_file, orm);
}


/**
 * Open database.
 * 
 * Once database is opened, master connection can be used and new database connections can be created.
 * 
 * If database file does not exist, new empty database file is created.
 * 
 * @param cancellable    Cancellable object.
 * @throws GLib.Error when operation is cancelled.
 * @throws DatabaseError when database cannot be opened.
 */
static void
drtdb_database_real_open (DrtdbDatabase* self,
                          GCancellable* cancellable,
                          GError** error)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	GFile* db_dir = NULL;
	GFile* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
	gboolean _tmp6_ = FALSE;
	GFile* _tmp7_;
	DrtdbConnection* _tmp14_ = NULL;
	DrtdbConnection* _tmp15_;
	DrtdbConnection* _tmp16_;
	GError * _inner_error_ = NULL;
	drtdb_throw_if_cancelled (cancellable, "Drtdb.Database.open", "Database.vala", 85, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		return;
	}
	_tmp0_ = drtdb_database_get_opened (self);
	_tmp1_ = _tmp0_;
	g_return_if_fail (!_tmp1_);
	_tmp2_ = self->priv->_db_file;
	_tmp3_ = g_file_get_parent (_tmp2_);
	db_dir = _tmp3_;
	_tmp4_ = db_dir;
	if (!g_file_query_exists (_tmp4_, cancellable)) {
		GFile* _tmp5_;
		_tmp5_ = db_dir;
		g_file_make_directory_with_parents (_tmp5_, cancellable, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			g_propagate_error (error, _inner_error_);
			_g_object_unref0 (db_dir);
			return;
		}
	}
	_tmp7_ = self->priv->_db_file;
	if (g_file_query_exists (_tmp7_, cancellable)) {
		GFile* _tmp8_;
		_tmp8_ = self->priv->_db_file;
		_tmp6_ = g_file_query_file_type (_tmp8_, 0, cancellable) != G_FILE_TYPE_REGULAR;
	} else {
		_tmp6_ = FALSE;
	}
	if (_tmp6_) {
		GFile* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		GError* _tmp12_;
		GError* _tmp13_;
		_tmp9_ = self->priv->_db_file;
		_tmp10_ = g_file_get_path (_tmp9_);
		_tmp11_ = _tmp10_;
		_tmp12_ = g_error_new (DRTDB_DATABASE_ERROR, DRTDB_DATABASE_ERROR_IOERROR, "'%s' exists, but is not a file.", _tmp11_);
		_tmp13_ = _tmp12_;
		_g_free0 (_tmp11_);
		_inner_error_ = _tmp13_;
		g_propagate_error (error, _inner_error_);
		_g_object_unref0 (db_dir);
		return;
	}
	_tmp15_ = drtdb_database_open_connection_internal (self, cancellable, TRUE, &_inner_error_);
	_tmp14_ = _tmp15_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		_g_object_unref0 (db_dir);
		return;
	}
	_tmp16_ = _tmp14_;
	_tmp14_ = NULL;
	_g_object_unref0 (self->priv->master_connection);
	self->priv->master_connection = _tmp16_;
	drtdb_database_set_opened (self, TRUE);
	_g_object_unref0 (_tmp14_);
	_g_object_unref0 (db_dir);
}


void
drtdb_database_open (DrtdbDatabase* self,
                     GCancellable* cancellable,
                     GError** error)
{
	g_return_if_fail (self != NULL);
	DRTDB_DATABASE_GET_CLASS (self)->open (self, cancellable, error);
}


/**
 * Close database
 * 
 * Once database is closed, master connection is also closed and new database connections cannot be created.
 * @param cancellable    Cancellable object
 * @throws GLib.IOError when the operation is cancelled
 * @throws DatabaseError when operation fails
 */
static void
drtdb_database_real_close (DrtdbDatabase* self,
                           GCancellable* cancellable,
                           GError** error)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	GError * _inner_error_ = NULL;
	drtdb_throw_if_cancelled (cancellable, "Drtdb.Database.close", "Database.vala", 109, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		return;
	}
	_tmp0_ = drtdb_database_get_opened (self);
	_tmp1_ = _tmp0_;
	g_return_if_fail (_tmp1_);
	_g_object_unref0 (self->priv->master_connection);
	self->priv->master_connection = NULL;
	drtdb_database_set_opened (self, FALSE);
}


void
drtdb_database_close (DrtdbDatabase* self,
                      GCancellable* cancellable,
                      GError** error)
{
	g_return_if_fail (self != NULL);
	DRTDB_DATABASE_GET_CLASS (self)->close (self, cancellable, error);
}


/**
 * Execute a sql query on master database conection
 * 
 * @param sql            SQL query
 * @param cancellable    Cancellable object
 * @throws GLib.IOError when the operation is cancelled
 * @throws DatabaseError when operation fails
 */
static void
drtdb_database_real_exec (DrtdbQueryable* base,
                          const gchar* sql,
                          GCancellable* cancellable,
                          GError** error)
{
	DrtdbDatabase * self;
	DrtdbConnection* _tmp0_ = NULL;
	DrtdbConnection* _tmp1_;
	GError * _inner_error_ = NULL;
	self = (DrtdbDatabase*) base;
	g_return_if_fail (sql != NULL);
	_tmp1_ = drtdb_database_get_master_connection (self, &_inner_error_);
	_tmp0_ = _tmp1_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		return;
	}
	drtdb_queryable_exec ((DrtdbQueryable*) _tmp0_, sql, cancellable, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		_g_object_unref0 (_tmp0_);
		return;
	}
	_g_object_unref0 (_tmp0_);
}


/**
 * Create new raw data query
 * 
 * After query is created, primitive data types can be bound prior execution.
 * 
 * @param sql            SQL query
 * @param cancellable    Cancellable object
 * @return new query object for further modifications prior execution
 * @throws GLib.IOError when the operation is cancelled
 * @throws DatabaseError when operation fails
 */
static DrtdbQuery*
drtdb_database_real_query (DrtdbQueryable* base,
                           const gchar* sql,
                           GCancellable* cancellable,
                           GError** error)
{
	DrtdbDatabase * self;
	DrtdbQuery* result = NULL;
	DrtdbConnection* _tmp0_ = NULL;
	DrtdbConnection* _tmp1_;
	DrtdbQuery* _tmp2_ = NULL;
	DrtdbQuery* _tmp3_;
	DrtdbQuery* _tmp4_;
	GError * _inner_error_ = NULL;
	self = (DrtdbDatabase*) base;
	g_return_val_if_fail (sql != NULL, NULL);
	_tmp1_ = drtdb_database_get_master_connection (self, &_inner_error_);
	_tmp0_ = _tmp1_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		return NULL;
	}
	_tmp3_ = drtdb_queryable_query ((DrtdbQueryable*) _tmp0_, sql, cancellable, &_inner_error_);
	_tmp2_ = _tmp3_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		_g_object_unref0 (_tmp0_);
		return NULL;
	}
	_tmp4_ = _tmp2_;
	_tmp2_ = NULL;
	result = _tmp4_;
	_g_object_unref0 (_tmp2_);
	_g_object_unref0 (_tmp0_);
	return result;
}


/**
 * Create new raw data query with values
 * 
 * After query is created, primitive data types can still be bound prior execution.
 * 
 * @param cancellable    Cancellable object
 * @param sql            SQL query with {@link BindExpression} syntax
 * @param ...            Values to be bound
 * @return new query object for further modifications prior execution
 * @throws GLib.IOError when the operation is cancelled
 * @throws DatabaseError when operation fails
 */
DrtdbQuery*
drtdb_database_query_with_values (DrtdbDatabase* self,
                                  GCancellable* cancellable,
                                  const gchar* sql,
                                  GError** error,
                                  ...)
{
	DrtdbQuery* result = NULL;
	DrtdbConnection* _tmp0_ = NULL;
	DrtdbConnection* _tmp1_;
	DrtdbQuery* _tmp2_ = NULL;
	va_list _tmp3_ = {0};
	DrtdbQuery* _tmp4_;
	DrtdbQuery* _tmp5_;
	DrtdbQuery* _tmp6_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (sql != NULL, NULL);
	_tmp1_ = drtdb_database_get_master_connection (self, &_inner_error_);
	_tmp0_ = _tmp1_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		return NULL;
	}
	va_start (_tmp3_, error);
	_tmp4_ = drtdb_connection_query_with_values_va (_tmp0_, cancellable, sql, _tmp3_, &_inner_error_);
	_tmp5_ = _tmp4_;
	va_end (_tmp3_);
	_tmp2_ = _tmp5_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		_g_object_unref0 (_tmp0_);
		return NULL;
	}
	_tmp6_ = _tmp2_;
	_tmp2_ = NULL;
	result = _tmp6_;
	_g_object_unref0 (_tmp2_);
	_g_object_unref0 (_tmp0_);
	return result;
}


/**
 * Create new raw data query with values
 * 
 * After query is created, primitive data types can still be bound prior execution.
 * 
 * @param cancellable    Cancellable object
 * @param sql            SQL query with {@link BindExpression} syntax
 * @param args           Values to be bound
 * @return new query object for further modifications prior execution
 * @throws GLib.IOError when the operation is cancelled
 * @throws DatabaseError when operation fails
 */
DrtdbQuery*
drtdb_database_query_with_values_va (DrtdbDatabase* self,
                                     GCancellable* cancellable,
                                     const gchar* sql,
                                     va_list args,
                                     GError** error)
{
	DrtdbQuery* result = NULL;
	DrtdbConnection* _tmp0_ = NULL;
	DrtdbConnection* _tmp1_;
	DrtdbQuery* _tmp2_ = NULL;
	DrtdbQuery* _tmp3_;
	DrtdbQuery* _tmp4_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (sql != NULL, NULL);
	_tmp1_ = drtdb_database_get_master_connection (self, &_inner_error_);
	_tmp0_ = _tmp1_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		return NULL;
	}
	_tmp3_ = drtdb_connection_query_with_values_va (_tmp0_, cancellable, sql, args, &_inner_error_);
	_tmp2_ = _tmp3_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		_g_object_unref0 (_tmp0_);
		return NULL;
	}
	_tmp4_ = _tmp2_;
	_tmp2_ = NULL;
	result = _tmp4_;
	_g_object_unref0 (_tmp2_);
	_g_object_unref0 (_tmp0_);
	return result;
}


/**
 * Get ORM objects
 * 
 * @param cancellable    Cancellable object
 * @return new ORM query object
 * @throws GLib.IOError when the operation is cancelled
 * @throws DatabaseError when operation fails
 */
static DrtdbObjectQuery*
drtdb_database_real_get_objects (DrtdbQueryable* base,
                                 GType t_type,
                                 GBoxedCopyFunc t_dup_func,
                                 GDestroyNotify t_destroy_func,
                                 GCancellable* cancellable,
                                 GError** error)
{
	DrtdbDatabase * self;
	DrtdbObjectQuery* result = NULL;
	DrtdbConnection* _tmp0_ = NULL;
	DrtdbConnection* _tmp1_;
	DrtdbObjectQuery* _tmp2_ = NULL;
	DrtdbObjectQuery* _tmp3_;
	DrtdbObjectQuery* _tmp4_;
	GError * _inner_error_ = NULL;
	self = (DrtdbDatabase*) base;
	_tmp1_ = drtdb_database_get_master_connection (self, &_inner_error_);
	_tmp0_ = _tmp1_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		return NULL;
	}
	_tmp3_ = drtdb_queryable_get_objects ((DrtdbQueryable*) _tmp0_, t_type, (GBoxedCopyFunc) t_dup_func, (GDestroyNotify) t_destroy_func, cancellable, &_inner_error_);
	_tmp2_ = _tmp3_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		_g_object_unref0 (_tmp0_);
		return NULL;
	}
	_tmp4_ = _tmp2_;
	_tmp2_ = NULL;
	result = _tmp4_;
	_g_object_unref0 (_tmp2_);
	_g_object_unref0 (_tmp0_);
	return result;
}


/**
 * Create new ORM query
 * 
 * @param sql_filter     SQL conditions for filtering of objects (with {@link BindExpression})
 * @param cancellable    Cancellable object
 * @param ...            Data to bind to the query placeholders
 * @return new ORM query object
 * @throws GLib.IOError when the operation is cancelled
 * @throws DatabaseError when operation fails
 */
DrtdbObjectQuery*
drtdb_database_query_objects (DrtdbDatabase* self,
                              GType t_type,
                              GBoxedCopyFunc t_dup_func,
                              GDestroyNotify t_destroy_func,
                              GCancellable* cancellable,
                              const gchar* sql_filter,
                              GError** error,
                              ...)
{
	DrtdbObjectQuery* result = NULL;
	DrtdbConnection* _tmp0_ = NULL;
	DrtdbConnection* _tmp1_;
	DrtdbObjectQuery* _tmp2_ = NULL;
	va_list _tmp3_ = {0};
	DrtdbObjectQuery* _tmp4_;
	DrtdbObjectQuery* _tmp5_;
	DrtdbObjectQuery* _tmp6_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp1_ = drtdb_database_get_master_connection (self, &_inner_error_);
	_tmp0_ = _tmp1_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		return NULL;
	}
	va_start (_tmp3_, error);
	_tmp4_ = drtdb_connection_query_objects_va (_tmp0_, t_type, (GBoxedCopyFunc) t_dup_func, (GDestroyNotify) t_destroy_func, cancellable, sql_filter, _tmp3_, &_inner_error_);
	_tmp5_ = _tmp4_;
	va_end (_tmp3_);
	_tmp2_ = _tmp5_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		_g_object_unref0 (_tmp0_);
		return NULL;
	}
	_tmp6_ = _tmp2_;
	_tmp2_ = NULL;
	result = _tmp6_;
	_g_object_unref0 (_tmp2_);
	_g_object_unref0 (_tmp0_);
	return result;
}


/**
 * Get a single ORM object
 * 
 * @param pk             value of primary key
 * @param cancellable    Cancellable object
 * @return new ORM object
 * @throws GLib.IOError when the operation is cancelled
 * @throws DatabaseError when operation fails
 */
static gpointer
drtdb_database_real_get_object (DrtdbQueryable* base,
                                GType t_type,
                                GBoxedCopyFunc t_dup_func,
                                GDestroyNotify t_destroy_func,
                                GValue* pk,
                                GCancellable* cancellable,
                                GError** error)
{
	DrtdbDatabase * self;
	gpointer result = NULL;
	DrtdbConnection* _tmp0_ = NULL;
	DrtdbConnection* _tmp1_;
	gpointer _tmp2_ = NULL;
	GValue _tmp3_;
	gpointer _tmp4_;
	gpointer _tmp5_;
	GError * _inner_error_ = NULL;
	self = (DrtdbDatabase*) base;
	g_return_val_if_fail (pk != NULL, NULL);
	_tmp1_ = drtdb_database_get_master_connection (self, &_inner_error_);
	_tmp0_ = _tmp1_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		return NULL;
	}
	_tmp3_ = *pk;
	_tmp4_ = drtdb_queryable_get_object ((DrtdbQueryable*) _tmp0_, t_type, (GBoxedCopyFunc) t_dup_func, (GDestroyNotify) t_destroy_func, &_tmp3_, cancellable, &_inner_error_);
	_tmp2_ = _tmp4_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		_g_object_unref0 (_tmp0_);
		return NULL;
	}
	_tmp5_ = _tmp2_;
	_tmp2_ = NULL;
	result = _tmp5_;
	_t_destroy_func0 (_tmp2_);
	_g_object_unref0 (_tmp0_);
	return result;
}


/**
 * Return last error message
 * 
 * @return the last error message
 */
static const gchar*
drtdb_database_real_get_last_error_message (DrtdbQueryable* base)
{
	DrtdbDatabase * self;
	const gchar* result = NULL;
	GError * _inner_error_ = NULL;
	self = (DrtdbDatabase*) base;
	{
		DrtdbConnection* _tmp0_ = NULL;
		DrtdbConnection* _tmp1_;
		const gchar* _tmp2_;
		_tmp1_ = drtdb_database_get_master_connection (self, &_inner_error_);
		_tmp0_ = _tmp1_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == DRTDB_DATABASE_ERROR) {
				goto __catch0_drtdb_database_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp2_ = drtdb_queryable_get_last_error_message ((DrtdbQueryable*) _tmp0_);
		result = _tmp2_;
		_g_object_unref0 (_tmp0_);
		return result;
	}
	goto __finally0;
	__catch0_drtdb_database_error:
	{
		GError* e = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		result = NULL;
		_g_error_free0 (e);
		return result;
	}
	__finally0:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
	g_clear_error (&_inner_error_);
	return NULL;
}


/**
 * Get master database connection
 * 
 * @throws DatabaseError when database is closed
 * @return master database connection
 */
static DrtdbConnection*
drtdb_database_get_master_connection (DrtdbDatabase* self,
                                      GError** error)
{
	DrtdbConnection* result = NULL;
	DrtdbConnection* _tmp0_;
	DrtdbConnection* _tmp1_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	drtdb_database_throw_if_not_opened (self, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == DRTDB_DATABASE_ERROR) {
			g_propagate_error (error, _inner_error_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp0_ = self->priv->master_connection;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	result = _tmp1_;
	return result;
}


/**
 * Open new database connection
 * @param cancellable    Cancellable object
 * @return new database connection
 * @throws GLib.IOError when the operation is cancelled
 * @throws DatabaseError when operation fails
 */
DrtdbConnection*
drtdb_database_open_connection (DrtdbDatabase* self,
                                GCancellable* cancellable,
                                GError** error)
{
	DrtdbConnection* result = NULL;
	DrtdbConnection* _tmp0_ = NULL;
	DrtdbConnection* _tmp1_;
	DrtdbConnection* _tmp2_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp1_ = drtdb_database_open_connection_internal (self, cancellable, FALSE, &_inner_error_);
	_tmp0_ = _tmp1_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		return NULL;
	}
	_tmp2_ = _tmp0_;
	_tmp0_ = NULL;
	result = _tmp2_;
	_g_object_unref0 (_tmp0_);
	return result;
}


/**
 * Open new database connection
 * @param cancellable    Cancellable object
 * @param master         If the master connection is to be opened
 * @return new database connection
 * @throws GLib.IOError when the operation is cancelled
 * @throws DatabaseError when operation fails
 */
DrtdbConnection*
drtdb_database_open_connection_internal (DrtdbDatabase* self,
                                         GCancellable* cancellable,
                                         gboolean master,
                                         GError** error)
{
	DrtdbConnection* result = NULL;
	sqlite3* db = NULL;
	gint _result_ = 0;
	GFile* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	sqlite3* _tmp3_ = NULL;
	gint _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	sqlite3* _tmp15_;
	DrtdbOrmManager* _tmp16_;
	DrtdbConnection* _tmp17_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	drtdb_throw_if_cancelled (cancellable, "Drtdb.Database.open_connection_internal", "Database.vala", 275, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		return NULL;
	}
	if (!master) {
		drtdb_database_throw_if_not_opened (self, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			g_propagate_error (error, _inner_error_);
			return NULL;
		}
	}
	_tmp0_ = self->priv->_db_file;
	_tmp1_ = g_file_get_path (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp4_ = sqlite3_open_v2 (_tmp2_, &_tmp3_, SQLITE_OPEN_READWRITE | SQLITE_OPEN_CREATE, NULL);
	_sqlite3_close0 (db);
	db = _tmp3_;
	_tmp5_ = _tmp4_;
	_g_free0 (_tmp2_);
	_result_ = _tmp5_;
	_tmp6_ = _result_;
	if (drtdb_is_sql_error (_tmp6_)) {
		const gchar* _tmp7_ = NULL;
		sqlite3* _tmp8_;
		gint _tmp13_;
		GError* _tmp14_;
		_tmp8_ = db;
		if (_tmp8_ != NULL) {
			sqlite3* _tmp9_;
			const gchar* _tmp10_;
			_tmp9_ = db;
			_tmp10_ = sqlite3_errmsg (_tmp9_);
			_tmp7_ = _tmp10_;
		} else {
			gint _tmp11_;
			const gchar* _tmp12_;
			_tmp11_ = _result_;
			_tmp12_ = sqlite3_errstr (_tmp11_);
			_tmp7_ = _tmp12_;
		}
		_tmp13_ = _result_;
		_tmp14_ = drtdb_convert_sqlite_error (_tmp13_, _tmp7_, NULL, NULL);
		_inner_error_ = _tmp14_;
		g_propagate_error (error, _inner_error_);
		_sqlite3_close0 (db);
		return NULL;
	}
	_tmp15_ = db;
	db = NULL;
	_tmp16_ = self->priv->_orm;
	_tmp17_ = drtdb_connection_new (_tmp15_, _tmp16_);
	result = _tmp17_;
	_sqlite3_close0 (db);
	return result;
}


/**
 * Throw an error if database is closed
 * 
 * @throws DatabaseError if database is closed
 */
static inline void
drtdb_database_throw_if_not_opened (DrtdbDatabase* self,
                                    GError** error)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = drtdb_database_get_opened (self);
	_tmp1_ = _tmp0_;
	if (!_tmp1_) {
		GFile* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GError* _tmp5_;
		GError* _tmp6_;
		_tmp2_ = self->priv->_db_file;
		_tmp3_ = g_file_get_path (_tmp2_);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_error_new (DRTDB_DATABASE_ERROR, DRTDB_DATABASE_ERROR_DATABASE_NOT_OPENED, "Database '%s' is not opened.", _tmp4_);
		_tmp6_ = _tmp5_;
		_g_free0 (_tmp4_);
		_inner_error_ = _tmp6_;
		if (_inner_error_->domain == DRTDB_DATABASE_ERROR) {
			g_propagate_error (error, _inner_error_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


GFile*
drtdb_database_get_db_file (DrtdbDatabase* self)
{
	GFile* result;
	GFile* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_db_file;
	result = _tmp0_;
	return result;
}


static void
drtdb_database_set_db_file (DrtdbDatabase* self,
                            GFile* value)
{
	g_return_if_fail (self != NULL);
	if (drtdb_database_get_db_file (self) != value) {
		GFile* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_db_file);
		self->priv->_db_file = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, drtdb_database_properties[DRTDB_DATABASE_DB_FILE_PROPERTY]);
	}
}


DrtdbOrmManager*
drtdb_database_get_orm (DrtdbDatabase* self)
{
	DrtdbOrmManager* result;
	DrtdbOrmManager* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_orm;
	result = _tmp0_;
	return result;
}


static void
drtdb_database_set_orm (DrtdbDatabase* self,
                        DrtdbOrmManager* value)
{
	g_return_if_fail (self != NULL);
	if (drtdb_database_get_orm (self) != value) {
		DrtdbOrmManager* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_orm);
		self->priv->_orm = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, drtdb_database_properties[DRTDB_DATABASE_ORM_PROPERTY]);
	}
}


gboolean
drtdb_database_get_opened (DrtdbDatabase* self)
{
	gboolean result;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	{
		gboolean _tmp0_;
		gboolean _tmp4_ = FALSE;
		_tmp0_ = self->priv->_opened;
		g_rec_mutex_lock (&self->priv->__lock__opened);
		{
			gboolean _tmp1_;
			_tmp1_ = self->priv->_opened;
			result = _tmp1_;
			{
				gboolean _tmp2_;
				_tmp2_ = self->priv->_opened;
				g_rec_mutex_unlock (&self->priv->__lock__opened);
			}
			return result;
		}
		__finally1:
		{
			gboolean _tmp3_;
			_tmp3_ = self->priv->_opened;
			g_rec_mutex_unlock (&self->priv->__lock__opened);
		}
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return _tmp4_;
	}
}


static void
drtdb_database_set_opened (DrtdbDatabase* self,
                           gboolean value)
{
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	{
		gboolean _tmp0_;
		_tmp0_ = self->priv->_opened;
		g_rec_mutex_lock (&self->priv->__lock__opened);
		{
			self->priv->_opened = value;
		}
		__finally2:
		{
			gboolean _tmp1_;
			_tmp1_ = self->priv->_opened;
			g_rec_mutex_unlock (&self->priv->__lock__opened);
		}
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	g_object_notify_by_pspec ((GObject *) self, drtdb_database_properties[DRTDB_DATABASE_OPENED_PROPERTY]);
}


static void
drtdb_database_class_init (DrtdbDatabaseClass * klass)
{
	drtdb_database_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (DrtdbDatabasePrivate));
	((DrtdbDatabaseClass *) klass)->open = (void (*) (DrtdbDatabase *, GCancellable*, GError**)) drtdb_database_real_open;
	((DrtdbDatabaseClass *) klass)->close = (void (*) (DrtdbDatabase *, GCancellable*, GError**)) drtdb_database_real_close;
	G_OBJECT_CLASS (klass)->get_property = _vala_drtdb_database_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_drtdb_database_set_property;
	G_OBJECT_CLASS (klass)->finalize = drtdb_database_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), DRTDB_DATABASE_DB_FILE_PROPERTY, drtdb_database_properties[DRTDB_DATABASE_DB_FILE_PROPERTY] = g_param_spec_object ("db-file", "db-file", "db-file", g_file_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DRTDB_DATABASE_ORM_PROPERTY, drtdb_database_properties[DRTDB_DATABASE_ORM_PROPERTY] = g_param_spec_object ("orm", "orm", "orm", DRTDB_TYPE_ORM_MANAGER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DRTDB_DATABASE_OPENED_PROPERTY, drtdb_database_properties[DRTDB_DATABASE_OPENED_PROPERTY] = g_param_spec_boolean ("opened", "opened", "opened", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
}


static void
drtdb_database_drtdb_queryable_interface_init (DrtdbQueryableIface * iface)
{
	drtdb_database_drtdb_queryable_parent_iface = g_type_interface_peek_parent (iface);
	iface->exec = (void (*) (DrtdbQueryable *, const gchar*, GCancellable*, GError**)) drtdb_database_real_exec;
	iface->query = (DrtdbQuery* (*) (DrtdbQueryable *, const gchar*, GCancellable*, GError**)) drtdb_database_real_query;
	iface->get_objects = (DrtdbObjectQuery* (*) (DrtdbQueryable *, GType, GBoxedCopyFunc, GDestroyNotify, GCancellable*, GError**)) drtdb_database_real_get_objects;
	iface->get_object = (gpointer (*) (DrtdbQueryable *, GType, GBoxedCopyFunc, GDestroyNotify, GValue*, GCancellable*, GError**)) drtdb_database_real_get_object;
	iface->get_last_error_message = (const gchar* (*) (DrtdbQueryable *)) drtdb_database_real_get_last_error_message;
}


static void
drtdb_database_instance_init (DrtdbDatabase * self)
{
	self->priv = DRTDB_DATABASE_GET_PRIVATE (self);
	g_rec_mutex_init (&self->priv->__lock__opened);
	self->priv->_opened = FALSE;
	self->priv->master_connection = NULL;
}


static void
drtdb_database_finalize (GObject * obj)
{
	DrtdbDatabase * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DRTDB_TYPE_DATABASE, DrtdbDatabase);
	_g_object_unref0 (self->priv->_db_file);
	_g_object_unref0 (self->priv->_orm);
	g_rec_mutex_clear (&self->priv->__lock__opened);
	_g_object_unref0 (self->priv->master_connection);
	G_OBJECT_CLASS (drtdb_database_parent_class)->finalize (obj);
}


/**
 * SQLite database object
 */
GType
drtdb_database_get_type (void)
{
	static volatile gsize drtdb_database_type_id__volatile = 0;
	if (g_once_init_enter (&drtdb_database_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DrtdbDatabaseClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) drtdb_database_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DrtdbDatabase), 0, (GInstanceInitFunc) drtdb_database_instance_init, NULL };
		static const GInterfaceInfo drtdb_queryable_info = { (GInterfaceInitFunc) drtdb_database_drtdb_queryable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType drtdb_database_type_id;
		drtdb_database_type_id = g_type_register_static (G_TYPE_OBJECT, "DrtdbDatabase", &g_define_type_info, 0);
		g_type_add_interface_static (drtdb_database_type_id, DRTDB_TYPE_QUERYABLE, &drtdb_queryable_info);
		g_once_init_leave (&drtdb_database_type_id__volatile, drtdb_database_type_id);
	}
	return drtdb_database_type_id__volatile;
}


static void
_vala_drtdb_database_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec)
{
	DrtdbDatabase * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DRTDB_TYPE_DATABASE, DrtdbDatabase);
	switch (property_id) {
		case DRTDB_DATABASE_DB_FILE_PROPERTY:
		g_value_set_object (value, drtdb_database_get_db_file (self));
		break;
		case DRTDB_DATABASE_ORM_PROPERTY:
		g_value_set_object (value, drtdb_database_get_orm (self));
		break;
		case DRTDB_DATABASE_OPENED_PROPERTY:
		g_value_set_boolean (value, drtdb_database_get_opened (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void
_vala_drtdb_database_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec)
{
	DrtdbDatabase * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DRTDB_TYPE_DATABASE, DrtdbDatabase);
	switch (property_id) {
		case DRTDB_DATABASE_DB_FILE_PROPERTY:
		drtdb_database_set_db_file (self, g_value_get_object (value));
		break;
		case DRTDB_DATABASE_ORM_PROPERTY:
		drtdb_database_set_orm (self, g_value_get_object (value));
		break;
		case DRTDB_DATABASE_OPENED_PROPERTY:
		drtdb_database_set_opened (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



