/* EventLoop.c generated by valac 0.40.6, the Vala compiler
 * generated from EventLoop.vala, do not modify */

/*
 * Copyright 2017 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */


#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>

typedef struct _DrtEventLoopResumeLaterData DrtEventLoopResumeLaterData;
#define _g_main_context_unref0(var) ((var == NULL) ? NULL : (var = (g_main_context_unref (var), NULL)))
#define _g_source_unref0(var) ((var == NULL) ? NULL : (var = (g_source_unref (var), NULL)))

struct _DrtEventLoopResumeLaterData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
};



static void drt_event_loop_resume_later_data_free (gpointer _data);
void drt_event_loop_resume_later (GAsyncReadyCallback _callback_,
                                  gpointer _user_data_);
void drt_event_loop_resume_later_finish (GAsyncResult* _res_);
static gboolean drt_event_loop_resume_later_co (DrtEventLoopResumeLaterData* _data_);
guint drt_event_loop_add_idle (GSourceFunc function,
                               void* function_target,
                               GDestroyNotify function_target_destroy_notify,
                               gint priority,
                               GMainContext* context);
static gboolean _drt_event_loop_resume_later_co_gsource_func (gpointer self);
guint drt_event_loop_add_timeout_ms (guint interval_ms,
                                     GSourceFunc function,
                                     void* function_target,
                                     GDestroyNotify function_target_destroy_notify,
                                     gint priority,
                                     GMainContext* context);
guint drt_event_loop_add_timeout_sec (guint interval_s,
                                      GSourceFunc function,
                                      void* function_target,
                                      GDestroyNotify function_target_destroy_notify,
                                      gint priority,
                                      GMainContext* context);


static void
drt_event_loop_resume_later_data_free (gpointer _data)
{
	DrtEventLoopResumeLaterData* _data_;
	_data_ = _data;
	g_slice_free (DrtEventLoopResumeLaterData, _data_);
}


void
drt_event_loop_resume_later (GAsyncReadyCallback _callback_,
                             gpointer _user_data_)
{
	DrtEventLoopResumeLaterData* _data_;
	_data_ = g_slice_new0 (DrtEventLoopResumeLaterData);
	_data_->_async_result = g_task_new (NULL, NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, drt_event_loop_resume_later_data_free);
	drt_event_loop_resume_later_co (_data_);
}


void
drt_event_loop_resume_later_finish (GAsyncResult* _res_)
{
	DrtEventLoopResumeLaterData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}


/**
 * Pause async method and resume it later.
 */
static gboolean
_drt_event_loop_resume_later_co_gsource_func (gpointer self)
{
	gboolean result;
	result = drt_event_loop_resume_later_co (self);
	return result;
}


static gboolean
drt_event_loop_resume_later_co (DrtEventLoopResumeLaterData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	drt_event_loop_add_idle (_drt_event_loop_resume_later_co_gsource_func, _data_, NULL, G_PRIORITY_DEFAULT_IDLE, NULL);
	_data_->_state_ = 1;
	return FALSE;
	_state_1:
	;
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (g_task_get_completed (_data_->_async_result) != TRUE) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}


/**
 * Attach an idle callback to the thread-default {@link GLib.MainContext}.
 * 
 * Similar to {@link GLib.Idle.add} but uses the thread-default {@link GLib.MainContext} instead of the global
 * {@link GLib.MainContext} if context is not specified.
 * 
 * @param function    The idle callback function.
 * @param priority    The priority of the callback.
 * @param context        The context to use instead of the thread-default one.
 * @return Id of the corresponding event source.
 */
static gpointer
_g_main_context_ref0 (gpointer self)
{
	return self ? g_main_context_ref (self) : NULL;
}


guint
drt_event_loop_add_idle (GSourceFunc function,
                         void* function_target,
                         GDestroyNotify function_target_destroy_notify,
                         gint priority,
                         GMainContext* context)
{
	guint result = 0U;
	GSource* source = NULL;
	GSource* _tmp0_;
	GSource* _tmp1_;
	GSource* _tmp2_;
	GSourceFunc _tmp3_;
	void* _tmp3__target;
	GDestroyNotify _tmp3__target_destroy_notify;
	GMainContext* _tmp4_ = NULL;
	GMainContext* _tmp5_;
	GSource* _tmp7_;
	_tmp0_ = g_idle_source_new ();
	source = _tmp0_;
	_tmp1_ = source;
	g_source_set_priority (_tmp1_, priority);
	_tmp2_ = source;
	_tmp3_ = function;
	_tmp3__target = function_target;
	_tmp3__target_destroy_notify = function_target_destroy_notify;
	function = NULL;
	function_target = NULL;
	function_target_destroy_notify = NULL;
	g_source_set_callback (_tmp2_, _tmp3_, _tmp3__target, _tmp3__target_destroy_notify);
	_tmp5_ = _g_main_context_ref0 (context);
	_tmp4_ = _tmp5_;
	if (_tmp4_ == NULL) {
		GMainContext* _tmp6_;
		_tmp6_ = g_main_context_ref_thread_default ();
		_g_main_context_unref0 (_tmp4_);
		_tmp4_ = _tmp6_;
	}
	_tmp7_ = source;
	result = g_source_attach (_tmp7_, _tmp4_);
	_g_main_context_unref0 (_tmp4_);
	_g_source_unref0 (source);
	(function_target_destroy_notify == NULL) ? NULL : (function_target_destroy_notify (function_target), NULL);
	function = NULL;
	function_target = NULL;
	function_target_destroy_notify = NULL;
	return result;
}


/**
 * Attach a timeout callback to the thread-default {@link GLib.MainContext}.
 * 
 * Similar to {@link GLib.Timeout.add} but uses the thread-default {@link GLib.MainContext} instead of the global
 * {@link GLib.MainContext} if context is not specified.
 * 
 * @param interval_ms    The number of miliseconds to wait before the callback is called.
 * @param function       The callback function.
 * @param priority       The priority of the callback.
 * @param context        The context to use instead of the thread-default one.
 * @return Id of the corresponding event source.
 */
guint
drt_event_loop_add_timeout_ms (guint interval_ms,
                               GSourceFunc function,
                               void* function_target,
                               GDestroyNotify function_target_destroy_notify,
                               gint priority,
                               GMainContext* context)
{
	guint result = 0U;
	GSource* source = NULL;
	GSource* _tmp0_;
	GSource* _tmp1_;
	GSource* _tmp2_;
	GSourceFunc _tmp3_;
	void* _tmp3__target;
	GDestroyNotify _tmp3__target_destroy_notify;
	GMainContext* _tmp4_ = NULL;
	GMainContext* _tmp5_;
	GSource* _tmp7_;
	_tmp0_ = g_timeout_source_new (interval_ms);
	source = _tmp0_;
	_tmp1_ = source;
	g_source_set_priority (_tmp1_, priority);
	_tmp2_ = source;
	_tmp3_ = function;
	_tmp3__target = function_target;
	_tmp3__target_destroy_notify = function_target_destroy_notify;
	function = NULL;
	function_target = NULL;
	function_target_destroy_notify = NULL;
	g_source_set_callback (_tmp2_, _tmp3_, _tmp3__target, _tmp3__target_destroy_notify);
	_tmp5_ = _g_main_context_ref0 (context);
	_tmp4_ = _tmp5_;
	if (_tmp4_ == NULL) {
		GMainContext* _tmp6_;
		_tmp6_ = g_main_context_ref_thread_default ();
		_g_main_context_unref0 (_tmp4_);
		_tmp4_ = _tmp6_;
	}
	_tmp7_ = source;
	result = g_source_attach (_tmp7_, _tmp4_);
	_g_main_context_unref0 (_tmp4_);
	_g_source_unref0 (source);
	(function_target_destroy_notify == NULL) ? NULL : (function_target_destroy_notify (function_target), NULL);
	function = NULL;
	function_target = NULL;
	function_target_destroy_notify = NULL;
	return result;
}


/**
 * Attach a timeout callback to the thread-default {@link GLib.MainContext}.
 * 
 * Similar to {@link GLib.Timeout.add_seconds} but uses the thread-default {@link GLib.MainContext} instead
 * of the global {@link GLib.MainContext} if context is not specified.
 * 
 * @param interval_s    The number of seconds to wait before the callback is called.
 * @param function      The callback function.
 * @param priority      The priority of the callback.
 * @param context        The context to use instead of the thread-default one.
 * @return Id of the corresponding event source.
 */
guint
drt_event_loop_add_timeout_sec (guint interval_s,
                                GSourceFunc function,
                                void* function_target,
                                GDestroyNotify function_target_destroy_notify,
                                gint priority,
                                GMainContext* context)
{
	guint result = 0U;
	GSourceFunc _tmp0_;
	void* _tmp0__target;
	GDestroyNotify _tmp0__target_destroy_notify;
	_tmp0_ = function;
	_tmp0__target = function_target;
	_tmp0__target_destroy_notify = function_target_destroy_notify;
	function = NULL;
	function_target = NULL;
	function_target_destroy_notify = NULL;
	result = drt_event_loop_add_timeout_ms (interval_s * 1000, _tmp0_, _tmp0__target, _tmp0__target_destroy_notify, priority, context);
	(function_target_destroy_notify == NULL) ? NULL : (function_target_destroy_notify (function_target), NULL);
	function = NULL;
	function_target = NULL;
	function_target_destroy_notify = NULL;
	return result;
}



