/* Logger.c generated by valac 0.40.6, the Vala compiler
 * generated from Logger.vala, do not modify */

/*
 * Copyright 2011-2014 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <unistd.h>
#include <stdarg.h>
#include <gobject/gvaluecollector.h>


#define DRT_TYPE_LOGGER (drt_logger_get_type ())
#define DRT_LOGGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DRT_TYPE_LOGGER, DrtLogger))
#define DRT_LOGGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DRT_TYPE_LOGGER, DrtLoggerClass))
#define DRT_IS_LOGGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DRT_TYPE_LOGGER))
#define DRT_IS_LOGGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DRT_TYPE_LOGGER))
#define DRT_LOGGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DRT_TYPE_LOGGER, DrtLoggerClass))

typedef struct _DrtLogger DrtLogger;
typedef struct _DrtLoggerClass DrtLoggerClass;
typedef struct _DrtLoggerPrivate DrtLoggerPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_pattern_spec_free0(var) ((var == NULL) ? NULL : (var = (g_pattern_spec_free (var), NULL)))
typedef struct _DrtParamSpecLogger DrtParamSpecLogger;

struct _DrtLogger {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DrtLoggerPrivate * priv;
};

struct _DrtLoggerClass {
	GTypeClass parent_class;
	void (*finalize) (DrtLogger *self);
};

struct _DrtParamSpecLogger {
	GParamSpec parent_instance;
};


static gpointer drt_logger_parent_class = NULL;
static GLogLevelFlags drt_logger_display_level;
static GLogLevelFlags drt_logger_display_level = 0;
static FILE* drt_logger_output;
static GRecMutex __lock_drt_logger_drt_logger_output = {0};
static FILE* drt_logger_output = NULL;
static gboolean drt_logger_colorful;
static gboolean drt_logger_colorful = FALSE;
static gchar* drt_logger_hint;
static gchar* drt_logger_hint = NULL;
static GDateTime* drt_logger_time_ref;
static GRecMutex __lock_drt_logger_drt_logger_time_ref = {0};
static GDateTime* drt_logger_time_ref = NULL;
static GPatternSpec* drt_logger_fatal_string;
static GPatternSpec* drt_logger_fatal_string = NULL;

#define G_LOG_DOMAIN "DioriteGlib"
gpointer drt_logger_ref (gpointer instance);
void drt_logger_unref (gpointer instance);
GParamSpec* drt_param_spec_logger (const gchar* name,
                                   const gchar* nick,
                                   const gchar* blurb,
                                   GType object_type,
                                   GParamFlags flags);
void drt_value_set_logger (GValue* value,
                           gpointer v_object);
void drt_value_take_logger (GValue* value,
                            gpointer v_object);
gpointer drt_value_get_logger (const GValue* value);
GType drt_logger_get_type (void) G_GNUC_CONST;
#define DRT_LOGGER_COLOR_FOREGROUND 30
#define DRT_LOGGER_COLOR_BACKGROUND 40
#define DRT_LOGGER_COLOR_BLACK 0
#define DRT_LOGGER_COLOR_RED 1
#define DRT_LOGGER_COLOR_GREEN 2
#define DRT_LOGGER_COLOR_YELLOW 3
#define DRT_LOGGER_COLOR_BLUE 4
#define DRT_LOGGER_COLOR_MAGENTA 5
#define DRT_LOGGER_COLOR_CYAN 6
#define DRT_LOGGER_COLOR_WHITE 7
void drt_logger_init_stderr (GLogLevelFlags display_level,
                             gboolean time,
                             const gchar* hint);
void drt_logger_init (FILE* output,
                      GLogLevelFlags display_level,
                      gboolean time,
                      const gchar* hint);
gboolean drt_logger_colors_supported (void);
static void drt_logger_log_handler (const gchar* domain,
                             GLogLevelFlags level,
                             const gchar* message);
static void _drt_logger_log_handler_glog_func (const gchar* log_domain,
                                        GLogLevelFlags log_levels,
                                        const gchar* message,
                                        gpointer self);
void drt_logger_printf (const gchar* format,
                        ...) G_GNUC_PRINTF(1,2);
void drt_logger_puts (const gchar* line);
void drt_logger_logf (const gchar* format,
                      ...) G_GNUC_PRINTF(1,2);
void drt_logger_log (const gchar* line);
static void drt_logger_print (const gchar* domain,
                       GLogLevelFlags level,
                       const gchar* message);
DrtLogger* drt_logger_new (void);
DrtLogger* drt_logger_construct (GType object_type);
static void drt_logger_finalize (DrtLogger * obj);


void
drt_logger_init_stderr (GLogLevelFlags display_level,
                        gboolean time,
                        const gchar* hint)
{
	FILE* _tmp0_;
	_tmp0_ = stderr;
	drt_logger_init (_tmp0_, display_level, time, hint);
}


/**
 * Initializes new logger for GLib
 * 
 * @param output           output to write logger messages to (e. g. sys.stderr)
 * @param display_level    lowest log level to log
 */
static gpointer
_g_date_time_ref0 (gpointer self)
{
	return self ? g_date_time_ref (self) : NULL;
}


static gchar
string_get (const gchar* self,
            glong index)
{
	gchar result = '\0';
	gchar _tmp0_;
	g_return_val_if_fail (self != NULL, '\0');
	_tmp0_ = ((gchar*) self)[index];
	result = _tmp0_;
	return result;
}


static void
_drt_logger_log_handler_glog_func (const gchar* log_domain,
                                   GLogLevelFlags log_levels,
                                   const gchar* message,
                                   gpointer self)
{
	drt_logger_log_handler (log_domain, log_levels, message);
}


void
drt_logger_init (FILE* output,
                 GLogLevelFlags display_level,
                 gboolean time,
                 const gchar* hint)
{
	gchar* _tmp0_ = NULL;
	gchar* _tmp2_;
	gchar* use_colors = NULL;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	GDateTime* _tmp9_ = NULL;
	GDateTime* _tmp11_;
	gchar* fatal_string = NULL;
	const gchar* _tmp12_;
	gchar* _tmp13_;
	gboolean _tmp14_ = FALSE;
	const gchar* _tmp15_;
	g_return_if_fail (output != NULL);
	drt_logger_output = output;
	drt_logger_display_level = display_level;
	if (hint != NULL) {
		gchar* _tmp1_;
		_tmp1_ = g_strconcat (hint, ": ", NULL);
		_g_free0 (_tmp0_);
		_tmp0_ = _tmp1_;
	} else {
		_g_free0 (_tmp0_);
		_tmp0_ = NULL;
	}
	_tmp2_ = g_strdup (_tmp0_);
	_g_free0 (drt_logger_hint);
	drt_logger_hint = _tmp2_;
	_tmp3_ = g_getenv ("DIORITE_LOGGER_USE_COLORS");
	_tmp4_ = g_strdup (_tmp3_);
	use_colors = _tmp4_;
	_tmp5_ = use_colors;
	if (g_strcmp0 (_tmp5_, "yes") == 0) {
		drt_logger_colorful = TRUE;
	} else {
		const gchar* _tmp6_;
		_tmp6_ = use_colors;
		if (g_strcmp0 (_tmp6_, "no") == 0) {
			drt_logger_colorful = FALSE;
		} else {
			const gchar* _tmp7_ = NULL;
			gboolean _tmp8_;
			drt_logger_colorful = drt_logger_colors_supported ();
			_tmp8_ = drt_logger_colorful;
			if (_tmp8_) {
				_tmp7_ = "yes";
			} else {
				_tmp7_ = "no";
			}
			g_setenv ("DIORITE_LOGGER_USE_COLORS", _tmp7_, FALSE);
		}
	}
	if (time) {
		GDateTime* _tmp10_;
		_tmp10_ = g_date_time_new_now_local ();
		_g_date_time_unref0 (_tmp9_);
		_tmp9_ = _tmp10_;
	} else {
		_g_date_time_unref0 (_tmp9_);
		_tmp9_ = NULL;
	}
	_tmp11_ = _g_date_time_ref0 (_tmp9_);
	_g_date_time_unref0 (drt_logger_time_ref);
	drt_logger_time_ref = _tmp11_;
	_tmp12_ = g_getenv ("DIORITE_LOGGER_FATAL_STRING");
	_tmp13_ = g_strdup (_tmp12_);
	fatal_string = _tmp13_;
	_tmp15_ = fatal_string;
	if (_tmp15_ != NULL) {
		const gchar* _tmp16_;
		_tmp16_ = fatal_string;
		_tmp14_ = string_get (_tmp16_, (glong) 0) != '\0';
	} else {
		_tmp14_ = FALSE;
	}
	if (_tmp14_) {
		const gchar* _tmp17_;
		GPatternSpec* _tmp18_;
		_tmp17_ = fatal_string;
		_tmp18_ = g_pattern_spec_new (_tmp17_);
		_g_pattern_spec_free0 (drt_logger_fatal_string);
		drt_logger_fatal_string = _tmp18_;
	}
	g_log_set_default_handler (_drt_logger_log_handler_glog_func, NULL);
	_g_free0 (fatal_string);
	_g_date_time_unref0 (_tmp9_);
	_g_free0 (use_colors);
	_g_free0 (_tmp0_);
}


gboolean
drt_logger_colors_supported (void)
{
	gboolean result = FALSE;
	FILE* _tmp0_;
	_tmp0_ = drt_logger_output;
	result = isatty (fileno (_tmp0_));
	return result;
}


/**
 * Prints message to log without any hint
 * 
 * @param format    message format
 */
void
drt_logger_printf (const gchar* format,
                   ...)
{
	GError * _inner_error_ = NULL;
	g_return_if_fail (format != NULL);
	{
		FILE* _tmp0_;
		_tmp0_ = drt_logger_output;
		g_rec_mutex_lock (&__lock_drt_logger_drt_logger_output);
		{
			FILE* _tmp1_;
			va_list _tmp2_ = {0};
			FILE* _tmp3_;
			_tmp1_ = drt_logger_output;
			va_start (_tmp2_, format);
			vfprintf (_tmp1_, format, _tmp2_);
			va_end (_tmp2_);
			_tmp3_ = drt_logger_output;
			fflush (_tmp3_);
		}
		__finally42:
		{
			FILE* _tmp4_;
			_tmp4_ = drt_logger_output;
			g_rec_mutex_unlock (&__lock_drt_logger_drt_logger_output);
		}
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


/**
 * Prints line to log without any hint
 * 
 * @param line    line to log
 */
void
drt_logger_puts (const gchar* line)
{
	GError * _inner_error_ = NULL;
	g_return_if_fail (line != NULL);
	{
		FILE* _tmp0_;
		_tmp0_ = drt_logger_output;
		g_rec_mutex_lock (&__lock_drt_logger_drt_logger_output);
		{
			FILE* _tmp1_;
			FILE* _tmp2_;
			_tmp1_ = drt_logger_output;
			fputs (line, _tmp1_);
			_tmp2_ = drt_logger_output;
			fflush (_tmp2_);
		}
		__finally43:
		{
			FILE* _tmp3_;
			_tmp3_ = drt_logger_output;
			g_rec_mutex_unlock (&__lock_drt_logger_drt_logger_output);
		}
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


/**
 * Prints message to log with hint if specified
 * 
 * @param format    message format
 */
void
drt_logger_logf (const gchar* format,
                 ...)
{
	GError * _inner_error_ = NULL;
	g_return_if_fail (format != NULL);
	{
		FILE* _tmp0_;
		_tmp0_ = drt_logger_output;
		g_rec_mutex_lock (&__lock_drt_logger_drt_logger_output);
		{
			const gchar* _tmp1_;
			FILE* _tmp5_;
			va_list _tmp6_ = {0};
			FILE* _tmp7_;
			_tmp1_ = drt_logger_hint;
			if (_tmp1_ != NULL) {
				FILE* _tmp2_;
				const gchar* _tmp3_;
				FILE* _tmp4_;
				_tmp2_ = drt_logger_output;
				_tmp3_ = drt_logger_hint;
				fputs (_tmp3_, _tmp2_);
				_tmp4_ = drt_logger_output;
				fputc (' ', _tmp4_);
			}
			_tmp5_ = drt_logger_output;
			va_start (_tmp6_, format);
			vfprintf (_tmp5_, format, _tmp6_);
			va_end (_tmp6_);
			_tmp7_ = drt_logger_output;
			fflush (_tmp7_);
		}
		__finally44:
		{
			FILE* _tmp8_;
			_tmp8_ = drt_logger_output;
			g_rec_mutex_unlock (&__lock_drt_logger_drt_logger_output);
		}
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


/**
 * Prints line to log with hint if specified
 * 
 * @param line    line to log
 */
void
drt_logger_log (const gchar* line)
{
	GError * _inner_error_ = NULL;
	g_return_if_fail (line != NULL);
	{
		FILE* _tmp0_;
		_tmp0_ = drt_logger_output;
		g_rec_mutex_lock (&__lock_drt_logger_drt_logger_output);
		{
			const gchar* _tmp1_;
			FILE* _tmp5_;
			FILE* _tmp6_;
			_tmp1_ = drt_logger_hint;
			if (_tmp1_ != NULL) {
				FILE* _tmp2_;
				const gchar* _tmp3_;
				FILE* _tmp4_;
				_tmp2_ = drt_logger_output;
				_tmp3_ = drt_logger_hint;
				fputs (_tmp3_, _tmp2_);
				_tmp4_ = drt_logger_output;
				fputc (' ', _tmp4_);
			}
			_tmp5_ = drt_logger_output;
			fputs (line, _tmp5_);
			_tmp6_ = drt_logger_output;
			fflush (_tmp6_);
		}
		__finally45:
		{
			FILE* _tmp7_;
			_tmp7_ = drt_logger_output;
			g_rec_mutex_unlock (&__lock_drt_logger_drt_logger_output);
		}
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


static void
drt_logger_log_handler (const gchar* domain,
                        GLogLevelFlags level,
                        const gchar* message)
{
	gboolean _tmp0_ = FALSE;
	GPatternSpec* _tmp1_;
	gboolean is_fatal_string = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_;
	const gchar* _tmp6_ = NULL;
	gboolean _tmp9_;
	g_return_if_fail (message != NULL);
	_tmp1_ = drt_logger_fatal_string;
	if (_tmp1_ != NULL) {
		GPatternSpec* _tmp2_;
		_tmp2_ = drt_logger_fatal_string;
		_tmp0_ = g_pattern_match_string (_tmp2_, message);
	} else {
		_tmp0_ = FALSE;
	}
	is_fatal_string = _tmp0_;
	_tmp4_ = is_fatal_string;
	if (!_tmp4_) {
		GLogLevelFlags _tmp5_;
		_tmp5_ = drt_logger_display_level;
		_tmp3_ = level > _tmp5_;
	} else {
		_tmp3_ = FALSE;
	}
	if (_tmp3_) {
		return;
	}
	_tmp6_ = domain;
	if (_tmp6_ == NULL) {
		_tmp6_ = "<unknown>";
	}
	drt_logger_print (_tmp6_, level, message);
	switch ((gint) level) {
		case G_LOG_LEVEL_ERROR:
		case 6:
		{
			const gchar* _tmp7_ = NULL;
			_tmp7_ = domain;
			if (_tmp7_ == NULL) {
				_tmp7_ = "<unknown>";
			}
			drt_logger_print (_tmp7_, level, "Application will be terminated.");
			break;
		}
		case G_LOG_LEVEL_CRITICAL:
		{
			const gchar* _tmp8_ = NULL;
			_tmp8_ = domain;
			if (_tmp8_ == NULL) {
				_tmp8_ = "<unknown>";
			}
			drt_logger_print (_tmp8_, level, "Application will not function properly.");
			break;
		}
		default:
		break;
	}
	_tmp9_ = is_fatal_string;
	if (_tmp9_) {
		const gchar* _tmp10_ = NULL;
		_tmp10_ = domain;
		if (_tmp10_ == NULL) {
			_tmp10_ = "<unknown>";
		}
		drt_logger_print (_tmp10_, G_LOG_LEVEL_ERROR, "Will abort because of fatal string match.");
		abort ();
	}
}


static void
drt_logger_print (const gchar* domain,
                  GLogLevelFlags level,
                  const gchar* message)
{
	gchar* name = NULL;
	gchar* _tmp0_;
	gint color = 0;
	const gchar* _tmp10_ = NULL;
	const gchar* _tmp11_;
	gchar* hint = NULL;
	gchar* _tmp12_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (domain != NULL);
	g_return_if_fail (message != NULL);
	_tmp0_ = g_strdup ("");
	name = _tmp0_;
	color = -1;
	switch ((gint) level) {
		case G_LOG_LEVEL_CRITICAL:
		{
			gchar* _tmp1_;
			_tmp1_ = g_strdup ("CRITICAL");
			_g_free0 (name);
			name = _tmp1_;
			color = DRT_LOGGER_COLOR_RED;
			break;
		}
		case G_LOG_LEVEL_ERROR:
		case 6:
		{
			gchar* _tmp2_;
			_tmp2_ = g_strdup ("ERROR");
			_g_free0 (name);
			name = _tmp2_;
			color = DRT_LOGGER_COLOR_RED;
			break;
		}
		case G_LOG_LEVEL_WARNING:
		{
			gchar* _tmp3_;
			_tmp3_ = g_strdup ("WARNING");
			_g_free0 (name);
			name = _tmp3_;
			color = DRT_LOGGER_COLOR_YELLOW;
			break;
		}
		case G_LOG_LEVEL_MESSAGE:
		case G_LOG_LEVEL_INFO:
		{
			gchar* _tmp4_;
			_tmp4_ = g_strdup ("INFO");
			_g_free0 (name);
			name = _tmp4_;
			color = DRT_LOGGER_COLOR_GREEN;
			break;
		}
		case G_LOG_LEVEL_DEBUG:
		{
			gchar* _tmp5_;
			_tmp5_ = g_strdup ("DEBUG");
			_g_free0 (name);
			name = _tmp5_;
			color = DRT_LOGGER_COLOR_BLUE;
			break;
		}
		case G_LOG_LEVEL_MASK:
		{
			gchar* _tmp6_;
			_tmp6_ = g_strdup ("MASK");
			_g_free0 (name);
			name = _tmp6_;
			break;
		}
		case G_LOG_FLAG_RECURSION:
		{
			gchar* _tmp7_;
			_tmp7_ = g_strdup ("Recursion");
			_g_free0 (name);
			name = _tmp7_;
			break;
		}
		case G_LOG_FLAG_FATAL:
		{
			gchar* _tmp8_;
			_tmp8_ = g_strdup ("Fatal");
			_g_free0 (name);
			name = _tmp8_;
			break;
		}
		default:
		{
			gchar* _tmp9_;
			_tmp9_ = g_strdup ("Unknown");
			_g_free0 (name);
			name = _tmp9_;
			break;
		}
	}
	_tmp11_ = drt_logger_hint;
	_tmp10_ = _tmp11_;
	if (_tmp10_ == NULL) {
		_tmp10_ = "";
	}
	_tmp12_ = g_strdup (_tmp10_);
	hint = _tmp12_;
	{
		FILE* _tmp13_;
		_tmp13_ = drt_logger_output;
		g_rec_mutex_lock (&__lock_drt_logger_drt_logger_output);
		{
			GDateTime* _tmp14_;
			gboolean _tmp57_ = FALSE;
			gboolean _tmp58_;
			FILE* _tmp67_;
			_tmp14_ = drt_logger_time_ref;
			if (_tmp14_ != NULL) {
				GDateTime* now = NULL;
				GDateTime* _tmp15_;
				GTimeSpan diff = 0LL;
				const gchar* _tmp23_;
				gchar* _tmp24_;
				GTimeSpan hours = 0LL;
				GTimeSpan _tmp25_;
				GTimeSpan _tmp26_;
				GTimeSpan minutes = 0LL;
				GTimeSpan _tmp34_;
				GTimeSpan _tmp35_;
				GTimeSpan seconds = 0LL;
				GTimeSpan _tmp43_;
				GTimeSpan _tmp44_;
				const gchar* _tmp52_;
				GTimeSpan _tmp53_;
				gchar* _tmp54_;
				gchar* _tmp55_;
				gchar* _tmp56_;
				_tmp15_ = g_date_time_new_now_local ();
				now = _tmp15_;
				{
					GDateTime* _tmp16_;
					_tmp16_ = drt_logger_time_ref;
					g_rec_mutex_lock (&__lock_drt_logger_drt_logger_time_ref);
					{
						GDateTime* _tmp17_;
						GDateTime* _tmp18_;
						GDateTime* _tmp19_;
						GDateTime* _tmp20_;
						_tmp17_ = now;
						_tmp18_ = drt_logger_time_ref;
						diff = g_date_time_difference (_tmp17_, _tmp18_);
						_tmp19_ = now;
						_tmp20_ = _g_date_time_ref0 (_tmp19_);
						_g_date_time_unref0 (drt_logger_time_ref);
						drt_logger_time_ref = _tmp20_;
					}
					__finally47:
					{
						GDateTime* _tmp21_;
						_tmp21_ = drt_logger_time_ref;
						g_rec_mutex_unlock (&__lock_drt_logger_drt_logger_time_ref);
					}
					if (G_UNLIKELY (_inner_error_ != NULL)) {
						_g_date_time_unref0 (now);
						_g_date_time_unref0 (now);
						{
							FILE* _tmp22_;
							_tmp22_ = drt_logger_output;
							g_rec_mutex_unlock (&__lock_drt_logger_drt_logger_output);
						}
						_g_free0 (hint);
						_g_free0 (name);
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
						g_clear_error (&_inner_error_);
						return;
					}
				}
				_tmp23_ = name;
				_tmp24_ = g_strconcat (_tmp23_, " Δ", NULL);
				_g_free0 (name);
				name = _tmp24_;
				_tmp25_ = diff;
				hours = _tmp25_ / G_TIME_SPAN_HOUR;
				_tmp26_ = hours;
				if (_tmp26_ > ((GTimeSpan) 0)) {
					GTimeSpan _tmp27_;
					GTimeSpan _tmp28_;
					const gchar* _tmp29_;
					GTimeSpan _tmp30_;
					gchar* _tmp31_;
					gchar* _tmp32_;
					gchar* _tmp33_;
					_tmp27_ = diff;
					_tmp28_ = hours;
					diff = _tmp27_ - (_tmp28_ * G_TIME_SPAN_HOUR);
					_tmp29_ = name;
					_tmp30_ = hours;
					_tmp31_ = g_strdup_printf ("%dh", (gint) _tmp30_);
					_tmp32_ = _tmp31_;
					_tmp33_ = g_strconcat (_tmp29_, _tmp32_, NULL);
					_g_free0 (name);
					name = _tmp33_;
					_g_free0 (_tmp32_);
				}
				_tmp34_ = diff;
				minutes = _tmp34_ / G_TIME_SPAN_MINUTE;
				_tmp35_ = minutes;
				if (_tmp35_ > ((GTimeSpan) 0)) {
					GTimeSpan _tmp36_;
					GTimeSpan _tmp37_;
					const gchar* _tmp38_;
					GTimeSpan _tmp39_;
					gchar* _tmp40_;
					gchar* _tmp41_;
					gchar* _tmp42_;
					_tmp36_ = diff;
					_tmp37_ = minutes;
					diff = _tmp36_ - (_tmp37_ * G_TIME_SPAN_MINUTE);
					_tmp38_ = name;
					_tmp39_ = minutes;
					_tmp40_ = g_strdup_printf ("%02dm", (gint) _tmp39_);
					_tmp41_ = _tmp40_;
					_tmp42_ = g_strconcat (_tmp38_, _tmp41_, NULL);
					_g_free0 (name);
					name = _tmp42_;
					_g_free0 (_tmp41_);
				}
				_tmp43_ = diff;
				seconds = _tmp43_ / G_TIME_SPAN_SECOND;
				_tmp44_ = seconds;
				if (_tmp44_ > ((GTimeSpan) 0)) {
					GTimeSpan _tmp45_;
					GTimeSpan _tmp46_;
					const gchar* _tmp47_;
					GTimeSpan _tmp48_;
					gchar* _tmp49_;
					gchar* _tmp50_;
					gchar* _tmp51_;
					_tmp45_ = diff;
					_tmp46_ = seconds;
					diff = _tmp45_ - (_tmp46_ * G_TIME_SPAN_SECOND);
					_tmp47_ = name;
					_tmp48_ = seconds;
					_tmp49_ = g_strdup_printf ("%02ds", (gint) _tmp48_);
					_tmp50_ = _tmp49_;
					_tmp51_ = g_strconcat (_tmp47_, _tmp50_, NULL);
					_g_free0 (name);
					name = _tmp51_;
					_g_free0 (_tmp50_);
				}
				_tmp52_ = name;
				_tmp53_ = diff;
				_tmp54_ = g_strdup_printf ("%06dus", (gint) _tmp53_);
				_tmp55_ = _tmp54_;
				_tmp56_ = g_strconcat (_tmp52_, _tmp55_, NULL);
				_g_free0 (name);
				name = _tmp56_;
				_g_free0 (_tmp55_);
				_g_date_time_unref0 (now);
			}
			_tmp58_ = drt_logger_colorful;
			if (_tmp58_) {
				gint _tmp59_;
				_tmp59_ = color;
				_tmp57_ = _tmp59_ >= 0;
			} else {
				_tmp57_ = FALSE;
			}
			if (_tmp57_) {
				FILE* _tmp60_;
				const gchar* _tmp61_;
				gint _tmp62_;
				const gchar* _tmp63_;
				_tmp60_ = drt_logger_output;
				_tmp61_ = hint;
				_tmp62_ = color;
				_tmp63_ = name;
				fprintf (_tmp60_, "%s\x1b[%dm[%-8s %5s]\x1b[0m %s\n", _tmp61_, DRT_LOGGER_COLOR_FOREGROUND + _tmp62_, _tmp63_, domain, message);
			} else {
				FILE* _tmp64_;
				const gchar* _tmp65_;
				const gchar* _tmp66_;
				_tmp64_ = drt_logger_output;
				_tmp65_ = hint;
				_tmp66_ = name;
				fprintf (_tmp64_, "%s[%-8s %5s] %s\n", _tmp65_, _tmp66_, domain, message);
			}
			_tmp67_ = drt_logger_output;
			fflush (_tmp67_);
		}
		__finally46:
		{
			FILE* _tmp68_;
			_tmp68_ = drt_logger_output;
			g_rec_mutex_unlock (&__lock_drt_logger_drt_logger_output);
		}
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_free0 (hint);
			_g_free0 (name);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_g_free0 (hint);
	_g_free0 (name);
}


DrtLogger*
drt_logger_construct (GType object_type)
{
	DrtLogger* self = NULL;
	self = (DrtLogger*) g_type_create_instance (object_type);
	return self;
}


DrtLogger*
drt_logger_new (void)
{
	return drt_logger_construct (DRT_TYPE_LOGGER);
}


static void
drt_value_logger_init (GValue* value)
{
	value->data[0].v_pointer = NULL;
}


static void
drt_value_logger_free_value (GValue* value)
{
	if (value->data[0].v_pointer) {
		drt_logger_unref (value->data[0].v_pointer);
	}
}


static void
drt_value_logger_copy_value (const GValue* src_value,
                             GValue* dest_value)
{
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = drt_logger_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer
drt_value_logger_peek_pointer (const GValue* value)
{
	return value->data[0].v_pointer;
}


static gchar*
drt_value_logger_collect_value (GValue* value,
                                guint n_collect_values,
                                GTypeCValue* collect_values,
                                guint collect_flags)
{
	if (collect_values[0].v_pointer) {
		DrtLogger * object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = drt_logger_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar*
drt_value_logger_lcopy_value (const GValue* value,
                              guint n_collect_values,
                              GTypeCValue* collect_values,
                              guint collect_flags)
{
	DrtLogger ** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = drt_logger_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec*
drt_param_spec_logger (const gchar* name,
                       const gchar* nick,
                       const gchar* blurb,
                       GType object_type,
                       GParamFlags flags)
{
	DrtParamSpecLogger* spec;
	g_return_val_if_fail (g_type_is_a (object_type, DRT_TYPE_LOGGER), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer
drt_value_get_logger (const GValue* value)
{
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DRT_TYPE_LOGGER), NULL);
	return value->data[0].v_pointer;
}


void
drt_value_set_logger (GValue* value,
                      gpointer v_object)
{
	DrtLogger * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DRT_TYPE_LOGGER));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, DRT_TYPE_LOGGER));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		drt_logger_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		drt_logger_unref (old);
	}
}


void
drt_value_take_logger (GValue* value,
                       gpointer v_object)
{
	DrtLogger * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DRT_TYPE_LOGGER));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, DRT_TYPE_LOGGER));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		drt_logger_unref (old);
	}
}


static void
drt_logger_class_init (DrtLoggerClass * klass)
{
	drt_logger_parent_class = g_type_class_peek_parent (klass);
	((DrtLoggerClass *) klass)->finalize = drt_logger_finalize;
	g_rec_mutex_init (&__lock_drt_logger_drt_logger_output);
	g_rec_mutex_init (&__lock_drt_logger_drt_logger_time_ref);
}


static void
drt_logger_instance_init (DrtLogger * self)
{
	self->ref_count = 1;
}


static void
drt_logger_finalize (DrtLogger * obj)
{
	DrtLogger * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DRT_TYPE_LOGGER, DrtLogger);
	g_signal_handlers_destroy (self);
}


/**
 * Logger for GLib
 */
GType
drt_logger_get_type (void)
{
	static volatile gsize drt_logger_type_id__volatile = 0;
	if (g_once_init_enter (&drt_logger_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { drt_value_logger_init, drt_value_logger_free_value, drt_value_logger_copy_value, drt_value_logger_peek_pointer, "p", drt_value_logger_collect_value, "p", drt_value_logger_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (DrtLoggerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) drt_logger_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DrtLogger), 0, (GInstanceInitFunc) drt_logger_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType drt_logger_type_id;
		drt_logger_type_id = g_type_register_fundamental (g_type_fundamental_next (), "DrtLogger", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&drt_logger_type_id__volatile, drt_logger_type_id);
	}
	return drt_logger_type_id__volatile;
}


gpointer
drt_logger_ref (gpointer instance)
{
	DrtLogger * self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void
drt_logger_unref (gpointer instance)
{
	DrtLogger * self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		DRT_LOGGER_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}



