/* Random.c generated by valac 0.40.6, the Vala compiler
 * generated from Random.vala, do not modify */

/*
 * Copyright 2016 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>

#define _g_free0(var) (var = (g_free (var), NULL))



gchar* drt_random_hex (gint n_bits);
void drt_uint32_to_bytes (guint8** buffer,
                          int* buffer_length1,
                          guint32 data,
                          guint offset);
void drt_bin_to_hex (guint8* array,
                     int array_length1,
                     gchar* * _result_,
                     gchar separator);
void drt_random_bin (gint n_bits,
                     guint8** _result_,
                     int* _result__length1);


/**
 * Generate random binary data as a hexadecimal string.
 * 
 * @param n_bits    Number of random bits. Will be rounded up to the nearest byte.
 * @return Random binary data.
 */
static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	glong result = 0L;
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
	end = _tmp0_;
	_tmp1_ = end;
	if (_tmp1_ == NULL) {
		result = maxlen;
		return result;
	} else {
		gchar* _tmp2_;
		_tmp2_ = end;
		result = (glong) (_tmp2_ - str);
		return result;
	}
}


static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	gchar* result = NULL;
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	glong _tmp6_;
	gchar* _tmp7_;
	g_return_val_if_fail (self != NULL, NULL);
	if (offset >= ((glong) 0)) {
		_tmp0_ = len >= ((glong) 0);
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		string_length = string_strnlen ((gchar*) self, offset + len);
	} else {
		gint _tmp1_;
		gint _tmp2_;
		_tmp1_ = strlen (self);
		_tmp2_ = _tmp1_;
		string_length = (glong) _tmp2_;
	}
	if (offset < ((glong) 0)) {
		glong _tmp3_;
		_tmp3_ = string_length;
		offset = _tmp3_ + offset;
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
	} else {
		glong _tmp4_;
		_tmp4_ = string_length;
		g_return_val_if_fail (offset <= _tmp4_, NULL);
	}
	if (len < ((glong) 0)) {
		glong _tmp5_;
		_tmp5_ = string_length;
		len = _tmp5_ - offset;
	}
	_tmp6_ = string_length;
	g_return_val_if_fail ((offset + len) <= _tmp6_, NULL);
	_tmp7_ = g_strndup (((gchar*) self) + offset, (gsize) len);
	result = _tmp7_;
	return result;
}


gchar*
drt_random_hex (gint n_bits)
{
	gchar* result = NULL;
	gint n_bytes = 0;
	gint _tmp0_;
	gint n_32bits = 0;
	gint _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gint size = 0;
	gint _tmp6_;
	guint8* buffer = NULL;
	gint _tmp7_;
	guint8* _tmp8_;
	gint buffer_length1;
	gint _buffer_size_;
	gchar* _result_ = NULL;
	guint8* _tmp14_;
	gint _tmp14__length1;
	gchar* _tmp15_ = NULL;
	gchar* _tmp16_ = NULL;
	gint _tmp17_;
	gint _tmp18_;
	n_bytes = n_bits / 8;
	_tmp0_ = n_bytes;
	if ((_tmp0_ * 8) < n_bits) {
		gint _tmp1_;
		_tmp1_ = n_bytes;
		n_bytes = _tmp1_ + 1;
	}
	_tmp2_ = n_bytes;
	n_32bits = _tmp2_ / 4;
	_tmp3_ = n_32bits;
	_tmp4_ = n_bytes;
	if ((_tmp3_ * 4) < _tmp4_) {
		gint _tmp5_;
		_tmp5_ = n_32bits;
		n_32bits = _tmp5_ + 1;
	}
	_tmp6_ = n_32bits;
	size = _tmp6_ * 4;
	_tmp7_ = size;
	_tmp8_ = g_new0 (guint8, _tmp7_);
	buffer = _tmp8_;
	buffer_length1 = _tmp7_;
	_buffer_size_ = buffer_length1;
	{
		guint offset = 0U;
		offset = (guint) 0;
		{
			gboolean _tmp9_ = FALSE;
			_tmp9_ = TRUE;
			while (TRUE) {
				guint _tmp11_;
				gint _tmp12_;
				guint _tmp13_;
				if (!_tmp9_) {
					guint _tmp10_;
					_tmp10_ = offset;
					offset = _tmp10_ + 4;
				}
				_tmp9_ = FALSE;
				_tmp11_ = offset;
				_tmp12_ = size;
				if (!((_tmp11_ + 4) <= ((guint) _tmp12_))) {
					break;
				}
				_tmp13_ = offset;
				drt_uint32_to_bytes (&buffer, &buffer_length1, g_random_int (), _tmp13_);
			}
		}
	}
	_tmp14_ = buffer;
	_tmp14__length1 = buffer_length1;
	drt_bin_to_hex (_tmp14_, _tmp14__length1, &_tmp15_, '\0');
	_g_free0 (_result_);
	_result_ = _tmp15_;
	_tmp17_ = size;
	_tmp18_ = n_bytes;
	if (_tmp17_ == _tmp18_) {
		const gchar* _tmp19_;
		gchar* _tmp20_;
		_tmp19_ = _result_;
		_tmp20_ = g_strdup (_tmp19_);
		_g_free0 (_tmp16_);
		_tmp16_ = _tmp20_;
	} else {
		const gchar* _tmp21_;
		gint _tmp22_;
		gchar* _tmp23_;
		_tmp21_ = _result_;
		_tmp22_ = n_bytes;
		_tmp23_ = string_substring (_tmp21_, (glong) 0, (glong) (_tmp22_ * 2));
		_g_free0 (_tmp16_);
		_tmp16_ = _tmp23_;
	}
	result = _tmp16_;
	_g_free0 (_result_);
	buffer = (g_free (buffer), NULL);
	return result;
}


/**
 * Generate random binary data as a hexadecimal string.
 * 
 * @param n_bits    Number of random bits. Will be rounded up to the nearest byte.
 * @param result    Random binary data.
 */
void
drt_random_bin (gint n_bits,
                guint8** _result_,
                int* _result__length1)
{
	guint8* _vala_result = NULL;
	int _vala_result_length1 = 0;
	gint n_bytes = 0;
	gint _tmp0_;
	gint n_32bits = 0;
	gint _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gint size = 0;
	gint _tmp6_;
	gint _tmp7_;
	guint8* _tmp8_;
	n_bytes = n_bits / 8;
	_tmp0_ = n_bytes;
	if ((_tmp0_ * 8) < n_bits) {
		gint _tmp1_;
		_tmp1_ = n_bytes;
		n_bytes = _tmp1_ + 1;
	}
	_tmp2_ = n_bytes;
	n_32bits = _tmp2_ / 4;
	_tmp3_ = n_32bits;
	_tmp4_ = n_bytes;
	if ((_tmp3_ * 4) < _tmp4_) {
		gint _tmp5_;
		_tmp5_ = n_32bits;
		n_32bits = _tmp5_ + 1;
	}
	_tmp6_ = n_32bits;
	size = _tmp6_ * 4;
	_tmp7_ = size;
	_tmp8_ = g_new0 (guint8, _tmp7_);
	_vala_result = (g_free (_vala_result), NULL);
	_vala_result = _tmp8_;
	_vala_result_length1 = _tmp7_;
	{
		guint offset = 0U;
		offset = (guint) 0;
		{
			gboolean _tmp9_ = FALSE;
			_tmp9_ = TRUE;
			while (TRUE) {
				guint _tmp11_;
				gint _tmp12_;
				guint _tmp13_;
				if (!_tmp9_) {
					guint _tmp10_;
					_tmp10_ = offset;
					offset = _tmp10_ + 4;
				}
				_tmp9_ = FALSE;
				_tmp11_ = offset;
				_tmp12_ = size;
				if (!((_tmp11_ + 4) <= ((guint) _tmp12_))) {
					break;
				}
				_tmp13_ = offset;
				drt_uint32_to_bytes (&_vala_result, &_vala_result_length1, g_random_int (), _tmp13_);
			}
		}
	}
	if (_result_) {
		*_result_ = _vala_result;
	} else {
		_vala_result = (g_free (_vala_result), NULL);
	}
	if (_result__length1) {
		*_result__length1 = _vala_result_length1;
	}
}



