/* RpcNotification.c generated by valac 0.40.6, the Vala compiler
 * generated from RpcNotification.vala, do not modify */

/*
 * Copyright 2016-2017 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>


#define DRT_TYPE_RPC_CALLABLE (drt_rpc_callable_get_type ())
#define DRT_RPC_CALLABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DRT_TYPE_RPC_CALLABLE, DrtRpcCallable))
#define DRT_RPC_CALLABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DRT_TYPE_RPC_CALLABLE, DrtRpcCallableClass))
#define DRT_IS_RPC_CALLABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DRT_TYPE_RPC_CALLABLE))
#define DRT_IS_RPC_CALLABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DRT_TYPE_RPC_CALLABLE))
#define DRT_RPC_CALLABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DRT_TYPE_RPC_CALLABLE, DrtRpcCallableClass))

typedef struct _DrtRpcCallable DrtRpcCallable;
typedef struct _DrtRpcCallableClass DrtRpcCallableClass;
typedef struct _DrtRpcCallablePrivate DrtRpcCallablePrivate;

#define DRT_TYPE_RPC_CONNECTION (drt_rpc_connection_get_type ())
#define DRT_RPC_CONNECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DRT_TYPE_RPC_CONNECTION, DrtRpcConnection))
#define DRT_RPC_CONNECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DRT_TYPE_RPC_CONNECTION, DrtRpcConnectionClass))
#define DRT_IS_RPC_CONNECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DRT_TYPE_RPC_CONNECTION))
#define DRT_IS_RPC_CONNECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DRT_TYPE_RPC_CONNECTION))
#define DRT_RPC_CONNECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DRT_TYPE_RPC_CONNECTION, DrtRpcConnectionClass))

typedef struct _DrtRpcConnection DrtRpcConnection;
typedef struct _DrtRpcConnectionClass DrtRpcConnectionClass;

#define DRT_TYPE_RPC_NOTIFICATION (drt_rpc_notification_get_type ())
#define DRT_RPC_NOTIFICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DRT_TYPE_RPC_NOTIFICATION, DrtRpcNotification))
#define DRT_RPC_NOTIFICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DRT_TYPE_RPC_NOTIFICATION, DrtRpcNotificationClass))
#define DRT_IS_RPC_NOTIFICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DRT_TYPE_RPC_NOTIFICATION))
#define DRT_IS_RPC_NOTIFICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DRT_TYPE_RPC_NOTIFICATION))
#define DRT_RPC_NOTIFICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DRT_TYPE_RPC_NOTIFICATION, DrtRpcNotificationClass))

typedef struct _DrtRpcNotification DrtRpcNotification;
typedef struct _DrtRpcNotificationClass DrtRpcNotificationClass;
typedef struct _DrtRpcNotificationPrivate DrtRpcNotificationPrivate;
#define __g_slist_free__g_object_unref0_0(var) ((var == NULL) ? NULL : (var = (_g_slist_free__g_object_unref0_ (var), NULL)))

#define DRT_TYPE_RPC_FLAGS (drt_rpc_flags_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _drt_rpc_callable_unref0(var) ((var == NULL) ? NULL : (var = (drt_rpc_callable_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _DrtRpcNotificationEmitData DrtRpcNotificationEmitData;

struct _DrtRpcCallable {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DrtRpcCallablePrivate * priv;
};

struct _DrtRpcCallableClass {
	GTypeClass parent_class;
	void (*finalize) (DrtRpcCallable *self);
	void (*run) (DrtRpcCallable* self, DrtRpcConnection* conn, guint id, GVariant* data, GError** error);
};

struct _DrtRpcNotification {
	DrtRpcCallable parent_instance;
	DrtRpcNotificationPrivate * priv;
};

struct _DrtRpcNotificationClass {
	DrtRpcCallableClass parent_class;
};

struct _DrtRpcNotificationPrivate {
	GSList* subscribers;
};

typedef enum  {
	DRT_RPC_FLAGS_PRIVATE = 1 << 0,
	DRT_RPC_FLAGS_READABLE = 1 << 1,
	DRT_RPC_FLAGS_WRITABLE = 1 << 2,
	DRT_RPC_FLAGS_SUBSCRIBE = 1 << 3
} DrtRpcFlags;

typedef enum  {
	DRT_API_ERROR_UNKNOWN,
	DRT_API_ERROR_INVALID_REQUEST,
	DRT_API_ERROR_INVALID_PARAMS,
	DRT_API_ERROR_PRIVATE_FLAG,
	DRT_API_ERROR_READABLE_FLAG,
	DRT_API_ERROR_WRITABLE_FLAG,
	DRT_API_ERROR_SUBSCRIBE_FLAG,
	DRT_API_ERROR_API_TOKEN_REQUIRED
} DrtApiError;
#define DRT_API_ERROR drt_api_error_quark ()
typedef enum  {
	DRT_RPC_ERROR_UNKNOWN,
	DRT_RPC_ERROR_REMOTE_ERROR,
	DRT_RPC_ERROR_UNSUPPORTED,
	DRT_RPC_ERROR_IOERROR,
	DRT_RPC_ERROR_INVALID_RESPONSE,
	DRT_RPC_ERROR_INVALID_REQUEST,
	DRT_RPC_ERROR_INVALID_ARGUMENTS,
	DRT_RPC_ERROR_NOT_READY
} DrtRpcError;
#define DRT_RPC_ERROR drt_rpc_error_quark ()
struct _DrtRpcNotificationEmitData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	DrtRpcNotification* self;
	gchar* detail;
	GVariant* data;
	gboolean result;
	gboolean _result_;
	GSList* _tmp0_;
	GSList* channel_collection;
	GSList* channel_it;
	DrtRpcConnection* channel;
	DrtRpcConnection* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GVariant* _tmp6_;
	GVariant* _tmp7_;
	GVariant* _tmp8_;
	GVariant* _tmp9_;
	GError* e;
	const gchar* _tmp10_;
	const gchar* _tmp11_;
	GError* _tmp12_;
	const gchar* _tmp13_;
	GError * _inner_error_;
};


static gpointer drt_rpc_notification_parent_class = NULL;

gpointer drt_rpc_callable_ref (gpointer instance);
void drt_rpc_callable_unref (gpointer instance);
GParamSpec* drt_param_spec_rpc_callable (const gchar* name,
                                         const gchar* nick,
                                         const gchar* blurb,
                                         GType object_type,
                                         GParamFlags flags);
void drt_value_set_rpc_callable (GValue* value,
                                 gpointer v_object);
void drt_value_take_rpc_callable (GValue* value,
                                  gpointer v_object);
gpointer drt_value_get_rpc_callable (const GValue* value);
GType drt_rpc_callable_get_type (void) G_GNUC_CONST;
GType drt_rpc_connection_get_type (void) G_GNUC_CONST;
GType drt_rpc_notification_get_type (void) G_GNUC_CONST;
#define DRT_RPC_NOTIFICATION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), DRT_TYPE_RPC_NOTIFICATION, DrtRpcNotificationPrivate))
static void _g_object_unref0_ (gpointer var);
static inline void _g_slist_free__g_object_unref0_ (GSList* self);
GType drt_rpc_flags_get_type (void) G_GNUC_CONST;
DrtRpcNotification* drt_rpc_notification_new (const gchar* path,
                                              DrtRpcFlags flags,
                                              const gchar* description);
DrtRpcNotification* drt_rpc_notification_construct (GType object_type,
                                                    const gchar* path,
                                                    DrtRpcFlags flags,
                                                    const gchar* description);
DrtRpcCallable* drt_rpc_callable_construct (GType object_type);
void drt_rpc_callable_set_path (DrtRpcCallable* self,
                                const gchar* value);
void drt_rpc_callable_set_flags (DrtRpcCallable* self,
                                 DrtRpcFlags value);
void drt_rpc_callable_set_description (DrtRpcCallable* self,
                                       const gchar* value);
void drt_rpc_notification_parse_params (const gchar* path,
                                        GVariant* data,
                                        gboolean* subscribe,
                                        gchar* * detail,
                                        GError** error);
GQuark drt_api_error_quark (void);
GQuark drt_rpc_error_quark (void);
gchar* drt_rpc_get_params_type (GVariant* params,
                                GError** error);
GVariant* drt_unbox_variant (GVariant* value);
gboolean drt_variant_bool (GVariant* variant,
                           gboolean* _result_);
gboolean drt_variant_string (GVariant* variant,
                             gchar* * data);
void drt_rpc_check_type_string (GVariant* data,
                                const gchar* type_string,
                                GError** error);
void drt_rpc_notification_get_detail_and_params (GVariant* data,
                                                 gchar* * detail,
                                                 GVariant* * parameters,
                                                 GError** error);
void drt_rpc_notification_subscribe (DrtRpcNotification* self,
                                     DrtRpcConnection* conn,
                                     gboolean subscribe,
                                     const gchar* detail,
                                     GError** error);
static void drt_rpc_notification_emit_data_free (gpointer _data);
void drt_rpc_notification_emit (DrtRpcNotification* self,
                                const gchar* detail,
                                GVariant* data,
                                GAsyncReadyCallback _callback_,
                                gpointer _user_data_);
gboolean drt_rpc_notification_emit_finish (DrtRpcNotification* self,
                                           GAsyncResult* _res_);
static gboolean drt_rpc_notification_emit_co (DrtRpcNotificationEmitData* _data_);
void drt_rpc_connection_call (DrtRpcConnection* self,
                              const gchar* method,
                              GVariant* parameters,
                              GAsyncReadyCallback _callback_,
                              gpointer _user_data_);
GVariant* drt_rpc_connection_call_finish (DrtRpcConnection* self,
                                          GAsyncResult* _res_,
                                          GError** error);
const gchar* drt_rpc_callable_get_path (DrtRpcCallable* self);
static void drt_rpc_notification_emit_ready (GObject* source_object,
                                      GAsyncResult* _res_,
                                      gpointer _user_data_);
static void drt_rpc_notification_real_run (DrtRpcCallable* base,
                                    DrtRpcConnection* conn,
                                    guint id,
                                    GVariant* data,
                                    GError** error);
void drt_rpc_connection_respond (DrtRpcConnection* self,
                                 guint id,
                                 GVariant* response);
static void drt_rpc_notification_finalize (DrtRpcCallable * obj);


static void
_g_object_unref0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
}


static inline void
_g_slist_free__g_object_unref0_ (GSList* self)
{
	g_slist_free_full (self, (GDestroyNotify) _g_object_unref0_);
}


/**
 * Creates new Rpcnotification handler
 * 
 * @param path           Notification path.
 * @param flags          Notification flags.
 * @param description    Notification description for API index.
 */
DrtRpcNotification*
drt_rpc_notification_construct (GType object_type,
                                const gchar* path,
                                DrtRpcFlags flags,
                                const gchar* description)
{
	DrtRpcNotification* self = NULL;
	g_return_val_if_fail (path != NULL, NULL);
	self = (DrtRpcNotification*) drt_rpc_callable_construct (object_type);
	drt_rpc_callable_set_path ((DrtRpcCallable*) self, path);
	drt_rpc_callable_set_flags ((DrtRpcCallable*) self, flags);
	drt_rpc_callable_set_description ((DrtRpcCallable*) self, description);
	return self;
}


DrtRpcNotification*
drt_rpc_notification_new (const gchar* path,
                          DrtRpcFlags flags,
                          const gchar* description)
{
	return drt_rpc_notification_construct (DRT_TYPE_RPC_NOTIFICATION, path, flags, description);
}


/**
 * Parse raw data of (un)subscribe request.
 * 
 * @param path         Request path.
 * @param data         Raw request data.
 * @param subscribe    Whether to subscribe or unsubscribe.
 * @param detail       Unused, reserved for future.
 * @throws GLib.Error on failure.
 */
static gpointer
_g_variant_ref0 (gpointer self)
{
	return self ? g_variant_ref (self) : NULL;
}


void
drt_rpc_notification_parse_params (const gchar* path,
                                   GVariant* data,
                                   gboolean* subscribe,
                                   gchar* * detail,
                                   GError** error)
{
	gboolean _vala_subscribe = FALSE;
	gchar* _vala_detail = NULL;
	gchar* params_type = NULL;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	GError * _inner_error_ = NULL;
	_vala_subscribe = TRUE;
	_g_free0 (_vala_detail);
	_vala_detail = NULL;
	if (data == NULL) {
		GError* _tmp0_;
		_tmp0_ = g_error_new (DRT_API_ERROR, DRT_API_ERROR_INVALID_PARAMS, "Method '%s' requires 2 parameters but no parameters have been provided" \
".", path);
		_inner_error_ = _tmp0_;
		g_propagate_error (error, _inner_error_);
		return;
	}
	_tmp1_ = drt_rpc_get_params_type (data, &_inner_error_);
	params_type = _tmp1_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		return;
	}
	_tmp2_ = params_type;
	if (g_strcmp0 (_tmp2_, "tuple") == 0) {
		const GVariantType* _tmp3_;
		const GVariantType* _tmp4_;
		gsize n_children = 0UL;
		gboolean _tmp7_ = FALSE;
		gsize _tmp8_;
		GVariant* entry = NULL;
		GVariant* _tmp11_;
		GVariant* _tmp12_;
		GVariant* _tmp13_;
		GVariant* _tmp14_;
		GVariant* _tmp15_;
		gboolean _tmp16_;
		gsize _tmp20_;
		_tmp3_ = g_variant_get_type (data);
		_tmp4_ = G_VARIANT_TYPE_TUPLE;
		if (!g_variant_type_is_subtype_of (_tmp3_, _tmp4_)) {
			const gchar* _tmp5_;
			GError* _tmp6_;
			_tmp5_ = g_variant_get_type_string (data);
			_tmp6_ = g_error_new (DRT_API_ERROR, DRT_API_ERROR_INVALID_PARAMS, "Method '%s' call expected a tuple of parameters, but type of '%s' rece" \
"ived.", path, _tmp5_);
			_inner_error_ = _tmp6_;
			g_propagate_error (error, _inner_error_);
			_g_free0 (params_type);
			return;
		}
		n_children = g_variant_n_children (data);
		_tmp8_ = n_children;
		if (_tmp8_ < ((gsize) 1)) {
			_tmp7_ = TRUE;
		} else {
			gsize _tmp9_;
			_tmp9_ = n_children;
			_tmp7_ = _tmp9_ > ((gsize) 2);
		}
		if (_tmp7_) {
			GError* _tmp10_;
			_tmp10_ = g_error_new (DRT_API_ERROR, DRT_API_ERROR_INVALID_PARAMS, "Method '%s' requires %d parameters but %d parameters have been provide" \
"d.", path, 2, (gint) g_variant_n_children (data));
			_inner_error_ = _tmp10_;
			g_propagate_error (error, _inner_error_);
			_g_free0 (params_type);
			return;
		}
		_tmp11_ = g_variant_get_child_value (data, (gsize) 0);
		_tmp12_ = _tmp11_;
		_tmp13_ = drt_unbox_variant (_tmp12_);
		_tmp14_ = _tmp13_;
		_g_variant_unref0 (_tmp12_);
		entry = _tmp14_;
		_tmp15_ = entry;
		_tmp16_ = drt_variant_bool (_tmp15_, &_vala_subscribe);
		if (!_tmp16_) {
			GVariant* _tmp17_;
			const gchar* _tmp18_;
			GError* _tmp19_;
			_tmp17_ = entry;
			_tmp18_ = g_variant_get_type_string (_tmp17_);
			_tmp19_ = g_error_new (DRT_API_ERROR, DRT_API_ERROR_INVALID_PARAMS, "Method '%s' call expected the first parameter to be a boolean, but typ" \
"e of '%s' received.", path, _tmp18_);
			_inner_error_ = _tmp19_;
			g_propagate_error (error, _inner_error_);
			_g_variant_unref0 (entry);
			_g_free0 (params_type);
			return;
		}
		_tmp20_ = n_children;
		if (_tmp20_ == ((gsize) 2)) {
			GVariant* _tmp21_;
			GVariant* _tmp22_;
			GVariant* _tmp23_;
			gboolean _tmp24_ = FALSE;
			GVariant* _tmp25_;
			_tmp21_ = g_variant_get_child_value (data, (gsize) 1);
			_tmp22_ = _tmp21_;
			_tmp23_ = drt_unbox_variant (_tmp22_);
			_g_variant_unref0 (entry);
			entry = _tmp23_;
			_g_variant_unref0 (_tmp22_);
			_tmp25_ = entry;
			if (_tmp25_ != NULL) {
				GVariant* _tmp26_;
				gchar* _tmp27_ = NULL;
				gboolean _tmp28_;
				_tmp26_ = entry;
				_tmp28_ = drt_variant_string (_tmp26_, &_tmp27_);
				_g_free0 (_vala_detail);
				_vala_detail = _tmp27_;
				_tmp24_ = !_tmp28_;
			} else {
				_tmp24_ = FALSE;
			}
			if (_tmp24_) {
				GVariant* _tmp29_;
				const gchar* _tmp30_;
				GError* _tmp31_;
				_tmp29_ = entry;
				_tmp30_ = g_variant_get_type_string (_tmp29_);
				_tmp31_ = g_error_new (DRT_API_ERROR, DRT_API_ERROR_INVALID_PARAMS, "Method '%s' call expected the second parameter to be a string, but typ" \
"e of '%s' received.", path, _tmp30_);
				_inner_error_ = _tmp31_;
				g_propagate_error (error, _inner_error_);
				_g_variant_unref0 (entry);
				_g_free0 (params_type);
				return;
			}
		}
		_g_variant_unref0 (entry);
	} else {
		const gchar* _tmp32_;
		GVariant* _tmp33_ = NULL;
		const gchar* _tmp34_;
		GVariant* dict = NULL;
		GVariant* _tmp37_;
		GVariant* entry = NULL;
		GVariant* _tmp38_;
		GVariant* _tmp39_;
		GVariant* _tmp40_;
		GVariant* _tmp41_;
		GVariant* _tmp42_;
		GVariant* _tmp43_;
		GVariant* _tmp45_;
		gboolean _tmp46_;
		GVariant* _tmp50_;
		GVariant* _tmp51_;
		GVariant* _tmp52_;
		GVariant* _tmp53_;
		gboolean _tmp54_ = FALSE;
		GVariant* _tmp55_;
		_tmp32_ = g_variant_get_type_string (data);
		if (g_strcmp0 (_tmp32_, "(a{smv})") != 0) {
			drt_rpc_check_type_string (data, "a{smv}", &_inner_error_);
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				g_propagate_error (error, _inner_error_);
				_g_free0 (params_type);
				return;
			}
		}
		_tmp34_ = g_variant_get_type_string (data);
		if (g_strcmp0 (_tmp34_, "(a{smv})") == 0) {
			GVariant* _tmp35_;
			_tmp35_ = g_variant_get_child_value (data, (gsize) 0);
			_g_variant_unref0 (_tmp33_);
			_tmp33_ = _tmp35_;
		} else {
			GVariant* _tmp36_;
			_tmp36_ = _g_variant_ref0 (data);
			_g_variant_unref0 (_tmp33_);
			_tmp33_ = _tmp36_;
		}
		_tmp37_ = _g_variant_ref0 (_tmp33_);
		dict = _tmp37_;
		_tmp38_ = dict;
		_tmp39_ = g_variant_lookup_value (_tmp38_, "subscribe", NULL);
		_tmp40_ = _tmp39_;
		_tmp41_ = drt_unbox_variant (_tmp40_);
		_tmp42_ = _tmp41_;
		_g_variant_unref0 (_tmp40_);
		entry = _tmp42_;
		_tmp43_ = entry;
		if (_tmp43_ == NULL) {
			GError* _tmp44_;
			_tmp44_ = g_error_new (DRT_API_ERROR, DRT_API_ERROR_INVALID_PARAMS, "Method '%s' requires the 'subscribe' parameter of type 'b', but it has" \
" been omitted.", path);
			_inner_error_ = _tmp44_;
			g_propagate_error (error, _inner_error_);
			_g_variant_unref0 (entry);
			_g_variant_unref0 (dict);
			_g_variant_unref0 (_tmp33_);
			_g_free0 (params_type);
			return;
		}
		_tmp45_ = entry;
		_tmp46_ = drt_variant_bool (_tmp45_, &_vala_subscribe);
		if (!_tmp46_) {
			GVariant* _tmp47_;
			const gchar* _tmp48_;
			GError* _tmp49_;
			_tmp47_ = entry;
			_tmp48_ = g_variant_get_type_string (_tmp47_);
			_tmp49_ = g_error_new (DRT_API_ERROR, DRT_API_ERROR_INVALID_PARAMS, "Method '%s' call expected the subscribe parameter to be a boolean, but" \
" type of '%s' received.", path, _tmp48_);
			_inner_error_ = _tmp49_;
			g_propagate_error (error, _inner_error_);
			_g_variant_unref0 (entry);
			_g_variant_unref0 (dict);
			_g_variant_unref0 (_tmp33_);
			_g_free0 (params_type);
			return;
		}
		_tmp50_ = dict;
		_tmp51_ = g_variant_lookup_value (_tmp50_, "detail", NULL);
		_tmp52_ = _tmp51_;
		_tmp53_ = drt_unbox_variant (_tmp52_);
		_g_variant_unref0 (entry);
		entry = _tmp53_;
		_g_variant_unref0 (_tmp52_);
		_tmp55_ = entry;
		if (_tmp55_ != NULL) {
			GVariant* _tmp56_;
			gchar* _tmp57_ = NULL;
			gboolean _tmp58_;
			_tmp56_ = entry;
			_tmp58_ = drt_variant_string (_tmp56_, &_tmp57_);
			_g_free0 (_vala_detail);
			_vala_detail = _tmp57_;
			_tmp54_ = !_tmp58_;
		} else {
			_tmp54_ = FALSE;
		}
		if (_tmp54_) {
			GVariant* _tmp59_;
			const gchar* _tmp60_;
			GError* _tmp61_;
			_tmp59_ = entry;
			_tmp60_ = g_variant_get_type_string (_tmp59_);
			_tmp61_ = g_error_new (DRT_API_ERROR, DRT_API_ERROR_INVALID_PARAMS, "Method '%s' call expected the detail parameter to be a string, but typ" \
"e of '%s' received.", path, _tmp60_);
			_inner_error_ = _tmp61_;
			g_propagate_error (error, _inner_error_);
			_g_variant_unref0 (entry);
			_g_variant_unref0 (dict);
			_g_variant_unref0 (_tmp33_);
			_g_free0 (params_type);
			return;
		}
		_g_variant_unref0 (entry);
		_g_variant_unref0 (dict);
		_g_variant_unref0 (_tmp33_);
	}
	_g_free0 (params_type);
	if (subscribe) {
		*subscribe = _vala_subscribe;
	}
	if (detail) {
		*detail = _vala_detail;
	} else {
		_g_free0 (_vala_detail);
	}
}


/**
 * Parse raw data of notification.
 * 
 * @param data         Raw notification data.
 * @param detail       Unused, reserved for future.
 * @param parameters       Notification parameters
 * @throws GLib.Error on failure.
 */
void
drt_rpc_notification_get_detail_and_params (GVariant* data,
                                            gchar* * detail,
                                            GVariant* * parameters,
                                            GError** error)
{
	gchar* _vala_detail = NULL;
	GVariant* _vala_parameters = NULL;
	gchar* params_type = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (data != NULL);
	_g_free0 (_vala_detail);
	_vala_detail = NULL;
	_g_variant_unref0 (_vala_parameters);
	_vala_parameters = NULL;
	_tmp0_ = drt_rpc_get_params_type (data, &_inner_error_);
	params_type = _tmp0_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		return;
	}
	_tmp1_ = params_type;
	if (g_strcmp0 (_tmp1_, "tuple") == 0) {
		const GVariantType* _tmp2_;
		const GVariantType* _tmp3_;
		gsize n_children = 0UL;
		gsize _tmp6_;
		gsize _tmp8_;
		_tmp2_ = g_variant_get_type (data);
		_tmp3_ = G_VARIANT_TYPE_TUPLE;
		if (!g_variant_type_is_subtype_of (_tmp2_, _tmp3_)) {
			const gchar* _tmp4_;
			GError* _tmp5_;
			_tmp4_ = g_variant_get_type_string (data);
			_tmp5_ = g_error_new (DRT_API_ERROR, DRT_API_ERROR_INVALID_PARAMS, "Notification call expected a tuple of parameters, but type of '%s' rec" \
"eived.", _tmp4_);
			_inner_error_ = _tmp5_;
			g_propagate_error (error, _inner_error_);
			_g_free0 (params_type);
			return;
		}
		n_children = g_variant_n_children (data);
		_tmp6_ = n_children;
		if (_tmp6_ > ((gsize) 2)) {
			GError* _tmp7_;
			_tmp7_ = g_error_new (DRT_API_ERROR, DRT_API_ERROR_INVALID_PARAMS, "Notification requires %d parameters but %d parameters have been provid" \
"ed.", 2, (gint) g_variant_n_children (data));
			_inner_error_ = _tmp7_;
			g_propagate_error (error, _inner_error_);
			_g_free0 (params_type);
			return;
		}
		_tmp8_ = n_children;
		if (_tmp8_ > ((gsize) 0)) {
			GVariant* entry = NULL;
			GVariant* _tmp9_;
			GVariant* _tmp10_;
			GVariant* _tmp11_;
			GVariant* _tmp12_;
			gboolean _tmp13_ = FALSE;
			GVariant* _tmp14_;
			gsize _tmp21_;
			_tmp9_ = g_variant_get_child_value (data, (gsize) 0);
			_tmp10_ = _tmp9_;
			_tmp11_ = drt_unbox_variant (_tmp10_);
			_tmp12_ = _tmp11_;
			_g_variant_unref0 (_tmp10_);
			entry = _tmp12_;
			_tmp14_ = entry;
			if (_tmp14_ != NULL) {
				GVariant* _tmp15_;
				gchar* _tmp16_ = NULL;
				gboolean _tmp17_;
				_tmp15_ = entry;
				_tmp17_ = drt_variant_string (_tmp15_, &_tmp16_);
				_g_free0 (_vala_detail);
				_vala_detail = _tmp16_;
				_tmp13_ = !_tmp17_;
			} else {
				_tmp13_ = FALSE;
			}
			if (_tmp13_) {
				GVariant* _tmp18_;
				const gchar* _tmp19_;
				GError* _tmp20_;
				_tmp18_ = entry;
				_tmp19_ = g_variant_get_type_string (_tmp18_);
				_tmp20_ = g_error_new (DRT_API_ERROR, DRT_API_ERROR_INVALID_PARAMS, "Notification call expected the first parameter to be a string, but typ" \
"e of '%s' received.", _tmp19_);
				_inner_error_ = _tmp20_;
				g_propagate_error (error, _inner_error_);
				_g_variant_unref0 (entry);
				_g_free0 (params_type);
				return;
			}
			_tmp21_ = n_children;
			if (_tmp21_ == ((gsize) 2)) {
				GVariant* _tmp22_;
				GVariant* _tmp23_;
				GVariant* _tmp24_;
				_tmp22_ = g_variant_get_child_value (data, (gsize) 1);
				_tmp23_ = _tmp22_;
				_tmp24_ = drt_unbox_variant (_tmp23_);
				_g_variant_unref0 (_vala_parameters);
				_vala_parameters = _tmp24_;
				_g_variant_unref0 (_tmp23_);
			}
			_g_variant_unref0 (entry);
		}
	} else {
		const gchar* _tmp25_;
		GVariant* _tmp26_ = NULL;
		const gchar* _tmp27_;
		GVariant* dict = NULL;
		GVariant* _tmp30_;
		GVariant* entry = NULL;
		GVariant* _tmp31_;
		GVariant* _tmp32_;
		GVariant* _tmp33_;
		GVariant* _tmp34_;
		GVariant* _tmp35_;
		gboolean _tmp36_ = FALSE;
		GVariant* _tmp37_;
		GVariant* _tmp44_;
		GVariant* _tmp45_;
		GVariant* _tmp46_;
		GVariant* _tmp47_;
		_tmp25_ = g_variant_get_type_string (data);
		if (g_strcmp0 (_tmp25_, "(a{smv})") != 0) {
			drt_rpc_check_type_string (data, "a{smv}", &_inner_error_);
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				g_propagate_error (error, _inner_error_);
				_g_free0 (params_type);
				return;
			}
		}
		_tmp27_ = g_variant_get_type_string (data);
		if (g_strcmp0 (_tmp27_, "(a{smv})") == 0) {
			GVariant* _tmp28_;
			_tmp28_ = g_variant_get_child_value (data, (gsize) 0);
			_g_variant_unref0 (_tmp26_);
			_tmp26_ = _tmp28_;
		} else {
			GVariant* _tmp29_;
			_tmp29_ = _g_variant_ref0 (data);
			_g_variant_unref0 (_tmp26_);
			_tmp26_ = _tmp29_;
		}
		_tmp30_ = _g_variant_ref0 (_tmp26_);
		dict = _tmp30_;
		_tmp31_ = dict;
		_tmp32_ = g_variant_lookup_value (_tmp31_, "detail", NULL);
		_tmp33_ = _tmp32_;
		_tmp34_ = drt_unbox_variant (_tmp33_);
		_tmp35_ = _tmp34_;
		_g_variant_unref0 (_tmp33_);
		entry = _tmp35_;
		_tmp37_ = entry;
		if (_tmp37_ != NULL) {
			GVariant* _tmp38_;
			gchar* _tmp39_ = NULL;
			gboolean _tmp40_;
			_tmp38_ = entry;
			_tmp40_ = drt_variant_string (_tmp38_, &_tmp39_);
			_g_free0 (_vala_detail);
			_vala_detail = _tmp39_;
			_tmp36_ = !_tmp40_;
		} else {
			_tmp36_ = FALSE;
		}
		if (_tmp36_) {
			GVariant* _tmp41_;
			const gchar* _tmp42_;
			GError* _tmp43_;
			_tmp41_ = entry;
			_tmp42_ = g_variant_get_type_string (_tmp41_);
			_tmp43_ = g_error_new (DRT_API_ERROR, DRT_API_ERROR_INVALID_PARAMS, "Notification call expected the detail parameter to be a string, but ty" \
"pe of '%s' received.", _tmp42_);
			_inner_error_ = _tmp43_;
			g_propagate_error (error, _inner_error_);
			_g_variant_unref0 (entry);
			_g_variant_unref0 (dict);
			_g_variant_unref0 (_tmp26_);
			_g_free0 (params_type);
			return;
		}
		_tmp44_ = dict;
		_tmp45_ = g_variant_lookup_value (_tmp44_, "params", NULL);
		_tmp46_ = _tmp45_;
		_tmp47_ = drt_unbox_variant (_tmp46_);
		_g_variant_unref0 (_vala_parameters);
		_vala_parameters = _tmp47_;
		_g_variant_unref0 (_tmp46_);
		_g_variant_unref0 (entry);
		_g_variant_unref0 (dict);
		_g_variant_unref0 (_tmp26_);
	}
	_g_free0 (params_type);
	if (detail) {
		*detail = _vala_detail;
	} else {
		_g_free0 (_vala_detail);
	}
	if (parameters) {
		*parameters = _vala_parameters;
	} else {
		_g_variant_unref0 (_vala_parameters);
	}
}


/**
 * Subscribe or unsubscribe from notification.
 * 
 * @param conn      RpcConnection to (un)subscribe.
 * @param detail    Unused, reserved for future.
 * @throws GLib.Error on failure.
 */
static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


void
drt_rpc_notification_subscribe (DrtRpcNotification* self,
                                DrtRpcConnection* conn,
                                gboolean subscribe,
                                const gchar* detail,
                                GError** error)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (conn != NULL);
	if (subscribe) {
		DrtRpcConnection* _tmp0_;
		_tmp0_ = _g_object_ref0 (conn);
		self->priv->subscribers = g_slist_append (self->priv->subscribers, _tmp0_);
	} else {
		self->priv->subscribers = g_slist_remove (self->priv->subscribers, conn);
	}
}


static void
drt_rpc_notification_emit_data_free (gpointer _data)
{
	DrtRpcNotificationEmitData* _data_;
	_data_ = _data;
	_g_free0 (_data_->detail);
	_g_variant_unref0 (_data_->data);
	_drt_rpc_callable_unref0 (_data_->self);
	g_slice_free (DrtRpcNotificationEmitData, _data_);
}


static gpointer
_drt_rpc_callable_ref0 (gpointer self)
{
	return self ? drt_rpc_callable_ref (self) : NULL;
}


void
drt_rpc_notification_emit (DrtRpcNotification* self,
                           const gchar* detail,
                           GVariant* data,
                           GAsyncReadyCallback _callback_,
                           gpointer _user_data_)
{
	DrtRpcNotificationEmitData* _data_;
	DrtRpcNotification* _tmp0_;
	gchar* _tmp1_;
	GVariant* _tmp2_;
	_data_ = g_slice_new0 (DrtRpcNotificationEmitData);
	_data_->_async_result = g_task_new (NULL, NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, drt_rpc_notification_emit_data_free);
	_tmp0_ = _drt_rpc_callable_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = g_strdup (detail);
	_g_free0 (_data_->detail);
	_data_->detail = _tmp1_;
	_tmp2_ = _g_variant_ref0 (data);
	_g_variant_unref0 (_data_->data);
	_data_->data = _tmp2_;
	drt_rpc_notification_emit_co (_data_);
}


gboolean
drt_rpc_notification_emit_finish (DrtRpcNotification* self,
                                  GAsyncResult* _res_)
{
	gboolean result;
	DrtRpcNotificationEmitData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
	result = _data_->result;
	return result;
}


/**
 * Emit notification.
 * 
 * @param detail    Unused, reserved for future.
 * @param data      Notification body.
 * @return true if there have been no errors.
 */
static void
drt_rpc_notification_emit_ready (GObject* source_object,
                                 GAsyncResult* _res_,
                                 gpointer _user_data_)
{
	DrtRpcNotificationEmitData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	drt_rpc_notification_emit_co (_data_);
}


static gboolean
drt_rpc_notification_emit_co (DrtRpcNotificationEmitData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_result_ = TRUE;
	_data_->_tmp0_ = _data_->self->priv->subscribers;
	{
		_data_->channel_collection = _data_->_tmp0_;
		for (_data_->channel_it = _data_->channel_collection; _data_->channel_it != NULL; _data_->channel_it = _data_->channel_it->next) {
			_data_->channel = (DrtRpcConnection*) _data_->channel_it->data;
			{
				{
					_data_->_tmp1_ = _data_->channel;
					_data_->_tmp2_ = drt_rpc_callable_get_path ((DrtRpcCallable*) _data_->self);
					_data_->_tmp3_ = _data_->_tmp2_;
					_data_->_tmp4_ = g_strconcat ("n:", _data_->_tmp3_, NULL);
					_data_->_tmp5_ = _data_->_tmp4_;
					_data_->_tmp6_ = g_variant_new ("(msmv)", _data_->detail, _data_->data, NULL);
					g_variant_ref_sink (_data_->_tmp6_);
					_data_->_tmp7_ = _data_->_tmp6_;
					_data_->_state_ = 1;
					drt_rpc_connection_call (_data_->_tmp1_, _data_->_tmp5_, _data_->_tmp7_, drt_rpc_notification_emit_ready, _data_);
					return FALSE;
					_state_1:
					_data_->_tmp8_ = drt_rpc_connection_call_finish (_data_->_tmp1_, _data_->_res_, &_data_->_inner_error_);
					_data_->_tmp9_ = _data_->_tmp8_;
					_g_variant_unref0 (_data_->_tmp9_);
					_g_variant_unref0 (_data_->_tmp7_);
					_g_free0 (_data_->_tmp5_);
					if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
						goto __catch62_g_error;
					}
				}
				goto __finally62;
				__catch62_g_error:
				{
					_data_->e = _data_->_inner_error_;
					_data_->_inner_error_ = NULL;
					_data_->_result_ = FALSE;
					_data_->_tmp10_ = drt_rpc_callable_get_path ((DrtRpcCallable*) _data_->self);
					_data_->_tmp11_ = _data_->_tmp10_;
					_data_->_tmp12_ = _data_->e;
					_data_->_tmp13_ = _data_->_tmp12_->message;
					g_warning ("RpcNotification.vala:194: Failed to emit '%s': %s", _data_->_tmp11_, _data_->_tmp13_);
					_g_error_free0 (_data_->e);
				}
				__finally62:
				if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
					g_clear_error (&_data_->_inner_error_);
					g_object_unref (_data_->_async_result);
					return FALSE;
				}
			}
		}
	}
	_data_->result = _data_->_result_;
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (g_task_get_completed (_data_->_async_result) != TRUE) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}


/**
 * Run callable object with data from RPC request.
 * @param conn    Request connection.
 * @param id      Request id.
 * @param data    Request data.
 * @throws GLib.Error on failure.
 */
static void
drt_rpc_notification_real_run (DrtRpcCallable* base,
                               DrtRpcConnection* conn,
                               guint id,
                               GVariant* data,
                               GError** error)
{
	DrtRpcNotification * self;
	gboolean subscribe = FALSE;
	gchar* detail = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	gchar* _tmp3_ = NULL;
	gboolean _tmp4_;
	const gchar* _tmp5_;
	GError * _inner_error_ = NULL;
	self = (DrtRpcNotification*) base;
	g_return_if_fail (conn != NULL);
	subscribe = TRUE;
	detail = NULL;
	_tmp0_ = drt_rpc_callable_get_path ((DrtRpcCallable*) self);
	_tmp1_ = _tmp0_;
	drt_rpc_notification_parse_params (_tmp1_, data, &_tmp2_, &_tmp3_, &_inner_error_);
	subscribe = _tmp2_;
	_g_free0 (detail);
	detail = _tmp3_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		_g_free0 (detail);
		return;
	}
	_tmp4_ = subscribe;
	_tmp5_ = detail;
	drt_rpc_notification_subscribe (self, conn, _tmp4_, _tmp5_, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		_g_free0 (detail);
		return;
	}
	drt_rpc_connection_respond (conn, id, NULL);
	_g_free0 (detail);
}


static void
drt_rpc_notification_class_init (DrtRpcNotificationClass * klass)
{
	drt_rpc_notification_parent_class = g_type_class_peek_parent (klass);
	((DrtRpcCallableClass *) klass)->finalize = drt_rpc_notification_finalize;
	g_type_class_add_private (klass, sizeof (DrtRpcNotificationPrivate));
	((DrtRpcCallableClass *) klass)->run = (void (*) (DrtRpcCallable *, DrtRpcConnection*, guint, GVariant*, GError**)) drt_rpc_notification_real_run;
}


static void
drt_rpc_notification_instance_init (DrtRpcNotification * self)
{
	self->priv = DRT_RPC_NOTIFICATION_GET_PRIVATE (self);
	self->priv->subscribers = NULL;
}


static void
drt_rpc_notification_finalize (DrtRpcCallable * obj)
{
	DrtRpcNotification * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DRT_TYPE_RPC_NOTIFICATION, DrtRpcNotification);
	__g_slist_free__g_object_unref0_0 (self->priv->subscribers);
	DRT_RPC_CALLABLE_CLASS (drt_rpc_notification_parent_class)->finalize (obj);
}


/**
 * RPC Notification handles incoming request to subscribe/unsubscribe and emits notifications..
 */
GType
drt_rpc_notification_get_type (void)
{
	static volatile gsize drt_rpc_notification_type_id__volatile = 0;
	if (g_once_init_enter (&drt_rpc_notification_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DrtRpcNotificationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) drt_rpc_notification_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DrtRpcNotification), 0, (GInstanceInitFunc) drt_rpc_notification_instance_init, NULL };
		GType drt_rpc_notification_type_id;
		drt_rpc_notification_type_id = g_type_register_static (DRT_TYPE_RPC_CALLABLE, "DrtRpcNotification", &g_define_type_info, 0);
		g_once_init_leave (&drt_rpc_notification_type_id__volatile, drt_rpc_notification_type_id);
	}
	return drt_rpc_notification_type_id__volatile;
}



