/* Serialize.c generated by valac 0.40.6, the Vala compiler
 * generated from Serialize.vala, do not modify */

/*
 * Copyright 2014 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_variant_type_free0(var) ((var == NULL) ? NULL : (var = (g_variant_type_free (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);



#define DRT_SERIALIZE_ALIGN ((guint) 8)
gboolean drt_serialize_variant (GVariant* variant,
                                guint8* buffer,
                                int buffer_length1,
                                guint offset);
guint8* drt_serialize_message (const gchar* name,
                               GVariant* parameters,
                               guint offset,
                               int* result_length1);
GVariant* drt_deserialize_variant (const gchar* type_sig,
                                   guint8* buffer,
                                   int buffer_length1,
                                   guint offset,
                                   gboolean trusted);
gboolean drt_deserialize_message (guint8* buffer,
                                  int buffer_length1,
                                  gchar* * name,
                                  GVariant* * parameters,
                                  guint offset);
GVariant* drt_serialize_error (GError* e);
GError* drt_deserialize_error (GVariant* e);


/**
 * Serializes Variant to byte array at given offset.
 * 
 * @param variant    variant value to store
 * @param buffer     byte array to store variant at, must be large enough (see Varian.get_size())
 * @param offset     starting offset to store value at, must be aligned to 8 bytes
 * @return true on success, false if requirements haven't been met
 */
gboolean
drt_serialize_variant (GVariant* variant,
                       guint8* buffer,
                       int buffer_length1,
                       guint offset)
{
	gboolean result = FALSE;
	guint8* p = NULL;
	g_return_val_if_fail (variant != NULL, FALSE);
	g_return_val_if_fail (((gsize) (buffer_length1 - offset)) >= g_variant_get_size (variant), FALSE);
	g_return_val_if_fail ((offset % DRT_SERIALIZE_ALIGN) == ((guint) 0), FALSE);
	p = ((guint8*) buffer) + offset;
	g_variant_store (variant, p);
	result = TRUE;
	return result;
}


/**
 * Serializes message to byte array at given offset.
 * 
 * @param name      message name
 * @param parameters    message parameters
 * @param offset    starting offset to store data at, use for your own data (e.g. format signature)
 * @return byte array with serialized message
 */
guint8*
drt_serialize_message (const gchar* name,
                       GVariant* parameters,
                       guint offset,
                       int* result_length1)
{
	guint8* result = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* type_str = NULL;
	gchar* _tmp2_;
	guint variant_offset = 0U;
	gint _tmp3_;
	gint _tmp4_;
	const gchar* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	guint _tmp8_;
	gsize _tmp11_ = 0UL;
	guint32 buffer_size = 0U;
	guint _tmp12_;
	guint8* buffer = NULL;
	guint32 _tmp13_;
	guint8* _tmp14_;
	gint buffer_length1;
	gint _buffer_size_;
	guint8* p = NULL;
	guint8* _tmp15_;
	gint _tmp15__length1;
	guint size = 0U;
	gint _tmp16_;
	gint _tmp17_;
	guint8* _tmp18_;
	guint _tmp19_;
	guint _tmp20_;
	const gchar* _tmp21_;
	gint _tmp22_;
	gint _tmp23_;
	guint8* _tmp24_;
	const gchar* _tmp25_;
	guint _tmp26_;
	guint _tmp27_;
	guint8* _tmp30_;
	gint _tmp30__length1;
	g_return_val_if_fail (name != NULL, NULL);
	if (parameters != NULL) {
		const gchar* _tmp1_;
		_tmp1_ = g_variant_get_type_string (parameters);
		_tmp0_ = _tmp1_;
	} else {
		_tmp0_ = "";
	}
	_tmp2_ = g_strdup (_tmp0_);
	type_str = _tmp2_;
	_tmp3_ = strlen (name);
	_tmp4_ = _tmp3_;
	_tmp5_ = type_str;
	_tmp6_ = strlen (_tmp5_);
	_tmp7_ = _tmp6_;
	variant_offset = (guint) ((((offset + _tmp4_) + 1) + _tmp7_) + 1);
	_tmp8_ = variant_offset;
	if ((_tmp8_ % DRT_SERIALIZE_ALIGN) != ((guint) 0)) {
		guint _tmp9_;
		guint _tmp10_;
		_tmp9_ = variant_offset;
		_tmp10_ = variant_offset;
		variant_offset = _tmp9_ + (DRT_SERIALIZE_ALIGN - (_tmp10_ % DRT_SERIALIZE_ALIGN));
	}
	if (parameters != NULL) {
		_tmp11_ = g_variant_get_size (parameters);
	} else {
		_tmp11_ = (gsize) 0;
	}
	_tmp12_ = variant_offset;
	buffer_size = (guint32) (_tmp12_ + _tmp11_);
	_tmp13_ = buffer_size;
	_tmp14_ = g_new0 (guint8, _tmp13_);
	buffer = _tmp14_;
	buffer_length1 = _tmp13_;
	_buffer_size_ = buffer_length1;
	_tmp15_ = buffer;
	_tmp15__length1 = buffer_length1;
	p = _tmp15_;
	_tmp16_ = strlen (name);
	_tmp17_ = _tmp16_;
	size = (guint) (_tmp17_ + 1);
	_tmp18_ = p;
	_tmp19_ = size;
	memcpy (_tmp18_ + offset, (void*) name, (gsize) _tmp19_);
	_tmp20_ = size;
	offset = offset + _tmp20_;
	_tmp21_ = type_str;
	_tmp22_ = strlen (_tmp21_);
	_tmp23_ = _tmp22_;
	size = (guint) (_tmp23_ + 1);
	_tmp24_ = p;
	_tmp25_ = type_str;
	_tmp26_ = size;
	memcpy (_tmp24_ + offset, (void*) _tmp25_, (gsize) _tmp26_);
	_tmp27_ = size;
	offset = offset + _tmp27_;
	if (parameters != NULL) {
		guint8* _tmp28_;
		gint _tmp28__length1;
		guint _tmp29_;
		_tmp28_ = buffer;
		_tmp28__length1 = buffer_length1;
		_tmp29_ = variant_offset;
		_vala_assert (drt_serialize_variant (parameters, _tmp28_, _tmp28__length1, _tmp29_), "serialize_variant(parameters, buffer, variant_offset)");
	}
	_tmp30_ = buffer;
	_tmp30__length1 = buffer_length1;
	if (result_length1) {
		*result_length1 = _tmp30__length1;
	}
	result = _tmp30_;
	_g_free0 (type_str);
	return result;
}


/**
 * Deserializes Variant from byte array at given offset.
 * 
 * @param type_sig    valid variant type signature
 * @param buffer      byte array read data from. array will be freed asynchronously, see Variant.new_from_data
 * @param offset      starting offset to read data from, must be aligned to 8 bytes
 * @param trusted     whether data comes from trusted source
 * @return Variant on success, null if requirements haven't been met
 */
GVariant*
drt_deserialize_variant (const gchar* type_sig,
                         guint8* buffer,
                         int buffer_length1,
                         guint offset,
                         gboolean trusted)
{
	GVariant* result = NULL;
	guint8* real_data = NULL;
	gint real_data_length1;
	gint _real_data_size_;
	gint _tmp0_;
	GVariantType* type = NULL;
	GVariantType* _tmp1_;
	GVariant* variant = NULL;
	guint8* _tmp2_;
	gint _tmp2__length1;
	GVariant* _tmp3_;
	g_return_val_if_fail (type_sig != NULL, NULL);
	g_return_val_if_fail (g_variant_type_string_is_valid (type_sig), NULL);
	g_return_val_if_fail ((offset % DRT_SERIALIZE_ALIGN) == ((guint) 0), NULL);
	real_data = (guint8*) (((guint8*) buffer) + offset);
	real_data_length1 = sizeof (guint8) / sizeof (guint8);
	_real_data_size_ = real_data_length1;
	real_data_length1 = (gint) (buffer_length1 - offset);
	_tmp0_ = real_data_length1;
	_tmp1_ = g_variant_type_new (type_sig);
	type = _tmp1_;
	_tmp2_ = buffer;
	_tmp2__length1 = buffer_length1;
	buffer = NULL;
	buffer_length1 = 0;
	_tmp3_ = g_variant_new_from_data (type, real_data, real_data_length1, trusted, g_free, _tmp2_);
	variant = _tmp3_;
	result = variant;
	_g_variant_type_free0 (type);
	buffer = (g_free (buffer), NULL);
	return result;
}


/**
 * Deserializes message from byte array at given offset.
 * 
 * @param buffer    byte array to read data from, array will be freed asynchronously, see Variant.new_from_data
 * @param name      message name
 * @param parameters    message parameters
 * @param offset    starting offset to store data at, use for your own data (e.g. format signature)
 * @return true on success, false on failure (i. e. invalid data)
 */
gboolean
drt_deserialize_message (guint8* buffer,
                         int buffer_length1,
                         gchar* * name,
                         GVariant* * parameters,
                         guint offset)
{
	gchar* _vala_name = NULL;
	GVariant* _vala_parameters = NULL;
	gboolean result = FALSE;
	guint32 limit = 0U;
	guint8* p = NULL;
	guint8* index = NULL;
	guint8* _tmp0_;
	guint32 _tmp1_;
	void* _tmp2_;
	gboolean _tmp3_ = FALSE;
	guint8* _tmp4_;
	guint size = 0U;
	guint8* _tmp7_;
	guint8* _tmp8_;
	gchar* tmp_name = NULL;
	guint8* _tmp9_;
	guint _tmp10_;
	void* _tmp11_;
	gchar* _tmp12_;
	guint _tmp13_;
	guint8* _tmp14_;
	guint _tmp15_;
	guint32 _tmp16_;
	guint _tmp17_;
	guint8* _tmp18_;
	guint32 _tmp19_;
	void* _tmp20_;
	gboolean _tmp21_ = FALSE;
	guint8* _tmp22_;
	guint8* _tmp25_;
	guint8* _tmp26_;
	gchar* type_str = NULL;
	guint8* _tmp27_;
	guint _tmp28_;
	void* _tmp29_;
	gchar* _tmp30_;
	guint _tmp31_;
	const gchar* _tmp32_;
	gchar* _tmp37_;
	_g_free0 (_vala_name);
	_vala_name = NULL;
	_g_variant_unref0 (_vala_parameters);
	_vala_parameters = NULL;
	limit = (guint32) (buffer_length1 - offset);
	p = ((guint8*) buffer) + offset;
	_tmp0_ = p;
	_tmp1_ = limit;
	_tmp2_ = memchr (_tmp0_, 0, (gsize) _tmp1_);
	index = _tmp2_;
	_tmp4_ = index;
	if (_tmp4_ != NULL) {
		guint8* _tmp5_;
		guint8* _tmp6_;
		_tmp5_ = index;
		_tmp6_ = p;
		_tmp3_ = (_tmp5_ - _tmp6_) > ((gsize) 0);
	} else {
		_tmp3_ = FALSE;
	}
	g_return_val_if_fail (_tmp3_, FALSE);
	_tmp7_ = index;
	_tmp8_ = p;
	size = (guint) ((_tmp7_ - _tmp8_) + 1);
	_tmp9_ = p;
	_tmp10_ = size;
	_tmp11_ = g_memdup (_tmp9_, _tmp10_);
	_tmp12_ = g_strdup ((const gchar*) _tmp11_);
	tmp_name = _tmp12_;
	_tmp13_ = size;
	offset = offset + _tmp13_;
	_tmp14_ = p;
	_tmp15_ = size;
	p = _tmp14_ + _tmp15_;
	_tmp16_ = limit;
	_tmp17_ = size;
	limit = _tmp16_ - _tmp17_;
	_tmp18_ = p;
	_tmp19_ = limit;
	_tmp20_ = memchr (_tmp18_, 0, (gsize) _tmp19_);
	index = _tmp20_;
	_tmp22_ = index;
	if (_tmp22_ != NULL) {
		guint8* _tmp23_;
		guint8* _tmp24_;
		_tmp23_ = index;
		_tmp24_ = p;
		_tmp21_ = (_tmp23_ - _tmp24_) >= ((gsize) 0);
	} else {
		_tmp21_ = FALSE;
	}
	g_return_val_if_fail (_tmp21_, FALSE);
	_tmp25_ = index;
	_tmp26_ = p;
	size = (guint) ((_tmp25_ - _tmp26_) + 1);
	_tmp27_ = p;
	_tmp28_ = size;
	_tmp29_ = g_memdup (_tmp27_, _tmp28_);
	_tmp30_ = g_strdup ((const gchar*) _tmp29_);
	type_str = _tmp30_;
	_tmp31_ = size;
	offset = offset + _tmp31_;
	if ((offset % DRT_SERIALIZE_ALIGN) != ((guint) 0)) {
		offset = offset + (DRT_SERIALIZE_ALIGN - (offset % DRT_SERIALIZE_ALIGN));
	}
	_tmp32_ = type_str;
	if (g_strcmp0 (_tmp32_, "") != 0) {
		const gchar* _tmp33_;
		guint8* _tmp34_;
		gint _tmp34__length1;
		GVariant* _tmp35_;
		GVariant* _tmp36_;
		_tmp33_ = type_str;
		_tmp34_ = buffer;
		_tmp34__length1 = buffer_length1;
		buffer = NULL;
		buffer_length1 = 0;
		_tmp35_ = drt_deserialize_variant (_tmp33_, _tmp34_, _tmp34__length1, offset, FALSE);
		_g_variant_unref0 (_vala_parameters);
		_vala_parameters = _tmp35_;
		_tmp36_ = _vala_parameters;
		g_return_val_if_fail (_tmp36_ != NULL, FALSE);
	}
	_tmp37_ = tmp_name;
	tmp_name = NULL;
	_g_free0 (_vala_name);
	_vala_name = _tmp37_;
	result = TRUE;
	_g_free0 (type_str);
	_g_free0 (tmp_name);
	buffer = (g_free (buffer), NULL);
	if (name) {
		*name = _vala_name;
	} else {
		_g_free0 (_vala_name);
	}
	if (parameters) {
		*parameters = _vala_parameters;
	} else {
		_g_variant_unref0 (_vala_parameters);
	}
	return result;
}


GVariant*
drt_serialize_error (GError* e)
{
	GVariant* result = NULL;
	GQuark _tmp0_;
	const gchar* _tmp1_;
	gint _tmp2_;
	const gchar* _tmp3_;
	GVariant* _tmp4_;
	_tmp0_ = e->domain;
	_tmp1_ = g_quark_to_string (_tmp0_);
	_tmp2_ = e->code;
	_tmp3_ = e->message;
	_tmp4_ = g_variant_new ("(sis)", _tmp1_, _tmp2_, _tmp3_, NULL);
	g_variant_ref_sink (_tmp4_);
	result = _tmp4_;
	return result;
}


GError*
drt_deserialize_error (GVariant* e)
{
	GError* result = NULL;
	gchar* domain = NULL;
	gint code = 0;
	gchar* message = NULL;
	const gchar* _tmp0_;
	gint _tmp1_;
	const gchar* _tmp2_;
	GError* _tmp3_;
	g_return_val_if_fail (e != NULL, NULL);
	domain = NULL;
	code = 0;
	message = NULL;
	g_variant_get (e, "(sis)", &domain, &code, &message, NULL);
	_tmp0_ = domain;
	_tmp1_ = code;
	_tmp2_ = message;
	_tmp3_ = g_error_new (g_quark_from_string (_tmp0_), _tmp1_, "%s", _tmp2_);
	result = _tmp3_;
	_g_free0 (message);
	_g_free0 (domain);
	return result;
}



