/* String.c generated by valac 0.40.6, the Vala compiler
 * generated from String.vala, do not modify */

/*
 * Copyright 2017 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define __g_slist_free__g_free0_0(var) ((var == NULL) ? NULL : (var = (_g_slist_free__g_free0_ (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);



gboolean drt_string_is_empty (const gchar* str);
gchar* drt_string_null_if_empty (const gchar* str);
gchar* drt_string_concat (const gchar* initial,
                          const gchar* separator,
                          gchar* text);
void drt_string_append (gchar* * initial,
                        const gchar* separator,
                        gchar* text);
GSList* drt_string_split_strip (const gchar* data,
                                const gchar* delimiter,
                                gint max_tokens);
GSList* drt_string_array_to_slist (gchar** array,
                                   int array_length1,
                                   gboolean strip);
static void _g_free0_ (gpointer var);
static inline void _g_slist_free__g_free0_ (GSList* self);
GHashTable* drt_string_semicolon_separated_set (const gchar* dataset,
                                                gboolean lowercase);
gint drt_string_index_of_char (const gchar* str,
                               gunichar c,
                               gint start_index,
                               gssize len);
gint drt_string_last_index_of_char (const gchar* str,
                                    gunichar c,
                                    gint start_index,
                                    gssize len);
gchar* drt_string_unmask (guint8* data,
                          int data_length1);
gint drt_string_utf16_strlen (const gchar* str);
const gchar* drt_string_offset (const gchar* str,
                                gint offset);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


/**
 * Check whether string is empty, i.e. `null` or `""`.
 * 
 * @param str    string to test
 * @return true if string is empty, false otherwise
 */
static gchar
string_get (const gchar* self,
            glong index)
{
	gchar result = '\0';
	gchar _tmp0_;
	g_return_val_if_fail (self != NULL, '\0');
	_tmp0_ = ((gchar*) self)[index];
	result = _tmp0_;
	return result;
}


inline gboolean
drt_string_is_empty (const gchar* str)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	if (str == NULL) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = string_get (str, (glong) 0) == '\0';
	}
	result = _tmp0_;
	return result;
}


/**
 * Ensure string is not empty but either non-empty or null
 * 
 * @param str    original string
 * @return original string if it isn't empty, null otherwise
 */
inline gchar*
drt_string_null_if_empty (const gchar* str)
{
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	gchar* _tmp2_;
	if (str == NULL) {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = string_get (str, (glong) 0) == '\0';
	}
	if (_tmp1_) {
		_tmp0_ = NULL;
	} else {
		_tmp0_ = str;
	}
	_tmp2_ = g_strdup (_tmp0_);
	result = _tmp2_;
	return result;
}


/**
 * Concatenate two strings with an optional separator
 * 
 * If the first string is empty, the second string is returned.
 * Otherwise, the strings are joined with the separator if specified.
 * 
 * @param initial     Initial string.
 * @param separator   A separator to include between strings.
 * @param text        The second string.
 * @return Joined string.
 */
gchar*
drt_string_concat (const gchar* initial,
                   const gchar* separator,
                   gchar* text)
{
	gchar* result = NULL;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	g_return_val_if_fail (text != NULL, NULL);
	if (drt_string_is_empty (initial)) {
		gchar* _tmp0_;
		_tmp0_ = text;
		text = NULL;
		result = _tmp0_;
		_g_free0 (text);
		return result;
	}
	if (drt_string_is_empty (separator)) {
		gchar* _tmp1_;
		_tmp1_ = g_strconcat (initial, text, NULL);
		result = _tmp1_;
		_g_free0 (text);
		return result;
	}
	_tmp2_ = g_strconcat (initial, separator, NULL);
	_tmp3_ = _tmp2_;
	_tmp4_ = g_strconcat (_tmp3_, text, NULL);
	_tmp5_ = _tmp4_;
	_g_free0 (_tmp3_);
	result = _tmp5_;
	_g_free0 (text);
	return result;
}


/**
 * Append string to the other string.
 * 
 * Separator is included if it is specified and the initial string is not empty.
 * 
 * @param initial      The initial string, which will be overwritten with the result.
 * @param separator    The separator which will be added if the initial string is not empty.
 * @param text         The text to append.
 */
void
drt_string_append (gchar* * initial,
                   const gchar* separator,
                   gchar* text)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_if_fail (text != NULL);
	_tmp0_ = text;
	text = NULL;
	_tmp1_ = drt_string_concat (*initial, separator, _tmp0_);
	_g_free0 (*initial);
	*initial = _tmp1_;
	_g_free0 (text);
}


/**	
 * Splits a string into a maximum of `max_tokens` pieces, using the given `delimiter` and ignoring
 * empty elements after stripping.
 * 
 * If `max_tokens` is reached, the remainder of string is appended to the last token.
 * 
 * @param data          a string to split
 * @param delimiter     a string which specifies the places at which to split the string. The delimiter is not
 *                      included in any of the resulting strings, unless `max_tokens` is reached.
 * @param max_tokens    the maximum number of pieces to split string into. If this is less than 1, the string 
 *                      is split completely.
 * @return resulting list of strings
 */
GSList*
drt_string_split_strip (const gchar* data,
                        const gchar* delimiter,
                        gint max_tokens)
{
	GSList* result = NULL;
	gchar** _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	GSList* _tmp3_;
	GSList* _tmp4_;
	g_return_val_if_fail (delimiter != NULL, NULL);
	if (drt_string_is_empty (data)) {
		result = NULL;
		return result;
	}
	_tmp1_ = _tmp0_ = g_strsplit (data, delimiter, max_tokens);
	_tmp2_ = _tmp1_;
	_tmp2__length1 = _vala_array_length (_tmp0_);
	_tmp3_ = drt_string_array_to_slist (_tmp2_, _vala_array_length (_tmp0_), TRUE);
	_tmp4_ = _tmp3_;
	_tmp2_ = (_vala_array_free (_tmp2_, _tmp2__length1, (GDestroyNotify) g_free), NULL);
	result = _tmp4_;
	return result;
}


/**
 * Creates list from array of strings
 * 
 * @param array    string array
 * @param strip    strip array elements and ignore empty elements
 * @return resulting list of strings
 */
static gchar*
string_strip (const gchar* self)
{
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup (self);
	_result_ = _tmp0_;
	_tmp1_ = _result_;
	g_strstrip (_tmp1_);
	result = _result_;
	return result;
}


static void
_g_free0_ (gpointer var)
{
	var = (g_free (var), NULL);
}


static inline void
_g_slist_free__g_free0_ (GSList* self)
{
	g_slist_free_full (self, (GDestroyNotify) _g_free0_);
}


GSList*
drt_string_array_to_slist (gchar** array,
                           int array_length1,
                           gboolean strip)
{
	GSList* result = NULL;
	GSList* _result_ = NULL;
	GSList* _tmp7_;
	_result_ = NULL;
	{
		gchar** item_collection = NULL;
		gint item_collection_length1 = 0;
		gint _item_collection_size_ = 0;
		gint item_it = 0;
		item_collection = array;
		item_collection_length1 = array_length1;
		for (item_it = 0; item_it < array_length1; item_it = item_it + 1) {
			const gchar* item = NULL;
			item = item_collection[item_it];
			{
				if (!strip) {
					const gchar* _tmp0_;
					gchar* _tmp1_;
					_tmp0_ = item;
					_tmp1_ = g_strdup (_tmp0_);
					_result_ = g_slist_prepend (_result_, _tmp1_);
				} else {
					const gchar* _tmp2_;
					_tmp2_ = item;
					if (!drt_string_is_empty (_tmp2_)) {
						gchar* stripped_item = NULL;
						const gchar* _tmp3_;
						gchar* _tmp4_;
						const gchar* _tmp5_;
						_tmp3_ = item;
						_tmp4_ = string_strip (_tmp3_);
						stripped_item = _tmp4_;
						_tmp5_ = stripped_item;
						if (!drt_string_is_empty (_tmp5_)) {
							gchar* _tmp6_;
							_tmp6_ = stripped_item;
							stripped_item = NULL;
							_result_ = g_slist_prepend (_result_, _tmp6_);
						}
						_g_free0 (stripped_item);
					}
				}
			}
		}
	}
	_result_ = g_slist_reverse (_result_);
	_tmp7_ = _result_;
	_result_ = NULL;
	result = _tmp7_;
	__g_slist_free__g_free0_0 (_result_);
	return result;
}


/**
 * Parse a string containing semicolon-separated set of items
 * 
 * @param dataset    semicolon-separated set of items
 * @return a set data structurecontaining all unique items from data set
 */
GHashTable*
drt_string_semicolon_separated_set (const gchar* dataset,
                                    gboolean lowercase)
{
	GHashTable* result = NULL;
	GHashTable* _result_ = NULL;
	GHashFunc _tmp0_;
	GEqualFunc _tmp1_;
	GHashTable* _tmp2_;
	_tmp0_ = g_str_hash;
	_tmp1_ = g_str_equal;
	_tmp2_ = g_hash_table_new_full (_tmp0_, _tmp1_, NULL, _g_free0_);
	_result_ = _tmp2_;
	if (!drt_string_is_empty (dataset)) {
		gchar** items = NULL;
		gchar** _tmp3_;
		gchar** _tmp4_;
		gint items_length1;
		gint _items_size_;
		gchar** _tmp5_;
		gint _tmp5__length1;
		_tmp4_ = _tmp3_ = g_strsplit (dataset, ";", 0);
		items = _tmp4_;
		items_length1 = _vala_array_length (_tmp3_);
		_items_size_ = items_length1;
		_tmp5_ = items;
		_tmp5__length1 = items_length1;
		{
			gchar** item_collection = NULL;
			gint item_collection_length1 = 0;
			gint _item_collection_size_ = 0;
			gint item_it = 0;
			item_collection = _tmp5_;
			item_collection_length1 = _tmp5__length1;
			for (item_it = 0; item_it < _tmp5__length1; item_it = item_it + 1) {
				gchar* _tmp6_;
				gchar* item = NULL;
				_tmp6_ = g_strdup (item_collection[item_it]);
				item = _tmp6_;
				{
					const gchar* _tmp7_;
					gchar* _tmp8_;
					const gchar* _tmp9_;
					_tmp7_ = item;
					_tmp8_ = string_strip (_tmp7_);
					_g_free0 (item);
					item = _tmp8_;
					_tmp9_ = item;
					if (((gint) string_get (_tmp9_, (glong) 0)) != 0) {
						gchar* _tmp10_ = NULL;
						GHashTable* _tmp15_;
						gchar* _tmp16_;
						if (lowercase) {
							const gchar* _tmp11_;
							gchar* _tmp12_;
							_tmp11_ = item;
							_tmp12_ = g_utf8_strdown (_tmp11_, (gssize) -1);
							_g_free0 (_tmp10_);
							_tmp10_ = _tmp12_;
						} else {
							const gchar* _tmp13_;
							gchar* _tmp14_;
							_tmp13_ = item;
							_tmp14_ = g_strdup (_tmp13_);
							_g_free0 (_tmp10_);
							_tmp10_ = _tmp14_;
						}
						_tmp15_ = _result_;
						_tmp16_ = g_strdup (_tmp10_);
						g_hash_table_add (_tmp15_, _tmp16_);
						_g_free0 (_tmp10_);
					}
					_g_free0 (item);
				}
			}
		}
		items = (_vala_array_free (items, items_length1, (GDestroyNotify) g_free), NULL);
	}
	result = _result_;
	return result;
}


gint
drt_string_index_of_char (const gchar* str,
                          gunichar c,
                          gint start_index,
                          gssize len)
{
	gint result = 0;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gint _tmp1_ = 0;
	gchar* _tmp2_;
	g_return_val_if_fail (str != NULL, 0);
	_tmp0_ = g_utf8_strchr (((gchar*) str) + start_index, len, c);
	_result_ = _tmp0_;
	_tmp2_ = _result_;
	if (_tmp2_ != NULL) {
		gchar* _tmp3_;
		_tmp3_ = _result_;
		_tmp1_ = (gint) (_tmp3_ - ((gchar*) str));
	} else {
		_tmp1_ = -1;
	}
	result = _tmp1_;
	return result;
}


gint
drt_string_last_index_of_char (const gchar* str,
                               gunichar c,
                               gint start_index,
                               gssize len)
{
	gint result = 0;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gint _tmp1_ = 0;
	gchar* _tmp2_;
	g_return_val_if_fail (str != NULL, 0);
	_tmp0_ = g_utf8_strrchr (((gchar*) str) + start_index, len, c);
	_result_ = _tmp0_;
	_tmp2_ = _result_;
	if (_tmp2_ != NULL) {
		gchar* _tmp3_;
		_tmp3_ = _result_;
		_tmp1_ = (gint) (_tmp3_ - ((gchar*) str));
	} else {
		_tmp1_ = -1;
	}
	result = _tmp1_;
	return result;
}


gchar*
drt_string_unmask (guint8* data,
                   int data_length1)
{
	gchar* result = NULL;
	gint length = 0;
	gint _tmp0_;
	guint8 shift = 0U;
	guint8 _tmp1_;
	guint8* _result_ = NULL;
	gint _tmp2_;
	guint8* _tmp3_;
	gint _result__length1;
	gint __result__size_;
	guint8* _tmp17_;
	gint _tmp17__length1;
	gint _tmp18_;
	guint8 _tmp19_;
	guint8* _tmp20_;
	gint _tmp20__length1;
	gchar* _tmp21_;
	length = data_length1;
	_tmp0_ = length;
	if (_tmp0_ < 2) {
		result = NULL;
		return result;
	}
	_tmp1_ = data[0];
	shift = _tmp1_;
	_tmp2_ = length;
	_tmp3_ = g_new0 (guint8, _tmp2_);
	_result_ = _tmp3_;
	_result__length1 = _tmp2_;
	__result__size_ = _result__length1;
	{
		gint i = 0;
		i = 1;
		{
			gboolean _tmp4_ = FALSE;
			_tmp4_ = TRUE;
			while (TRUE) {
				gint _tmp6_;
				gint _tmp7_;
				guint8 _tmp8_;
				gint _tmp9_;
				guint8 _tmp10_;
				guint8* _tmp11_;
				gint _tmp11__length1;
				gint _tmp12_;
				gint _tmp13_;
				guint8 _tmp14_;
				guint8 _tmp15_;
				guint8 _tmp16_;
				if (!_tmp4_) {
					gint _tmp5_;
					_tmp5_ = i;
					i = _tmp5_ + 1;
				}
				_tmp4_ = FALSE;
				_tmp6_ = i;
				_tmp7_ = length;
				if (!(_tmp6_ < _tmp7_)) {
					break;
				}
				_tmp8_ = shift;
				_tmp9_ = i;
				_tmp10_ = data[_tmp9_];
				if (_tmp8_ > _tmp10_) {
					result = NULL;
					_result_ = (g_free (_result_), NULL);
					return result;
				}
				_tmp11_ = _result_;
				_tmp11__length1 = _result__length1;
				_tmp12_ = i;
				_tmp13_ = i;
				_tmp14_ = data[_tmp13_];
				_tmp15_ = shift;
				_tmp11_[_tmp12_ - 1] = _tmp14_ - _tmp15_;
				_tmp16_ = _tmp11_[_tmp12_ - 1];
			}
		}
	}
	_tmp17_ = _result_;
	_tmp17__length1 = _result__length1;
	_tmp18_ = length;
	_tmp17_[_tmp18_] = (guint8) 0;
	_tmp19_ = _tmp17_[_tmp18_];
	_tmp20_ = _result_;
	_tmp20__length1 = _result__length1;
	_tmp21_ = g_strdup ((const gchar*) _tmp20_);
	result = _tmp21_;
	_result_ = (g_free (_result_), NULL);
	return result;
}


/**
 * Return the number of UTF-16 code points to store given string.
 * 
 * It corresponds to JavaScript's String.length.
 * 
 * @param str    a string
 * @return a number of UTF-16 code points
 */
static gboolean
string_get_next_char (const gchar* self,
                      gint* index,
                      gunichar* c)
{
	gunichar _vala_c = 0U;
	gboolean result = FALSE;
	gunichar _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_vala_c = g_utf8_get_char (((gchar*) self) + (*index));
	_tmp0_ = _vala_c;
	if (_tmp0_ != ((gunichar) 0)) {
		gchar* _tmp1_;
		_tmp1_ = g_utf8_next_char (((gchar*) self) + (*index));
		*index = (gint) (_tmp1_ - ((gchar*) self));
		result = TRUE;
		if (c) {
			*c = _vala_c;
		}
		return result;
	} else {
		result = FALSE;
		if (c) {
			*c = _vala_c;
		}
		return result;
	}
	if (c) {
		*c = _vala_c;
	}
}


gint
drt_string_utf16_strlen (const gchar* str)
{
	gint result = 0;
	gint len = 0;
	gunichar c = 0U;
	gint i = 0;
	if (drt_string_is_empty (str)) {
		result = 0;
		return result;
	}
	len = 0;
	c = (gunichar) 0;
	i = 0;
	while (TRUE) {
		gunichar _tmp0_ = 0U;
		gboolean _tmp1_;
		gint _tmp2_ = 0;
		gunichar _tmp3_;
		gint _tmp4_;
		_tmp1_ = string_get_next_char (str, &i, &_tmp0_);
		c = _tmp0_;
		if (!_tmp1_) {
			break;
		}
		_tmp3_ = c;
		if (((guint) _tmp3_) <= ((guint) 0xFFFF)) {
			_tmp2_ = 1;
		} else {
			_tmp2_ = 2;
		}
		_tmp4_ = len;
		len = _tmp4_ + _tmp2_;
	}
	result = len;
	return result;
}


/**
 * Create unowned string at the given offset
 * 
 * @param str       the parent string
 * @param offset    starting offset
 * @return unowned substring starting at given offset
 */
const gchar*
drt_string_offset (const gchar* str,
                   gint offset)
{
	const gchar* result = NULL;
	guint8* pointer = NULL;
	const gchar* _result_ = NULL;
	g_return_val_if_fail (str != NULL, NULL);
	_vala_assert (offset >= 0, "offset >= 0");
	pointer = ((guint8*) str) + offset;
	_result_ = (const gchar*) pointer;
	result = _result_;
	return result;
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



