/* Value.c generated by valac 0.40.6, the Vala compiler
 * generated from Value.vala, do not modify */

/*
 * Copyright 2015 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>

#define _g_free0(var) (var = (g_free (var), NULL))



gchar* drt_value_to_string (GValue* value);
gchar* drt_blobs_bytes_to_string (GBytes* value);
gchar* drt_blobs_byte_array_to_string (GByteArray* value);
gboolean drt_value_equal (GValue* value1,
                          GValue* value2);
gboolean drt_blobs_bytes_equal (GBytes* value1,
                                GBytes* value2);
gboolean drt_blobs_byte_array_equal (GByteArray* value1,
                                     GByteArray* value2);
gchar* drt_value_describe (GValue* value);
gboolean drt_value_equal_verbose (GValue* value1,
                                  GValue* value2,
                                  gchar* * description);


/**
 * Supported types: GLib.Object, GLib.Bytes, GLib.ByteArray, int, uint, int64, uint64, float, double and bool.
 */
static gchar*
bool_to_string (gboolean self)
{
	gchar* result = NULL;
	if (self) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup ("true");
		result = _tmp0_;
		return result;
	} else {
		gchar* _tmp1_;
		_tmp1_ = g_strdup ("false");
		result = _tmp1_;
		return result;
	}
}


static gchar*
double_to_string (gdouble self)
{
	gchar* result = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint _tmp1__length1;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	_tmp0_ = g_new0 (gchar, G_ASCII_DTOSTR_BUF_SIZE);
	_tmp1_ = _tmp0_;
	_tmp1__length1 = G_ASCII_DTOSTR_BUF_SIZE;
	_tmp2_ = g_ascii_dtostr (_tmp1_, G_ASCII_DTOSTR_BUF_SIZE, self);
	_tmp3_ = g_strdup (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp1_ = (g_free (_tmp1_), NULL);
	result = _tmp4_;
	return result;
}


gchar*
drt_value_to_string (GValue* value)
{
	gchar* result = NULL;
	GType type = 0UL;
	GType _tmp0_;
	GType _tmp3_;
	GType _tmp5_;
	GType _tmp7_;
	GType _tmp9_;
	GType _tmp11_;
	GType _tmp14_;
	GType _tmp16_;
	GType _tmp18_;
	GType _tmp20_;
	GType _tmp23_;
	GType _tmp26_;
	GType _tmp29_;
	if (value == NULL) {
		result = NULL;
		return result;
	}
	type = G_VALUE_TYPE (value);
	_tmp0_ = type;
	if (G_TYPE_IS_OBJECT (_tmp0_)) {
		GObject* _tmp1_;
		gchar* _tmp2_;
		_tmp1_ = g_value_get_object (value);
		_tmp2_ = g_strdup_printf ("%p", (void*) _tmp1_);
		result = _tmp2_;
		return result;
	}
	_tmp3_ = type;
	if (_tmp3_ == G_TYPE_INT) {
		gchar* _tmp4_;
		_tmp4_ = g_strdup_printf ("%i", g_value_get_int (value));
		result = _tmp4_;
		return result;
	}
	_tmp5_ = type;
	if (_tmp5_ == G_TYPE_UINT) {
		gchar* _tmp6_;
		_tmp6_ = g_strdup_printf ("%u", g_value_get_uint (value));
		result = _tmp6_;
		return result;
	}
	_tmp7_ = type;
	if (_tmp7_ == G_TYPE_INT64) {
		gchar* _tmp8_;
		_tmp8_ = g_strdup_printf ("%" G_GINT64_FORMAT, g_value_get_int64 (value));
		result = _tmp8_;
		return result;
	}
	_tmp9_ = type;
	if (_tmp9_ == G_TYPE_UINT64) {
		gchar* _tmp10_;
		_tmp10_ = g_strdup_printf ("%" G_GUINT64_FORMAT, g_value_get_uint64 (value));
		result = _tmp10_;
		return result;
	}
	_tmp11_ = type;
	if (_tmp11_ == G_TYPE_STRING) {
		const gchar* _tmp12_;
		gchar* _tmp13_;
		_tmp12_ = g_value_get_string (value);
		_tmp13_ = g_strdup (_tmp12_);
		result = _tmp13_;
		return result;
	}
	_tmp14_ = type;
	if (_tmp14_ == G_TYPE_BOOLEAN) {
		gchar* _tmp15_;
		_tmp15_ = bool_to_string (g_value_get_boolean (value));
		result = _tmp15_;
		return result;
	}
	_tmp16_ = type;
	if (_tmp16_ == G_TYPE_DOUBLE) {
		gchar* _tmp17_;
		_tmp17_ = double_to_string (g_value_get_double (value));
		result = _tmp17_;
		return result;
	}
	_tmp18_ = type;
	if (_tmp18_ == G_TYPE_FLOAT) {
		gchar* _tmp19_;
		_tmp19_ = g_strdup_printf ("%g", g_value_get_float (value));
		result = _tmp19_;
		return result;
	}
	_tmp20_ = type;
	if (_tmp20_ == G_TYPE_BYTES) {
		void* _tmp21_;
		gchar* _tmp22_;
		_tmp21_ = g_value_get_boxed (value);
		_tmp22_ = drt_blobs_bytes_to_string ((GBytes*) _tmp21_);
		result = _tmp22_;
		return result;
	}
	_tmp23_ = type;
	if (_tmp23_ == G_TYPE_BYTE_ARRAY) {
		void* _tmp24_;
		gchar* _tmp25_;
		_tmp24_ = g_value_get_boxed (value);
		_tmp25_ = drt_blobs_byte_array_to_string ((GByteArray*) _tmp24_);
		result = _tmp25_;
		return result;
	}
	_tmp26_ = type;
	if (g_type_is_a (_tmp26_, G_TYPE_BOXED)) {
		void* _tmp27_;
		gchar* _tmp28_;
		_tmp27_ = g_value_get_boxed (value);
		_tmp28_ = g_strdup_printf ("%p", (void*) _tmp27_);
		result = _tmp28_;
		return result;
	}
	_tmp29_ = type;
	if (G_TYPE_IS_CLASSED (_tmp29_)) {
		void* _tmp30_;
		gchar* _tmp31_;
		_tmp30_ = g_value_peek_pointer (value);
		_tmp31_ = g_strdup_printf ("%p", (void*) _tmp30_);
		result = _tmp31_;
		return result;
	}
	result = NULL;
	return result;
}


/**
 * Supported types: GLib.Object, GLib.Bytes, GLib.ByteArray, int, uint, int64, uint64, float, double and bool.
 */
gboolean
drt_value_equal (GValue* value1,
                 GValue* value2)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GType type = 0UL;
	GType _tmp2_;
	GType _tmp3_;
	GType _tmp4_;
	GType _tmp5_;
	GType _tmp6_;
	GType _tmp7_;
	GType _tmp8_;
	GType _tmp11_;
	GType _tmp12_;
	GType _tmp13_;
	GType _tmp16_;
	GType _tmp19_;
	GType _tmp22_;
	if (value1 == NULL) {
		_tmp0_ = value2 == NULL;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		result = TRUE;
		return result;
	}
	if (value1 != NULL) {
		_tmp1_ = value2 != NULL;
	} else {
		_tmp1_ = FALSE;
	}
	if (!_tmp1_) {
		result = FALSE;
		return result;
	}
	type = G_VALUE_TYPE (value1);
	_tmp2_ = type;
	if (_tmp2_ != G_VALUE_TYPE (value2)) {
		result = FALSE;
		return result;
	}
	_tmp3_ = type;
	if (_tmp3_ == G_TYPE_BOOLEAN) {
		result = g_value_get_boolean (value1) == g_value_get_boolean (value2);
		return result;
	}
	_tmp4_ = type;
	if (_tmp4_ == G_TYPE_INT) {
		result = g_value_get_int (value1) == g_value_get_int (value2);
		return result;
	}
	_tmp5_ = type;
	if (_tmp5_ == G_TYPE_UINT) {
		result = g_value_get_uint (value1) == g_value_get_uint (value2);
		return result;
	}
	_tmp6_ = type;
	if (_tmp6_ == G_TYPE_INT64) {
		result = g_value_get_int64 (value1) == g_value_get_int64 (value2);
		return result;
	}
	_tmp7_ = type;
	if (_tmp7_ == G_TYPE_UINT64) {
		result = g_value_get_uint64 (value1) == g_value_get_uint64 (value2);
		return result;
	}
	_tmp8_ = type;
	if (_tmp8_ == G_TYPE_STRING) {
		const gchar* _tmp9_;
		const gchar* _tmp10_;
		_tmp9_ = g_value_get_string (value1);
		_tmp10_ = g_value_get_string (value2);
		result = g_strcmp0 (_tmp9_, _tmp10_) == 0;
		return result;
	}
	_tmp11_ = type;
	if (_tmp11_ == G_TYPE_DOUBLE) {
		result = g_value_get_double (value1) == g_value_get_double (value2);
		return result;
	}
	_tmp12_ = type;
	if (_tmp12_ == G_TYPE_FLOAT) {
		result = g_value_get_float (value1) == g_value_get_float (value2);
		return result;
	}
	_tmp13_ = type;
	if (G_TYPE_IS_OBJECT (_tmp13_)) {
		GObject* _tmp14_;
		GObject* _tmp15_;
		_tmp14_ = g_value_get_object (value1);
		_tmp15_ = g_value_get_object (value2);
		result = _tmp14_ == _tmp15_;
		return result;
	}
	_tmp16_ = type;
	if (_tmp16_ == G_TYPE_BYTES) {
		void* _tmp17_;
		void* _tmp18_;
		_tmp17_ = g_value_get_boxed (value1);
		_tmp18_ = g_value_get_boxed (value2);
		result = drt_blobs_bytes_equal ((GBytes*) _tmp17_, (GBytes*) _tmp18_);
		return result;
	}
	_tmp19_ = type;
	if (_tmp19_ == G_TYPE_BYTE_ARRAY) {
		void* _tmp20_;
		void* _tmp21_;
		_tmp20_ = g_value_get_boxed (value1);
		_tmp21_ = g_value_get_boxed (value2);
		result = drt_blobs_byte_array_equal ((GByteArray*) _tmp20_, (GByteArray*) _tmp21_);
		return result;
	}
	_tmp22_ = type;
	if (g_type_is_a (_tmp22_, G_TYPE_BOXED)) {
		void* _tmp23_;
		void* _tmp24_;
		_tmp23_ = g_value_get_boxed (value1);
		_tmp24_ = g_value_get_boxed (value2);
		result = _tmp23_ == _tmp24_;
		return result;
	}
	g_return_val_if_reached (FALSE);
}


/**
 * Supported types: GLib.Object, GLib.Bytes, GLib.ByteArray, int, uint, int64, uint64, float, double and bool.
 */
gchar*
drt_value_describe (GValue* value)
{
	gchar* result = NULL;
	GType type = 0UL;
	gchar* content = NULL;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	GType _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	if (value == NULL) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup ("<null>");
		result = _tmp0_;
		return result;
	}
	type = G_VALUE_TYPE (value);
	_tmp1_ = drt_value_to_string (value);
	content = _tmp1_;
	_tmp2_ = content;
	if (_tmp2_ != NULL) {
		GType _tmp3_;
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		_tmp3_ = type;
		_tmp4_ = g_type_name (_tmp3_);
		_tmp5_ = content;
		_tmp6_ = g_strdup_printf ("<%s:%s>", _tmp4_, _tmp5_);
		result = _tmp6_;
		_g_free0 (content);
		return result;
	}
	_tmp7_ = type;
	_tmp8_ = g_type_name (_tmp7_);
	_tmp9_ = g_strdup_printf ("<%s>", _tmp8_);
	result = _tmp9_;
	_g_free0 (content);
	return result;
}


/**
 * Supported types: GLib.Object, GLib.Bytes, GLib.ByteArray, int, uint, int64, uint64, float, double and bool.
 */
gboolean
drt_value_equal_verbose (GValue* value1,
                         GValue* value2,
                         gchar* * description)
{
	gchar* _vala_description = NULL;
	gboolean result = FALSE;
	gboolean _result_ = FALSE;
	gboolean _tmp0_;
	_result_ = drt_value_equal (value1, value2);
	_tmp0_ = _result_;
	if (_tmp0_) {
		gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		_tmp1_ = drt_value_describe (value1);
		_tmp2_ = _tmp1_;
		_tmp3_ = g_strdup_printf ("equal %s", _tmp2_);
		_g_free0 (_vala_description);
		_vala_description = _tmp3_;
		_g_free0 (_tmp2_);
	} else {
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		_tmp4_ = drt_value_describe (value1);
		_tmp5_ = _tmp4_;
		_tmp6_ = drt_value_describe (value2);
		_tmp7_ = _tmp6_;
		_tmp8_ = g_strdup_printf ("%s != %s", _tmp5_, _tmp7_);
		_g_free0 (_vala_description);
		_vala_description = _tmp8_;
		_g_free0 (_tmp7_);
		_g_free0 (_tmp5_);
	}
	result = _result_;
	if (description) {
		*description = _vala_description;
	} else {
		_g_free0 (_vala_description);
	}
	return result;
}



