/* Variant.c generated by valac 0.40.6, the Vala compiler
 * generated from Variant.vala, do not modify */

/*
 * Copyright 2014-2016 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_variant_iter_free0(var) ((var == NULL) ? NULL : (var = (g_variant_iter_free (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_variant_type_free0(var) ((var == NULL) ? NULL : (var = (g_variant_type_free (var), NULL)))
#define _g_list_free0(var) ((var == NULL) ? NULL : (var = (g_list_free (var), NULL)))
#define _g_variant_builder_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_builder_unref (var), NULL)))



gboolean drt_variant_equal (GVariant* a,
                            GVariant* b);
gchar** drt_variant_to_strv (GVariant* variant,
                             int* result_length1);
gboolean drt_variant_string (GVariant* variant,
                             gchar* * data);
GVariant** drt_variant_to_array (GVariant* variant,
                                 int* result_length1);
GHashTable* drt_variant_to_hashtable (GVariant* variant);
static void _g_free0_ (gpointer var);
static void _g_variant_unref0_ (gpointer var);
GVariant* drt_variant_from_hashtable (GHashTable* hashtable);
gboolean drt_variant_bool (GVariant* variant,
                           gboolean* _result_);
gchar* drt_variant_dict_str (GVariant* dict,
                             const gchar* key);
gdouble drt_variant_dict_double (GVariant* dict,
                                 const gchar* key,
                                 gdouble default_value);
GVariant* drt_unbox_variant (GVariant* value);
gboolean drt_variant_to_bool (GVariant* value);
gint64 drt_variant_to_int64 (GVariant* value);
gint drt_variant_to_int (GVariant* value);
guint drt_variant_to_uint (GVariant* value);
gdouble drt_variant_to_double (GVariant* value);
gchar* drt_variant_to_string (GVariant* value,
                              const gchar* default_val);
gchar* drt_variant_dump (GVariant* value);
GVariant* drt_new_variant_string_or_null (const gchar* str);
GVariant* drt_strv_to_variant_dict (gchar** args,
                                    int args_length1,
                                    gint offset);
void drt_variant_dict_add_param (GVariantBuilder* dict_builder,
                                 const gchar* key,
                                 const gchar* value);
GVariant* drt_str_table_to_variant_dict (GHashTable* args);
GVariant* g_variant_ref (GVariant* variant);
void g_variant_unref (GVariant* variant);
void drt_variant_ref (GVariant* variant);
void drt_variant_unref (GVariant* variant);
gchar* drt_print_variant (GVariant* variant);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


gboolean
drt_variant_equal (GVariant* a,
                   GVariant* b)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	if (a == NULL) {
		_tmp0_ = b == NULL;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		result = TRUE;
		return result;
	}
	if (a == NULL) {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = b == NULL;
	}
	if (_tmp1_) {
		result = FALSE;
		return result;
	}
	result = g_variant_equal (a, b);
	return result;
}


gchar**
drt_variant_to_strv (GVariant* variant,
                     int* result_length1)
{
	gchar** result = NULL;
	gchar** _result_ = NULL;
	gint _result__length1 = 0;
	gint __result__size_ = 0;
	gboolean _tmp0_ = FALSE;
	gchar** _tmp30_;
	gint _tmp30__length1;
	g_return_val_if_fail (variant != NULL, NULL);
	if (g_variant_is_container (variant)) {
		_tmp0_ = g_variant_n_children (variant) > ((gsize) 0);
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		gsize size = 0UL;
		gsize _tmp1_;
		gchar** _tmp2_;
		size = g_variant_n_children (variant);
		_tmp1_ = size;
		_tmp2_ = g_new0 (gchar*, _tmp1_ + 1);
		_result_ = (_vala_array_free (_result_, _result__length1, (GDestroyNotify) g_free), NULL);
		_result_ = _tmp2_;
		_result__length1 = _tmp1_;
		__result__size_ = _result__length1;
		{
			gsize i = 0UL;
			i = (gsize) 0;
			{
				gboolean _tmp3_ = FALSE;
				_tmp3_ = TRUE;
				while (TRUE) {
					gsize _tmp5_;
					gsize _tmp6_;
					GVariant* child = NULL;
					gsize _tmp7_;
					GVariant* _tmp8_;
					gchar* str = NULL;
					gboolean _tmp9_ = FALSE;
					GVariant* _tmp10_;
					gchar* _tmp11_ = NULL;
					gboolean _tmp12_;
					gchar** _tmp21_;
					gint _tmp21__length1;
					gsize _tmp22_;
					const gchar* _tmp23_;
					gchar* _tmp24_;
					gchar* _tmp25_;
					if (!_tmp3_) {
						gsize _tmp4_;
						_tmp4_ = i;
						i = _tmp4_ + 1;
					}
					_tmp3_ = FALSE;
					_tmp5_ = i;
					_tmp6_ = size;
					if (!(_tmp5_ < _tmp6_)) {
						break;
					}
					_tmp7_ = i;
					_tmp8_ = g_variant_get_child_value (variant, _tmp7_);
					child = _tmp8_;
					_tmp10_ = child;
					_tmp12_ = drt_variant_string (_tmp10_, &_tmp11_);
					_g_free0 (str);
					str = _tmp11_;
					if (!_tmp12_) {
						_tmp9_ = TRUE;
					} else {
						const gchar* _tmp13_;
						_tmp13_ = str;
						_tmp9_ = _tmp13_ == NULL;
					}
					if (_tmp9_) {
						GVariant* _tmp14_;
						const gchar* _tmp15_;
						GVariant* _tmp16_;
						gchar* _tmp17_;
						gchar* _tmp18_;
						GVariant* _tmp19_;
						gchar* _tmp20_;
						_tmp14_ = child;
						_tmp15_ = g_variant_get_type_string (_tmp14_);
						_tmp16_ = child;
						_tmp17_ = g_variant_print (_tmp16_, TRUE);
						_tmp18_ = _tmp17_;
						g_warning ("Variant.vala:50: Wrong child type %s: %s", _tmp15_, _tmp18_);
						_g_free0 (_tmp18_);
						_tmp19_ = child;
						_tmp20_ = g_variant_print (_tmp19_, FALSE);
						_g_free0 (str);
						str = _tmp20_;
					}
					_tmp21_ = _result_;
					_tmp21__length1 = _result__length1;
					_tmp22_ = i;
					_tmp23_ = str;
					_tmp24_ = g_strdup (_tmp23_);
					_g_free0 (_tmp21_[_tmp22_]);
					_tmp21_[_tmp22_] = _tmp24_;
					_tmp25_ = _tmp21_[_tmp22_];
					_g_free0 (str);
					_g_variant_unref0 (child);
				}
			}
		}
	} else {
		gchar** _tmp29_;
		if (!g_variant_is_container (variant)) {
			const gchar* _tmp26_;
			gchar* _tmp27_;
			gchar* _tmp28_;
			_tmp26_ = g_variant_get_type_string (variant);
			_tmp27_ = g_variant_print (variant, TRUE);
			_tmp28_ = _tmp27_;
			g_warning ("Variant.vala:59: Variant is not a container: %s: %s", _tmp26_, _tmp28_);
			_g_free0 (_tmp28_);
		}
		_tmp29_ = g_new0 (gchar*, 0 + 1);
		_result_ = (_vala_array_free (_result_, _result__length1, (GDestroyNotify) g_free), NULL);
		_result_ = _tmp29_;
		_result__length1 = 0;
		__result__size_ = _result__length1;
	}
	_tmp30_ = _result_;
	_tmp30__length1 = _result__length1;
	if (result_length1) {
		*result_length1 = _tmp30__length1;
	}
	result = _tmp30_;
	return result;
}


static gpointer
_g_variant_ref0 (gpointer self)
{
	return self ? g_variant_ref (self) : NULL;
}


GVariant**
drt_variant_to_array (GVariant* variant,
                      int* result_length1)
{
	GVariant** result = NULL;
	GVariant** _result_ = NULL;
	gint _result__length1 = 0;
	gint __result__size_ = 0;
	gboolean _tmp0_ = FALSE;
	GVariant** _tmp19_;
	gint _tmp19__length1;
	g_return_val_if_fail (variant != NULL, NULL);
	if (g_variant_is_container (variant)) {
		_tmp0_ = g_variant_n_children (variant) > ((gsize) 0);
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		gsize size = 0UL;
		gsize _tmp1_;
		GVariant** _tmp2_;
		size = g_variant_n_children (variant);
		_tmp1_ = size;
		_tmp2_ = g_new0 (GVariant*, _tmp1_ + 1);
		_result_ = (_vala_array_free (_result_, _result__length1, (GDestroyNotify) g_variant_unref), NULL);
		_result_ = _tmp2_;
		_result__length1 = _tmp1_;
		__result__size_ = _result__length1;
		{
			gsize i = 0UL;
			i = (gsize) 0;
			{
				gboolean _tmp3_ = FALSE;
				_tmp3_ = TRUE;
				while (TRUE) {
					gsize _tmp5_;
					gsize _tmp6_;
					GVariant* val = NULL;
					gsize _tmp7_;
					GVariant* _tmp8_;
					GVariant* _tmp9_;
					const GVariantType* _tmp10_;
					GVariant** _tmp13_;
					gint _tmp13__length1;
					gsize _tmp14_;
					GVariant* _tmp15_;
					GVariant* _tmp16_;
					GVariant* _tmp17_;
					if (!_tmp3_) {
						gsize _tmp4_;
						_tmp4_ = i;
						i = _tmp4_ + 1;
					}
					_tmp3_ = FALSE;
					_tmp5_ = i;
					_tmp6_ = size;
					if (!(_tmp5_ < _tmp6_)) {
						break;
					}
					_tmp7_ = i;
					_tmp8_ = g_variant_get_child_value (variant, _tmp7_);
					val = _tmp8_;
					_tmp9_ = val;
					_tmp10_ = G_VARIANT_TYPE_VARIANT;
					if (g_variant_is_of_type (_tmp9_, _tmp10_)) {
						GVariant* _tmp11_;
						GVariant* _tmp12_;
						_tmp11_ = val;
						_tmp12_ = g_variant_get_variant (_tmp11_);
						_g_variant_unref0 (val);
						val = _tmp12_;
					}
					_tmp13_ = _result_;
					_tmp13__length1 = _result__length1;
					_tmp14_ = i;
					_tmp15_ = val;
					_tmp16_ = _g_variant_ref0 (_tmp15_);
					_g_variant_unref0 (_tmp13_[_tmp14_]);
					_tmp13_[_tmp14_] = _tmp16_;
					_tmp17_ = _tmp13_[_tmp14_];
					_g_variant_unref0 (val);
				}
			}
		}
	} else {
		GVariant** _tmp18_;
		_tmp18_ = g_new0 (GVariant*, 0 + 1);
		_result_ = (_vala_array_free (_result_, _result__length1, (GDestroyNotify) g_variant_unref), NULL);
		_result_ = _tmp18_;
		_result__length1 = 0;
		__result__size_ = _result__length1;
	}
	_tmp19_ = _result_;
	_tmp19__length1 = _result__length1;
	if (result_length1) {
		*result_length1 = _tmp19__length1;
	}
	result = _tmp19_;
	return result;
}


static void
_g_free0_ (gpointer var)
{
	var = (g_free (var), NULL);
}


static void
_g_variant_unref0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (g_variant_unref (var), NULL));
}


GHashTable*
drt_variant_to_hashtable (GVariant* variant)
{
	GHashTable* result = NULL;
	GHashTable* _result_ = NULL;
	GHashFunc _tmp0_;
	GEqualFunc _tmp1_;
	GHashTable* _tmp2_;
	gboolean _tmp3_ = FALSE;
	_tmp0_ = g_str_hash;
	_tmp1_ = g_str_equal;
	_tmp2_ = g_hash_table_new_full (_tmp0_, _tmp1_, _g_free0_, _g_variant_unref0_);
	_result_ = _tmp2_;
	if (variant != NULL) {
		const GVariantType* _tmp4_;
		_tmp4_ = G_VARIANT_TYPE_DICTIONARY;
		_tmp3_ = g_variant_is_of_type (variant, _tmp4_);
	} else {
		_tmp3_ = FALSE;
	}
	if (_tmp3_) {
		GVariantIter* iter = NULL;
		GVariantIter* _tmp5_;
		GVariant* val = NULL;
		gchar* key = NULL;
		_tmp5_ = g_variant_iter_new (variant);
		iter = _tmp5_;
		val = NULL;
		key = NULL;
		while (TRUE) {
			GVariantIter* _tmp6_;
			const gchar* _tmp7_;
			_tmp6_ = iter;
			if (!g_variant_iter_next (_tmp6_, "{s*}", &key, &val, NULL)) {
				break;
			}
			_tmp7_ = key;
			if (_tmp7_ != NULL) {
				GVariant* _tmp8_;
				const GVariantType* _tmp9_;
				GVariant* _tmp12_;
				const GVariantType* _tmp13_;
				GHashTable* _tmp16_;
				const gchar* _tmp17_;
				gchar* _tmp18_;
				GVariant* _tmp19_;
				GVariant* _tmp20_;
				_tmp8_ = val;
				_tmp9_ = G_VARIANT_TYPE_MAYBE;
				if (g_variant_is_of_type (_tmp8_, _tmp9_)) {
					GVariant* _tmp10_;
					GVariant* _tmp11_;
					_tmp10_ = val;
					_tmp11_ = g_variant_get_maybe (_tmp10_);
					_g_variant_unref0 (val);
					val = _tmp11_;
				}
				_tmp12_ = val;
				_tmp13_ = G_VARIANT_TYPE_VARIANT;
				if (g_variant_is_of_type (_tmp12_, _tmp13_)) {
					GVariant* _tmp14_;
					GVariant* _tmp15_;
					_tmp14_ = val;
					_tmp15_ = g_variant_get_variant (_tmp14_);
					_g_variant_unref0 (val);
					val = _tmp15_;
				}
				_tmp16_ = _result_;
				_tmp17_ = key;
				_tmp18_ = g_strdup (_tmp17_);
				_tmp19_ = val;
				_tmp20_ = _g_variant_ref0 (_tmp19_);
				g_hash_table_insert (_tmp16_, _tmp18_, _tmp20_);
			}
		}
		_g_free0 (key);
		_g_variant_unref0 (val);
		_g_variant_iter_free0 (iter);
	} else {
		if (variant != NULL) {
			const gchar* _tmp21_;
			gchar* _tmp22_;
			gchar* _tmp23_;
			_tmp21_ = g_variant_get_type_string (variant);
			_tmp22_ = g_variant_print (variant, TRUE);
			_tmp23_ = _tmp22_;
			g_critical ("Variant.vala:110: Wrong type: %s %s", _tmp21_, _tmp23_);
			_g_free0 (_tmp23_);
		}
	}
	result = _result_;
	return result;
}


GVariant*
drt_variant_from_hashtable (GHashTable* hashtable)
{
	GVariant* result = NULL;
	GVariantBuilder* builder = NULL;
	GVariantType* _tmp0_;
	GVariantType* _tmp1_;
	GVariantBuilder* _tmp2_;
	GVariantBuilder* _tmp3_;
	GList* _tmp4_;
	GVariantBuilder* _tmp9_;
	GVariant* _tmp10_;
	g_return_val_if_fail (hashtable != NULL, NULL);
	_tmp0_ = g_variant_type_new ("a{sv}");
	_tmp1_ = _tmp0_;
	_tmp2_ = g_variant_builder_new (_tmp1_);
	_tmp3_ = _tmp2_;
	_g_variant_type_free0 (_tmp1_);
	builder = _tmp3_;
	_tmp4_ = g_hash_table_get_keys (hashtable);
	{
		GList* key_collection = NULL;
		GList* key_it = NULL;
		key_collection = _tmp4_;
		for (key_it = key_collection; key_it != NULL; key_it = key_it->next) {
			const gchar* key = NULL;
			key = (const gchar*) key_it->data;
			{
				GVariantBuilder* _tmp5_;
				const gchar* _tmp6_;
				const gchar* _tmp7_;
				gconstpointer _tmp8_;
				_tmp5_ = builder;
				_tmp6_ = key;
				_tmp7_ = key;
				_tmp8_ = g_hash_table_lookup (hashtable, _tmp7_);
				g_variant_builder_add (_tmp5_, "{sv}", _tmp6_, (GVariant*) _tmp8_, NULL);
			}
		}
		_g_list_free0 (key_collection);
	}
	_tmp9_ = builder;
	_tmp10_ = g_variant_builder_end (_tmp9_);
	g_variant_ref_sink (_tmp10_);
	result = _tmp10_;
	_g_variant_builder_unref0 (builder);
	return result;
}


/**
 * Extract string from variant with unboxing and data type checking.
 */
gboolean
drt_variant_string (GVariant* variant,
                    gchar* * data)
{
	gchar* _vala_data = NULL;
	gboolean result = FALSE;
	const GVariantType* _tmp0_;
	const GVariantType* _tmp3_;
	const GVariantType* _tmp4_;
	const GVariantType* _tmp9_;
	g_return_val_if_fail (variant != NULL, FALSE);
	_tmp0_ = G_VARIANT_TYPE_STRING;
	if (g_variant_is_of_type (variant, _tmp0_)) {
		const gchar* _tmp1_;
		gchar* _tmp2_;
		_tmp1_ = g_variant_get_string (variant, NULL);
		_tmp2_ = g_strdup (_tmp1_);
		_g_free0 (_vala_data);
		_vala_data = _tmp2_;
		result = TRUE;
		if (data) {
			*data = _vala_data;
		} else {
			_g_free0 (_vala_data);
		}
		return result;
	}
	_tmp3_ = g_variant_get_type (variant);
	_tmp4_ = G_VARIANT_TYPE_MAYBE;
	if (g_variant_type_is_subtype_of (_tmp3_, _tmp4_)) {
		GVariant* maybe_variant = NULL;
		GVariant* _tmp5_;
		GVariant* _tmp6_;
		gchar* _tmp7_ = NULL;
		gboolean _tmp8_;
		maybe_variant = NULL;
		g_variant_get (variant, "m*", &maybe_variant, NULL);
		_tmp5_ = maybe_variant;
		if (_tmp5_ == NULL) {
			_g_free0 (_vala_data);
			_vala_data = NULL;
			result = TRUE;
			_g_variant_unref0 (maybe_variant);
			if (data) {
				*data = _vala_data;
			} else {
				_g_free0 (_vala_data);
			}
			return result;
		}
		_tmp6_ = maybe_variant;
		_tmp8_ = drt_variant_string (_tmp6_, &_tmp7_);
		_g_free0 (_vala_data);
		_vala_data = _tmp7_;
		result = _tmp8_;
		_g_variant_unref0 (maybe_variant);
		if (data) {
			*data = _vala_data;
		} else {
			_g_free0 (_vala_data);
		}
		return result;
	}
	_tmp9_ = G_VARIANT_TYPE_VARIANT;
	if (g_variant_is_of_type (variant, _tmp9_)) {
		GVariant* _tmp10_;
		GVariant* _tmp11_;
		gchar* _tmp12_ = NULL;
		gboolean _tmp13_;
		gboolean _tmp14_;
		_tmp10_ = g_variant_get_variant (variant);
		_tmp11_ = _tmp10_;
		_tmp13_ = drt_variant_string (_tmp11_, &_tmp12_);
		_g_free0 (_vala_data);
		_vala_data = _tmp12_;
		_tmp14_ = _tmp13_;
		_g_variant_unref0 (_tmp11_);
		result = _tmp14_;
		if (data) {
			*data = _vala_data;
		} else {
			_g_free0 (_vala_data);
		}
		return result;
	}
	_g_free0 (_vala_data);
	_vala_data = NULL;
	result = FALSE;
	if (data) {
		*data = _vala_data;
	} else {
		_g_free0 (_vala_data);
	}
	return result;
}


gboolean
drt_variant_bool (GVariant* variant,
                  gboolean* _result_)
{
	gboolean result = FALSE;
	const GVariantType* _tmp0_;
	const GVariantType* _tmp1_;
	const GVariantType* _tmp2_;
	const GVariantType* _tmp5_;
	if (variant == NULL) {
		result = FALSE;
		return result;
	}
	_tmp0_ = G_VARIANT_TYPE_BOOLEAN;
	if (g_variant_is_of_type (variant, _tmp0_)) {
		*_result_ = g_variant_get_boolean (variant);
		result = TRUE;
		return result;
	}
	_tmp1_ = g_variant_get_type (variant);
	_tmp2_ = G_VARIANT_TYPE_MAYBE;
	if (g_variant_type_is_subtype_of (_tmp1_, _tmp2_)) {
		GVariant* maybe_variant = NULL;
		GVariant* _tmp3_;
		gboolean _tmp4_;
		maybe_variant = NULL;
		g_variant_get (variant, "m*", &maybe_variant, NULL);
		_tmp3_ = maybe_variant;
		_tmp4_ = drt_variant_bool (_tmp3_, _result_);
		result = _tmp4_;
		_g_variant_unref0 (maybe_variant);
		return result;
	}
	_tmp5_ = G_VARIANT_TYPE_VARIANT;
	if (g_variant_is_of_type (variant, _tmp5_)) {
		GVariant* _tmp6_;
		GVariant* _tmp7_;
		gboolean _tmp8_;
		gboolean _tmp9_;
		_tmp6_ = g_variant_get_variant (variant);
		_tmp7_ = _tmp6_;
		_tmp8_ = drt_variant_bool (_tmp7_, _result_);
		_tmp9_ = _tmp8_;
		_g_variant_unref0 (_tmp7_);
		result = _tmp9_;
		return result;
	}
	result = FALSE;
	return result;
}


gchar*
drt_variant_dict_str (GVariant* dict,
                      const gchar* key)
{
	gchar* result = NULL;
	GVariant* val = NULL;
	GVariant* _tmp0_;
	GVariant* _tmp1_;
	GVariant* _tmp2_;
	const GVariantType* _tmp3_;
	GVariant* _tmp7_;
	const GVariantType* _tmp8_;
	GVariant* _tmp11_;
	const GVariantType* _tmp12_;
	g_return_val_if_fail (dict != NULL, NULL);
	g_return_val_if_fail (key != NULL, NULL);
	_tmp0_ = g_variant_lookup_value (dict, key, NULL);
	val = _tmp0_;
	_tmp1_ = val;
	if (_tmp1_ == NULL) {
		result = NULL;
		_g_variant_unref0 (val);
		return result;
	}
	_tmp2_ = val;
	_tmp3_ = G_VARIANT_TYPE_MAYBE;
	if (g_variant_is_of_type (_tmp2_, _tmp3_)) {
		GVariant* _tmp4_;
		GVariant* _tmp5_;
		GVariant* _tmp6_;
		_tmp4_ = val;
		_tmp5_ = g_variant_get_maybe (_tmp4_);
		_g_variant_unref0 (val);
		val = _tmp5_;
		_tmp6_ = val;
		if (_tmp6_ == NULL) {
			result = NULL;
			_g_variant_unref0 (val);
			return result;
		}
	}
	_tmp7_ = val;
	_tmp8_ = G_VARIANT_TYPE_VARIANT;
	if (g_variant_is_of_type (_tmp7_, _tmp8_)) {
		GVariant* _tmp9_;
		GVariant* _tmp10_;
		_tmp9_ = val;
		_tmp10_ = g_variant_get_variant (_tmp9_);
		_g_variant_unref0 (val);
		val = _tmp10_;
	}
	_tmp11_ = val;
	_tmp12_ = G_VARIANT_TYPE_STRING;
	if (g_variant_is_of_type (_tmp11_, _tmp12_)) {
		GVariant* _tmp13_;
		const gchar* _tmp14_;
		gchar* _tmp15_;
		_tmp13_ = val;
		_tmp14_ = g_variant_get_string (_tmp13_, NULL);
		_tmp15_ = g_strdup (_tmp14_);
		result = _tmp15_;
		_g_variant_unref0 (val);
		return result;
	}
	result = NULL;
	_g_variant_unref0 (val);
	return result;
}


gdouble
drt_variant_dict_double (GVariant* dict,
                         const gchar* key,
                         gdouble default_value)
{
	gdouble result = 0.0;
	GVariant* val = NULL;
	GVariant* _tmp0_;
	GVariant* _tmp1_;
	GVariant* _tmp2_;
	const GVariantType* _tmp3_;
	GVariant* _tmp7_;
	const GVariantType* _tmp8_;
	GVariant* _tmp11_;
	const GVariantType* _tmp12_;
	g_return_val_if_fail (dict != NULL, 0.0);
	g_return_val_if_fail (key != NULL, 0.0);
	_tmp0_ = g_variant_lookup_value (dict, key, NULL);
	val = _tmp0_;
	_tmp1_ = val;
	if (_tmp1_ == NULL) {
		result = default_value;
		_g_variant_unref0 (val);
		return result;
	}
	_tmp2_ = val;
	_tmp3_ = G_VARIANT_TYPE_MAYBE;
	if (g_variant_is_of_type (_tmp2_, _tmp3_)) {
		GVariant* _tmp4_;
		GVariant* _tmp5_;
		GVariant* _tmp6_;
		_tmp4_ = val;
		_tmp5_ = g_variant_get_maybe (_tmp4_);
		_g_variant_unref0 (val);
		val = _tmp5_;
		_tmp6_ = val;
		if (_tmp6_ == NULL) {
			result = default_value;
			_g_variant_unref0 (val);
			return result;
		}
	}
	_tmp7_ = val;
	_tmp8_ = G_VARIANT_TYPE_VARIANT;
	if (g_variant_is_of_type (_tmp7_, _tmp8_)) {
		GVariant* _tmp9_;
		GVariant* _tmp10_;
		_tmp9_ = val;
		_tmp10_ = g_variant_get_variant (_tmp9_);
		_g_variant_unref0 (val);
		val = _tmp10_;
	}
	_tmp11_ = val;
	_tmp12_ = G_VARIANT_TYPE_DOUBLE;
	if (g_variant_is_of_type (_tmp11_, _tmp12_)) {
		GVariant* _tmp13_;
		_tmp13_ = val;
		result = g_variant_get_double (_tmp13_);
		_g_variant_unref0 (val);
		return result;
	}
	result = default_value;
	_g_variant_unref0 (val);
	return result;
}


/**
 * Unboxes variant value.
 * 
 *  * Null maybe variant is converted to null.
 *  * Child value is returned for values of type variant.
 * 
 * @param value    value to unbox
 * @return unboxed value or null
 */
GVariant*
drt_unbox_variant (GVariant* value)
{
	GVariant* result = NULL;
	const GVariantType* _tmp0_;
	const GVariantType* _tmp1_;
	const GVariantType* _tmp4_;
	GVariant* _tmp9_;
	if (value == NULL) {
		result = NULL;
		return result;
	}
	_tmp0_ = g_variant_get_type (value);
	_tmp1_ = G_VARIANT_TYPE_MAYBE;
	if (g_variant_type_is_subtype_of (_tmp0_, _tmp1_)) {
		GVariant* maybe_variant = NULL;
		GVariant* _tmp2_;
		GVariant* _tmp3_;
		maybe_variant = NULL;
		g_variant_get (value, "m*", &maybe_variant, NULL);
		_tmp2_ = maybe_variant;
		_tmp3_ = drt_unbox_variant (_tmp2_);
		result = _tmp3_;
		_g_variant_unref0 (maybe_variant);
		return result;
	}
	_tmp4_ = G_VARIANT_TYPE_VARIANT;
	if (g_variant_is_of_type (value, _tmp4_)) {
		GVariant* _tmp5_;
		GVariant* _tmp6_;
		GVariant* _tmp7_;
		GVariant* _tmp8_;
		_tmp5_ = g_variant_get_variant (value);
		_tmp6_ = _tmp5_;
		_tmp7_ = drt_unbox_variant (_tmp6_);
		_tmp8_ = _tmp7_;
		_g_variant_unref0 (_tmp6_);
		result = _tmp8_;
		return result;
	}
	_tmp9_ = _g_variant_ref0 (value);
	result = _tmp9_;
	return result;
}


/**
 * Converts any Variant value to boolean.
 * 
 * @param value    value to convert
 * @return actual boolean value if the value is of type boolean, false otherwise
 */
gboolean
drt_variant_to_bool (GVariant* value)
{
	gboolean result = FALSE;
	GVariant* unboxed = NULL;
	GVariant* _tmp0_;
	gboolean _tmp1_ = FALSE;
	GVariant* _tmp2_;
	_tmp0_ = drt_unbox_variant (value);
	unboxed = _tmp0_;
	_tmp2_ = unboxed;
	if (_tmp2_ != NULL) {
		GVariant* _tmp3_;
		const GVariantType* _tmp4_;
		_tmp3_ = unboxed;
		_tmp4_ = G_VARIANT_TYPE_BOOLEAN;
		_tmp1_ = g_variant_is_of_type (_tmp3_, _tmp4_);
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		GVariant* _tmp5_;
		_tmp5_ = unboxed;
		result = g_variant_get_boolean (_tmp5_);
		_g_variant_unref0 (unboxed);
		return result;
	}
	result = FALSE;
	_g_variant_unref0 (unboxed);
	return result;
}


/**
 * Converts any Variant value to int64.
 * 
 * @param value    value to convert
 * @return actual int64 value if the value is of type int64, zero otherwise
 */
gint64
drt_variant_to_int64 (GVariant* value)
{
	gint64 result = 0LL;
	GVariant* unboxed = NULL;
	GVariant* _tmp0_;
	gboolean _tmp1_ = FALSE;
	GVariant* _tmp2_;
	_tmp0_ = drt_unbox_variant (value);
	unboxed = _tmp0_;
	_tmp2_ = unboxed;
	if (_tmp2_ != NULL) {
		GVariant* _tmp3_;
		const GVariantType* _tmp4_;
		_tmp3_ = unboxed;
		_tmp4_ = G_VARIANT_TYPE_INT64;
		_tmp1_ = g_variant_is_of_type (_tmp3_, _tmp4_);
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		GVariant* _tmp5_;
		_tmp5_ = unboxed;
		result = g_variant_get_int64 (_tmp5_);
		_g_variant_unref0 (unboxed);
		return result;
	}
	result = (gint64) 0;
	_g_variant_unref0 (unboxed);
	return result;
}


/**
 * Converts any Variant value to int.
 * 
 * @param value    value to convert
 * @return actual int value if the value is of type int, zero otherwise
 */
gint
drt_variant_to_int (GVariant* value)
{
	gint result = 0;
	GVariant* unboxed = NULL;
	GVariant* _tmp0_;
	gboolean _tmp1_ = FALSE;
	GVariant* _tmp2_;
	gboolean _tmp6_ = FALSE;
	GVariant* _tmp7_;
	_tmp0_ = drt_unbox_variant (value);
	unboxed = _tmp0_;
	_tmp2_ = unboxed;
	if (_tmp2_ != NULL) {
		GVariant* _tmp3_;
		const GVariantType* _tmp4_;
		_tmp3_ = unboxed;
		_tmp4_ = G_VARIANT_TYPE_INT32;
		_tmp1_ = g_variant_is_of_type (_tmp3_, _tmp4_);
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		GVariant* _tmp5_;
		_tmp5_ = unboxed;
		result = (gint) g_variant_get_int32 (_tmp5_);
		_g_variant_unref0 (unboxed);
		return result;
	}
	_tmp7_ = unboxed;
	if (_tmp7_ != NULL) {
		GVariant* _tmp8_;
		const GVariantType* _tmp9_;
		_tmp8_ = unboxed;
		_tmp9_ = G_VARIANT_TYPE_INT64;
		_tmp6_ = g_variant_is_of_type (_tmp8_, _tmp9_);
	} else {
		_tmp6_ = FALSE;
	}
	if (_tmp6_) {
		GVariant* _tmp10_;
		_tmp10_ = unboxed;
		result = (gint) g_variant_get_int64 (_tmp10_);
		_g_variant_unref0 (unboxed);
		return result;
	}
	result = 0;
	_g_variant_unref0 (unboxed);
	return result;
}


/**
 * Converts any Variant value to uint.
 * 
 * @param value    value to convert
 * @return actual uint value if the value is of type uint, zero otherwise
 */
guint
drt_variant_to_uint (GVariant* value)
{
	guint result = 0U;
	GVariant* unboxed = NULL;
	GVariant* _tmp0_;
	gboolean _tmp1_ = FALSE;
	GVariant* _tmp2_;
	gboolean _tmp6_ = FALSE;
	GVariant* _tmp7_;
	_tmp0_ = drt_unbox_variant (value);
	unboxed = _tmp0_;
	_tmp2_ = unboxed;
	if (_tmp2_ != NULL) {
		GVariant* _tmp3_;
		const GVariantType* _tmp4_;
		_tmp3_ = unboxed;
		_tmp4_ = G_VARIANT_TYPE_UINT32;
		_tmp1_ = g_variant_is_of_type (_tmp3_, _tmp4_);
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		GVariant* _tmp5_;
		_tmp5_ = unboxed;
		result = (guint) g_variant_get_uint32 (_tmp5_);
		_g_variant_unref0 (unboxed);
		return result;
	}
	_tmp7_ = unboxed;
	if (_tmp7_ != NULL) {
		GVariant* _tmp8_;
		const GVariantType* _tmp9_;
		_tmp8_ = unboxed;
		_tmp9_ = G_VARIANT_TYPE_UINT64;
		_tmp6_ = g_variant_is_of_type (_tmp8_, _tmp9_);
	} else {
		_tmp6_ = FALSE;
	}
	if (_tmp6_) {
		GVariant* _tmp10_;
		_tmp10_ = unboxed;
		result = (guint) g_variant_get_uint64 (_tmp10_);
		_g_variant_unref0 (unboxed);
		return result;
	}
	result = (guint) 0;
	_g_variant_unref0 (unboxed);
	return result;
}


/**
 * Converts any Variant value to double.
 * 
 * @param value    value to convert
 * @return actual double value if the value is of type double or int64, 0.0 otherwise
 */
gdouble
drt_variant_to_double (GVariant* value)
{
	gdouble result = 0.0;
	GVariant* unboxed = NULL;
	GVariant* _tmp0_;
	GVariant* _tmp1_;
	_tmp0_ = drt_unbox_variant (value);
	unboxed = _tmp0_;
	_tmp1_ = unboxed;
	if (_tmp1_ != NULL) {
		GVariant* _tmp2_;
		const GVariantType* _tmp3_;
		GVariant* _tmp5_;
		const GVariantType* _tmp6_;
		_tmp2_ = unboxed;
		_tmp3_ = G_VARIANT_TYPE_DOUBLE;
		if (g_variant_is_of_type (_tmp2_, _tmp3_)) {
			GVariant* _tmp4_;
			_tmp4_ = unboxed;
			result = g_variant_get_double (_tmp4_);
			_g_variant_unref0 (unboxed);
			return result;
		}
		_tmp5_ = unboxed;
		_tmp6_ = G_VARIANT_TYPE_INT64;
		if (g_variant_is_of_type (_tmp5_, _tmp6_)) {
			GVariant* _tmp7_;
			_tmp7_ = unboxed;
			result = (gdouble) g_variant_get_int64 (_tmp7_);
			_g_variant_unref0 (unboxed);
			return result;
		}
	}
	result = 0.0;
	_g_variant_unref0 (unboxed);
	return result;
}


/**
 * Converts any Variant value to string.
 * 
 * @param value      value to convert
 * @param default_val    default value (usually null or empty string)
 * @return actual string value if the value is of type string, default value otherwise
 */
gchar*
drt_variant_to_string (GVariant* value,
                       const gchar* default_val)
{
	gchar* result = NULL;
	GVariant* unboxed = NULL;
	GVariant* _tmp0_;
	gboolean _tmp1_ = FALSE;
	GVariant* _tmp2_;
	gchar* _tmp8_;
	_tmp0_ = drt_unbox_variant (value);
	unboxed = _tmp0_;
	_tmp2_ = unboxed;
	if (_tmp2_ != NULL) {
		GVariant* _tmp3_;
		const GVariantType* _tmp4_;
		_tmp3_ = unboxed;
		_tmp4_ = G_VARIANT_TYPE_STRING;
		_tmp1_ = g_variant_is_of_type (_tmp3_, _tmp4_);
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		GVariant* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		_tmp5_ = unboxed;
		_tmp6_ = g_variant_get_string (_tmp5_, NULL);
		_tmp7_ = g_strdup (_tmp6_);
		result = _tmp7_;
		_g_variant_unref0 (unboxed);
		return result;
	}
	_tmp8_ = g_strdup (default_val);
	result = _tmp8_;
	_g_variant_unref0 (unboxed);
	return result;
}


/**
 * Dump variant as a string or return null.
 * 
 * @param value    Variant value.
 * @return null if `value` is null, the variant value as a string otherwise
 */
inline gchar*
drt_variant_dump (GVariant* value)
{
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	if (value == NULL) {
		_g_free0 (_tmp0_);
		_tmp0_ = NULL;
	} else {
		gchar* _tmp1_;
		_tmp1_ = g_variant_print (value, TRUE);
		_g_free0 (_tmp0_);
		_tmp0_ = _tmp1_;
	}
	result = _tmp0_;
	return result;
}


GVariant*
drt_new_variant_string_or_null (const gchar* str)
{
	GVariant* result = NULL;
	GVariant* _tmp0_;
	if (str == NULL) {
		result = NULL;
		return result;
	}
	_tmp0_ = g_variant_new_string (str);
	g_variant_ref_sink (_tmp0_);
	result = _tmp0_;
	return result;
}


/**
 * Converts string array to Variant dictionary
 * 
 * The string array entries must follow this format: "[x:]key=value", where
 * `key` is the dictionary key, `x` is the type specifier and `value` is the dictionary value.
 * 
 * The type specifiers are:
 * 
 *   *  `d` - double
 *   *  `b` - boolean
 *   *  `s` - string
 * 
 * If the specifier is omitted, the default type is string.
 * 
 * @param args      array of `[x:]key=value` strings
 * @param offset    the offset of the first param
 * @return `null` if `args` is `null` or `offset` is invalid, Variant dict otherwise
 */
GVariant*
drt_strv_to_variant_dict (gchar** args,
                          int args_length1,
                          gint offset)
{
	GVariant* result = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GVariantBuilder* builder = NULL;
	GVariantType* _tmp2_;
	GVariantType* _tmp3_;
	GVariantBuilder* _tmp4_;
	GVariantBuilder* _tmp5_;
	GVariantBuilder* _tmp24_;
	GVariant* _tmp25_;
	if (args == NULL) {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = offset < 0;
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = offset >= args_length1;
	}
	if (_tmp0_) {
		result = NULL;
		return result;
	}
	_tmp2_ = g_variant_type_new ("a{smv}");
	_tmp3_ = _tmp2_;
	_tmp4_ = g_variant_builder_new (_tmp3_);
	_tmp5_ = _tmp4_;
	_g_variant_type_free0 (_tmp3_);
	builder = _tmp5_;
	{
		gint i = 0;
		i = offset;
		{
			gboolean _tmp6_ = FALSE;
			_tmp6_ = TRUE;
			while (TRUE) {
				gint _tmp8_;
				gchar* arg = NULL;
				gint _tmp9_;
				const gchar* _tmp10_;
				gchar* _tmp11_;
				gchar** arg_parts = NULL;
				const gchar* _tmp12_;
				gchar** _tmp13_;
				gchar** _tmp14_;
				gint arg_parts_length1;
				gint _arg_parts_size_;
				const gchar* key = NULL;
				gchar** _tmp15_;
				gint _tmp15__length1;
				const gchar* _tmp16_;
				const gchar* _tmp17_ = NULL;
				gchar** _tmp18_;
				gint _tmp18__length1;
				const gchar* value = NULL;
				GVariantBuilder* _tmp21_;
				const gchar* _tmp22_;
				const gchar* _tmp23_;
				if (!_tmp6_) {
					gint _tmp7_;
					_tmp7_ = i;
					i = _tmp7_ + 1;
				}
				_tmp6_ = FALSE;
				_tmp8_ = i;
				if (!(_tmp8_ < args_length1)) {
					break;
				}
				_tmp9_ = i;
				_tmp10_ = args[_tmp9_];
				_tmp11_ = g_strdup (_tmp10_);
				arg = _tmp11_;
				_tmp12_ = arg;
				_tmp14_ = _tmp13_ = g_strsplit (_tmp12_, "=", 2);
				arg_parts = _tmp14_;
				arg_parts_length1 = _vala_array_length (_tmp13_);
				_arg_parts_size_ = arg_parts_length1;
				_tmp15_ = arg_parts;
				_tmp15__length1 = arg_parts_length1;
				_tmp16_ = _tmp15_[0];
				key = _tmp16_;
				_tmp18_ = arg_parts;
				_tmp18__length1 = arg_parts_length1;
				if (_tmp18__length1 == 2) {
					gchar** _tmp19_;
					gint _tmp19__length1;
					const gchar* _tmp20_;
					_tmp19_ = arg_parts;
					_tmp19__length1 = arg_parts_length1;
					_tmp20_ = _tmp19_[1];
					_tmp17_ = _tmp20_;
				} else {
					_tmp17_ = NULL;
				}
				value = _tmp17_;
				_tmp21_ = builder;
				_tmp22_ = key;
				_tmp23_ = value;
				drt_variant_dict_add_param (_tmp21_, _tmp22_, _tmp23_);
				arg_parts = (_vala_array_free (arg_parts, arg_parts_length1, (GDestroyNotify) g_free), NULL);
				_g_free0 (arg);
			}
		}
	}
	_tmp24_ = builder;
	_tmp25_ = g_variant_builder_end (_tmp24_);
	g_variant_ref_sink (_tmp25_);
	result = _tmp25_;
	_g_variant_builder_unref0 (builder);
	return result;
}


/**
 * Converts a HashTable with both string keys and values to Variant dictionary
 * 
 * The table keys must follow this format: "[x:]key", where `key` is the dictionary key and `x` is the type
 * specifier:
 * 
 *   *  `d` - double
 *   *  `b` - boolean
 *   *  `s` - string
 * 
 * If the specifier is omitted, the default type is string.
 * 
 * @param args      hash table of `[x:]key` = `value` pairs
 * @return `null` if `args` is `null`, Variant dict otherwise
 */
GVariant*
drt_str_table_to_variant_dict (GHashTable* args)
{
	GVariant* result = NULL;
	GVariantBuilder* builder = NULL;
	GVariantType* _tmp0_;
	GVariantType* _tmp1_;
	GVariantBuilder* _tmp2_;
	GVariantBuilder* _tmp3_;
	GHashTableIter iter = {0};
	const gchar* key = NULL;
	const gchar* value = NULL;
	GVariantBuilder* _tmp10_;
	GVariant* _tmp11_;
	if (args == NULL) {
		result = NULL;
		return result;
	}
	_tmp0_ = g_variant_type_new ("a{smv}");
	_tmp1_ = _tmp0_;
	_tmp2_ = g_variant_builder_new (_tmp1_);
	_tmp3_ = _tmp2_;
	_g_variant_type_free0 (_tmp1_);
	builder = _tmp3_;
	g_hash_table_iter_init (&iter, args);
	while (TRUE) {
		gconstpointer _tmp4_ = NULL;
		gconstpointer _tmp5_ = NULL;
		gboolean _tmp6_;
		GVariantBuilder* _tmp7_;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
		_tmp6_ = g_hash_table_iter_next (&iter, (gpointer*) (&_tmp4_), (gpointer*) (&_tmp5_));
		key = _tmp4_;
		value = _tmp5_;
		if (!_tmp6_) {
			break;
		}
		_tmp7_ = builder;
		_tmp8_ = key;
		_tmp9_ = value;
		drt_variant_dict_add_param (_tmp7_, _tmp8_, _tmp9_);
	}
	_tmp10_ = builder;
	_tmp11_ = g_variant_builder_end (_tmp10_);
	g_variant_ref_sink (_tmp11_);
	result = _tmp11_;
	_g_variant_builder_unref0 (builder);
	return result;
}


static gboolean
double_try_parse (const gchar* str,
                  gdouble* _result_,
                  const gchar* * unparsed)
{
	gdouble _vala_result = 0.0;
	const gchar* _vala_unparsed = NULL;
	gboolean result = FALSE;
	gchar* endptr = NULL;
	gchar* _tmp0_ = NULL;
	gdouble _tmp1_;
	gchar* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	g_return_val_if_fail (str != NULL, FALSE);
	_tmp1_ = g_ascii_strtod (str, &_tmp0_);
	endptr = _tmp0_;
	_vala_result = _tmp1_;
	_tmp2_ = endptr;
	_tmp3_ = strlen (str);
	_tmp4_ = _tmp3_;
	if (_tmp2_ == (((gchar*) str) + _tmp4_)) {
		_vala_unparsed = "";
		result = TRUE;
		if (_result_) {
			*_result_ = _vala_result;
		}
		if (unparsed) {
			*unparsed = _vala_unparsed;
		}
		return result;
	} else {
		gchar* _tmp5_;
		_tmp5_ = endptr;
		_vala_unparsed = (const gchar*) _tmp5_;
		result = FALSE;
		if (_result_) {
			*_result_ = _vala_result;
		}
		if (unparsed) {
			*unparsed = _vala_unparsed;
		}
		return result;
	}
	if (_result_) {
		*_result_ = _vala_result;
	}
	if (unparsed) {
		*unparsed = _vala_unparsed;
	}
}


static gboolean
bool_try_parse (const gchar* str,
                gboolean* _result_)
{
	gboolean _vala_result = FALSE;
	gboolean result = FALSE;
	g_return_val_if_fail (str != NULL, FALSE);
	if (g_strcmp0 (str, "true") == 0) {
		_vala_result = TRUE;
		result = TRUE;
		if (_result_) {
			*_result_ = _vala_result;
		}
		return result;
	} else {
		if (g_strcmp0 (str, "false") == 0) {
			_vala_result = FALSE;
			result = TRUE;
			if (_result_) {
				*_result_ = _vala_result;
			}
			return result;
		} else {
			_vala_result = FALSE;
			result = FALSE;
			if (_result_) {
				*_result_ = _vala_result;
			}
			return result;
		}
	}
	if (_result_) {
		*_result_ = _vala_result;
	}
}


void
drt_variant_dict_add_param (GVariantBuilder* dict_builder,
                            const gchar* key,
                            const gchar* value)
{
	gchar* param_type = NULL;
	gchar* param_key = NULL;
	GVariant* param_value = NULL;
	gchar** parts = NULL;
	gchar** _tmp0_;
	gchar** _tmp1_;
	gint parts_length1;
	gint _parts_size_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	const gchar* _tmp24_;
	GVariant* _tmp25_;
	g_return_if_fail (dict_builder != NULL);
	g_return_if_fail (key != NULL);
	g_return_if_fail (value != NULL);
	param_value = NULL;
	_tmp1_ = _tmp0_ = g_strsplit (key, ":", 2);
	parts = _tmp1_;
	parts_length1 = _vala_array_length (_tmp0_);
	_parts_size_ = parts_length1;
	_tmp2_ = parts;
	_tmp2__length1 = parts_length1;
	if (_tmp2__length1 < 2) {
		gchar* _tmp3_;
		gchar* _tmp4_;
		_tmp3_ = g_strdup ("s");
		_g_free0 (param_type);
		param_type = _tmp3_;
		_tmp4_ = g_strdup (key);
		_g_free0 (param_key);
		param_key = _tmp4_;
	} else {
		gchar** _tmp5_;
		gint _tmp5__length1;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		gchar** _tmp8_;
		gint _tmp8__length1;
		const gchar* _tmp9_;
		gchar* _tmp10_;
		_tmp5_ = parts;
		_tmp5__length1 = parts_length1;
		_tmp6_ = _tmp5_[0];
		_tmp7_ = g_strdup (_tmp6_);
		_g_free0 (param_type);
		param_type = _tmp7_;
		_tmp8_ = parts;
		_tmp8__length1 = parts_length1;
		_tmp9_ = _tmp8_[1];
		_tmp10_ = g_strdup (_tmp9_);
		_g_free0 (param_key);
		param_key = _tmp10_;
	}
	if (value == NULL) {
		_g_variant_unref0 (param_value);
		param_value = NULL;
	} else {
		const gchar* _tmp11_;
		const gchar* _tmp12_;
		GQuark _tmp14_ = 0U;
		static GQuark _tmp13_label0 = 0;
		static GQuark _tmp13_label1 = 0;
		_tmp11_ = param_type;
		_tmp12_ = _tmp11_;
		_tmp14_ = (NULL == _tmp12_) ? 0 : g_quark_from_string (_tmp12_);
		if (_tmp14_ == ((0 != _tmp13_label0) ? _tmp13_label0 : (_tmp13_label0 = g_quark_from_static_string ("d")))) {
			switch (0) {
				default:
				{
					gdouble d = 0.0;
					gdouble _tmp15_ = 0.0;
					gboolean _tmp16_;
					_tmp16_ = double_try_parse (value, &_tmp15_, NULL);
					d = _tmp15_;
					if (_tmp16_) {
						gdouble _tmp17_;
						GVariant* _tmp18_;
						_tmp17_ = d;
						_tmp18_ = g_variant_new_double (_tmp17_);
						g_variant_ref_sink (_tmp18_);
						_g_variant_unref0 (param_value);
						param_value = _tmp18_;
					}
					break;
				}
			}
		} else if (_tmp14_ == ((0 != _tmp13_label1) ? _tmp13_label1 : (_tmp13_label1 = g_quark_from_static_string ("b")))) {
			switch (0) {
				default:
				{
					gboolean b = FALSE;
					gboolean _tmp19_ = FALSE;
					gboolean _tmp20_;
					_tmp20_ = bool_try_parse (value, &_tmp19_);
					b = _tmp19_;
					if (_tmp20_) {
						gboolean _tmp21_;
						GVariant* _tmp22_;
						_tmp21_ = b;
						_tmp22_ = g_variant_new_boolean (_tmp21_);
						g_variant_ref_sink (_tmp22_);
						_g_variant_unref0 (param_value);
						param_value = _tmp22_;
					}
					break;
				}
			}
		} else {
			switch (0) {
				default:
				{
					GVariant* _tmp23_;
					_tmp23_ = g_variant_new_string (value);
					g_variant_ref_sink (_tmp23_);
					_g_variant_unref0 (param_value);
					param_value = _tmp23_;
					break;
				}
			}
		}
	}
	_tmp24_ = param_key;
	_tmp25_ = param_value;
	g_variant_builder_add (dict_builder, "{smv}", _tmp24_, _tmp25_, NULL);
	parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
	_g_variant_unref0 (param_value);
	_g_free0 (param_key);
	_g_free0 (param_type);
}


/**
 * Increase Variant reference if it is not null.
 * 
 * @param variant    Variant value to increase the reference of.
 */
void
drt_variant_ref (GVariant* variant)
{
	if (variant != NULL) {
		g_variant_ref (variant);
	}
}


/**
 * Decrease Variant reference if it is not null.
 * 
 * @param variant    Variant value to decrease the reference of.
 */
void
drt_variant_unref (GVariant* variant)
{
	if (variant != NULL) {
		g_variant_unref (variant);
	}
}


/**
 * Print variant as string
 * 
 * @param variant    Variant to print.
 * @return Printed value.
 */
gchar*
drt_print_variant (GVariant* variant)
{
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	if (variant != NULL) {
		gchar* _tmp1_;
		_tmp1_ = g_variant_print (variant, TRUE);
		_g_free0 (_tmp0_);
		_tmp0_ = _tmp1_;
	} else {
		gchar* _tmp2_;
		_tmp2_ = g_strdup ("null");
		_g_free0 (_tmp0_);
		_tmp0_ = _tmp2_;
	}
	result = _tmp0_;
	return result;
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



