/* X11.c generated by valac 0.40.6, the Vala compiler
 * generated from X11.vala, do not modify */

/*
 * Copyright 2015 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */


#include <glib.h>
#include <glib-object.h>
#include <gdk/gdk.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdkx.h>
#include <X11/Xlib.h>
#include <X11/Xatom.h>
#include <X11/Xutil.h>
#include <X11/Xregion.h>

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))



GdkX11Window* drtgtk_x11_get_window_property_as_win (GdkWindow* window,
                                                     const gchar* property);
gchar* drtgtk_x11_get_window_property_as_utf8 (GdkWindow* window,
                                               const gchar* property);
GdkX11Window* drtgtk_x11_get_net_wm_check_window (void);


/**
 * Retrieve window property of type window.
 * 
 * @param window      target window or ``null`` to use the default root window
 * @param property    name of the requested property
 * @return            the value of property as {@link Gdk.X11.Window} on success,
 *                    null on failure such as invalid ``window``, non-existent ``property``
 *                    or different property type than {@link X.XA_WINDOW}.
 */
static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


GdkX11Window*
drtgtk_x11_get_window_property_as_win (GdkWindow* window,
                                       const gchar* property)
{
	GdkX11Window* result = NULL;
	GdkX11Window* win = NULL;
	GdkX11Window* _result_ = NULL;
	GdkX11Display* display = NULL;
	GdkX11Window* _tmp3_;
	GdkDisplay* _tmp4_;
	GdkX11Display* _tmp5_;
	Atom type = {0};
	gint format = 0;
	gulong n_items = 0UL;
	gulong bytes_after = 0UL;
	void* data = NULL;
	GdkX11Display* _tmp6_;
	GdkX11Display* _tmp7_;
	Display* _tmp8_;
	GdkX11Window* _tmp9_;
	GdkX11Display* _tmp10_;
	Atom _tmp11_ = {0};
	gint _tmp12_ = 0;
	gulong _tmp13_ = 0UL;
	gulong _tmp14_ = 0UL;
	void* _tmp15_ = NULL;
	GdkX11Display* _tmp16_;
	Atom _tmp17_;
	void* _tmp22_;
	g_return_val_if_fail (property != NULL, NULL);
	_result_ = NULL;
	if (window != NULL) {
		GdkX11Window* _tmp0_;
		_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (window, gdk_x11_window_get_type ()) ? ((GdkX11Window*) window) : NULL);
		_g_object_unref0 (win);
		win = _tmp0_;
	} else {
		GdkWindow* _tmp1_;
		GdkX11Window* _tmp2_;
		_tmp1_ = gdk_get_default_root_window ();
		_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp1_, gdk_x11_window_get_type ()) ? ((GdkX11Window*) _tmp1_) : NULL);
		_g_object_unref0 (win);
		win = _tmp2_;
	}
	_tmp3_ = win;
	_tmp4_ = gdk_window_get_display ((GdkWindow*) _tmp3_);
	_tmp5_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp4_, gdk_x11_display_get_type ()) ? ((GdkX11Display*) _tmp4_) : NULL);
	display = _tmp5_;
	_tmp6_ = display;
	gdk_x11_display_error_trap_push (_tmp6_);
	_tmp7_ = display;
	_tmp8_ = gdk_x11_display_get_xdisplay (_tmp7_);
	_tmp9_ = win;
	_tmp10_ = display;
	XGetWindowProperty (_tmp8_, gdk_x11_window_get_xid (_tmp9_), gdk_x11_get_xatom_by_name_for_display (_tmp10_, property), (glong) 0, G_MAXLONG, FALSE, XA_WINDOW, &_tmp11_, &_tmp12_, &_tmp13_, &_tmp14_, (unsigned char **) (&_tmp15_));
	type = _tmp11_;
	format = _tmp12_;
	n_items = _tmp13_;
	bytes_after = _tmp14_;
	data = _tmp15_;
	_tmp16_ = display;
	gdk_x11_display_error_trap_pop_ignored (_tmp16_);
	_tmp17_ = type;
	if (_tmp17_ == XA_WINDOW) {
		Window xwin = 0;
		void* _tmp18_;
		GdkX11Display* _tmp19_;
		Window _tmp20_;
		GdkX11Window* _tmp21_;
		_tmp18_ = data;
		xwin = *((Window*) _tmp18_);
		_tmp19_ = display;
		_tmp20_ = xwin;
		_tmp21_ = (GdkX11Window*) gdk_x11_window_foreign_new_for_display (_tmp19_, _tmp20_);
		_g_object_unref0 (_result_);
		_result_ = _tmp21_;
	}
	_tmp22_ = data;
	if (_tmp22_ != NULL) {
		void* _tmp23_;
		_tmp23_ = data;
		XFree (_tmp23_);
	}
	result = _result_;
	_g_object_unref0 (display);
	_g_object_unref0 (win);
	return result;
}


/**
 * Retrieve window property of type UTF-8 string.
 * 
 * @param window      target window or ``null`` to use the default root window
 * @param property    name of the requested property
 * @return            the value of property as string on success,
 *                    null on failure such as invalid ``window`` or non-existent ``property``.
 */
gchar*
drtgtk_x11_get_window_property_as_utf8 (GdkWindow* window,
                                        const gchar* property)
{
	gchar* result = NULL;
	GdkX11Window* win = NULL;
	GdkX11Display* display = NULL;
	GdkX11Window* _tmp3_;
	GdkDisplay* _tmp4_;
	GdkX11Display* _tmp5_;
	Atom type = {0};
	gint format = 0;
	gulong n_items = 0UL;
	gulong bytes_after = 0UL;
	void* data = NULL;
	gchar* name = NULL;
	GdkX11Display* _tmp6_;
	GdkX11Display* _tmp7_;
	Display* _tmp8_;
	GdkX11Window* _tmp9_;
	GdkX11Display* _tmp10_;
	GdkX11Display* _tmp11_;
	Atom _tmp12_ = {0};
	gint _tmp13_ = 0;
	gulong _tmp14_ = 0UL;
	gulong _tmp15_ = 0UL;
	void* _tmp16_ = NULL;
	GdkX11Display* _tmp17_;
	void* _tmp18_;
	g_return_val_if_fail (property != NULL, NULL);
	if (window != NULL) {
		GdkX11Window* _tmp0_;
		_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (window, gdk_x11_window_get_type ()) ? ((GdkX11Window*) window) : NULL);
		_g_object_unref0 (win);
		win = _tmp0_;
	} else {
		GdkWindow* _tmp1_;
		GdkX11Window* _tmp2_;
		_tmp1_ = gdk_get_default_root_window ();
		_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp1_, gdk_x11_window_get_type ()) ? ((GdkX11Window*) _tmp1_) : NULL);
		_g_object_unref0 (win);
		win = _tmp2_;
	}
	_tmp3_ = win;
	_tmp4_ = gdk_window_get_display ((GdkWindow*) _tmp3_);
	_tmp5_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp4_, gdk_x11_display_get_type ()) ? ((GdkX11Display*) _tmp4_) : NULL);
	display = _tmp5_;
	name = NULL;
	_tmp6_ = display;
	gdk_x11_display_error_trap_push (_tmp6_);
	_tmp7_ = display;
	_tmp8_ = gdk_x11_display_get_xdisplay (_tmp7_);
	_tmp9_ = win;
	_tmp10_ = display;
	_tmp11_ = display;
	XGetWindowProperty (_tmp8_, gdk_x11_window_get_xid (_tmp9_), gdk_x11_get_xatom_by_name_for_display (_tmp10_, property), (glong) 0, G_MAXLONG, FALSE, gdk_x11_get_xatom_by_name_for_display (_tmp11_, "UTF8_STRING"), &_tmp12_, &_tmp13_, &_tmp14_, &_tmp15_, (unsigned char **) (&_tmp16_));
	type = _tmp12_;
	format = _tmp13_;
	n_items = _tmp14_;
	bytes_after = _tmp15_;
	data = _tmp16_;
	_tmp17_ = display;
	gdk_x11_display_error_trap_pop_ignored (_tmp17_);
	_tmp18_ = data;
	if (_tmp18_ != NULL) {
		void* _tmp19_;
		gchar* _tmp20_;
		void* _tmp21_;
		_tmp19_ = data;
		_tmp20_ = g_strdup ((const gchar*) _tmp19_);
		_g_free0 (name);
		name = _tmp20_;
		_tmp21_ = data;
		XFree (_tmp21_);
	}
	result = name;
	_g_object_unref0 (display);
	_g_object_unref0 (win);
	return result;
}


/**
 * Retrieve WM_CHECK Window of a compliant window manager
 * 
 * See [[http://standards.freedesktop.org/wm-spec/1.3/ar01s03.html|Extended Window Manager Hints]].
 * 
 * @return    WM_CHECK Window of a compliant window manager of null if there is not any
 */
GdkX11Window*
drtgtk_x11_get_net_wm_check_window (void)
{
	GdkX11Window* result = NULL;
	GdkX11Window* window = NULL;
	GdkX11Window* _tmp0_;
	GdkX11Window* _tmp1_;
	GdkX11Window* _tmp2_;
	GdkX11Window* _tmp3_;
	GdkX11Window* _tmp4_;
	GdkX11Window* _tmp5_;
	gboolean _tmp6_;
	_tmp0_ = drtgtk_x11_get_window_property_as_win (NULL, "_NET_SUPPORTING_WM_CHECK");
	window = _tmp0_;
	_tmp1_ = window;
	if (_tmp1_ == NULL) {
		result = NULL;
		_g_object_unref0 (window);
		return result;
	}
	_tmp2_ = window;
	_tmp3_ = drtgtk_x11_get_window_property_as_win ((GdkWindow*) _tmp2_, "_NET_SUPPORTING_WM_CHECK");
	_tmp4_ = _tmp3_;
	_tmp5_ = window;
	_tmp6_ = gdk_x11_window_get_xid (_tmp4_) != gdk_x11_window_get_xid (_tmp5_);
	_g_object_unref0 (_tmp4_);
	if (_tmp6_) {
		result = NULL;
		_g_object_unref0 (window);
		return result;
	}
	result = window;
	return result;
}



