/* main.c generated by valac 0.40.6, the Vala compiler
 * generated from main.vala, do not modify */

/*
 * Copyright 2015-2017 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <sqlite3.h>
#include <gio/gio.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

typedef enum  {
	DRTDB_DATABASE_ERROR_UNKNOWN,
	DRTDB_DATABASE_ERROR_IOERROR,
	DRTDB_DATABASE_ERROR_DATABASE_NOT_OPENED,
	DRTDB_DATABASE_ERROR_GENERAL,
	DRTDB_DATABASE_ERROR_RANGE,
	DRTDB_DATABASE_ERROR_DATA_TYPE,
	DRTDB_DATABASE_ERROR_NAME,
	DRTDB_DATABASE_ERROR_MISMATCH,
	DRTDB_DATABASE_ERROR_MISUSE,
	DRTDB_DATABASE_ERROR_DOES_NOT_EXIST,
	DRTDB_DATABASE_ERROR_TOO_MANY_RESULTS
} DrtdbDatabaseError;
#define DRTDB_DATABASE_ERROR drtdb_database_error_quark ()


GQuark drtdb_database_error_quark (void);
gboolean drtdb_is_type_supported (GType* type);
static gboolean _g_type_equal (const GType * s1,
                        const GType * s2);
GParamSpec** drtdb_create_param_spec_list (GObjectClass* class_spec,
                                           gchar** properties,
                                           int properties_length1,
                                           int* result_length1,
                                           GError** error);
GError* drtdb_convert_sqlite_error (gint errno,
                                    const gchar* message,
                                    const gchar* sql,
                                    sqlite3_stmt* stm);
gboolean drtdb_is_sql_error (gint result_code);
void drtdb_throw_if_cancelled (GCancellable* cancellable,
                               const gchar* method,
                               const gchar* file,
                               gint line,
                               GError** error);
gchar* drtdb_escape_sql_id (const gchar* sql_id);


GQuark
drtdb_database_error_quark (void)
{
	return g_quark_from_static_string ("drtdb_database_error-quark");
}


/**
 * Check whether data type is supported
 * 
 * @param type    the type to check
 * @return `true` if the given type is supported, `false` otherwise
 */
static gboolean
_g_type_equal (const GType * s1,
               const GType * s2)
{
	if (s1 == s2) {
		return TRUE;
	}
	if (s1 == NULL) {
		return FALSE;
	}
	if (s2 == NULL) {
		return FALSE;
	}
	return (*s1) == (*s2);
}


gboolean
drtdb_is_type_supported (GType* type)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
	if (type == NULL) {
		_tmp8_ = TRUE;
	} else {
		GType _tmp9_;
		_tmp9_ = G_TYPE_BOOLEAN;
		_tmp8_ = _g_type_equal (type, &_tmp9_) == TRUE;
	}
	if (_tmp8_) {
		_tmp7_ = TRUE;
	} else {
		GType _tmp10_;
		_tmp10_ = G_TYPE_INT;
		_tmp7_ = _g_type_equal (type, &_tmp10_) == TRUE;
	}
	if (_tmp7_) {
		_tmp6_ = TRUE;
	} else {
		GType _tmp11_;
		_tmp11_ = G_TYPE_INT64;
		_tmp6_ = _g_type_equal (type, &_tmp11_) == TRUE;
	}
	if (_tmp6_) {
		_tmp5_ = TRUE;
	} else {
		GType _tmp12_;
		_tmp12_ = G_TYPE_STRING;
		_tmp5_ = _g_type_equal (type, &_tmp12_) == TRUE;
	}
	if (_tmp5_) {
		_tmp4_ = TRUE;
	} else {
		GType _tmp13_;
		_tmp13_ = G_TYPE_DOUBLE;
		_tmp4_ = _g_type_equal (type, &_tmp13_) == TRUE;
	}
	if (_tmp4_) {
		_tmp3_ = TRUE;
	} else {
		GType _tmp14_;
		_tmp14_ = G_TYPE_FLOAT;
		_tmp3_ = _g_type_equal (type, &_tmp14_) == TRUE;
	}
	if (_tmp3_) {
		_tmp2_ = TRUE;
	} else {
		GType _tmp15_;
		_tmp15_ = G_TYPE_BYTES;
		_tmp2_ = _g_type_equal (type, &_tmp15_) == TRUE;
	}
	if (_tmp2_) {
		_tmp1_ = TRUE;
	} else {
		GType _tmp16_;
		_tmp16_ = G_TYPE_BYTE_ARRAY;
		_tmp1_ = _g_type_equal (type, &_tmp16_) == TRUE;
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		GType _tmp17_;
		_tmp17_ = G_TYPE_POINTER;
		_tmp0_ = _g_type_equal (type, &_tmp17_) == TRUE;
	}
	result = _tmp0_;
	return result;
}


/**
 * Create a list of property specifications of a given ObjectClass
 * 
 * @param class_spec    object class to retrieve property specifications from
 * @param properties    properties to retrieve specification for or `null` to use all properties
 * @return array of requested property specifications
 */
GParamSpec**
drtdb_create_param_spec_list (GObjectClass* class_spec,
                              gchar** properties,
                              int properties_length1,
                              int* result_length1,
                              GError** error)
{
	GParamSpec** result = NULL;
	GParamSpec** properties_list = NULL;
	gint properties_list_length1 = 0;
	gint _properties_list_size_ = 0;
	gboolean _tmp0_ = FALSE;
	GParamSpec** _tmp19_;
	gint _tmp19__length1;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (class_spec != NULL, NULL);
	if (properties == NULL) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = properties_length1 == 0;
	}
	if (_tmp0_) {
		guint _tmp1_;
		GParamSpec** _tmp2_;
		_tmp2_ = g_object_class_list_properties (class_spec, &_tmp1_);
		properties_list = (g_free (properties_list), NULL);
		properties_list = _tmp2_;
		properties_list_length1 = _tmp1_;
		_properties_list_size_ = properties_list_length1;
	} else {
		GParamSpec** _tmp3_;
		_tmp3_ = g_new0 (GParamSpec*, properties_length1 + 1);
		properties_list = (g_free (properties_list), NULL);
		properties_list = _tmp3_;
		properties_list_length1 = properties_length1;
		_properties_list_size_ = properties_list_length1;
		{
			gint i = 0;
			i = 0;
			{
				gboolean _tmp4_ = FALSE;
				_tmp4_ = TRUE;
				while (TRUE) {
					gint _tmp6_;
					GParamSpec** _tmp7_;
					gint _tmp7__length1;
					gint _tmp8_;
					gint _tmp9_;
					const gchar* _tmp10_;
					GParamSpec* _tmp11_;
					GParamSpec* _tmp12_;
					GParamSpec** _tmp13_;
					gint _tmp13__length1;
					gint _tmp14_;
					GParamSpec* _tmp15_;
					if (!_tmp4_) {
						gint _tmp5_;
						_tmp5_ = i;
						i = _tmp5_ + 1;
					}
					_tmp4_ = FALSE;
					_tmp6_ = i;
					if (!(_tmp6_ < properties_length1)) {
						break;
					}
					_tmp7_ = properties_list;
					_tmp7__length1 = properties_list_length1;
					_tmp8_ = i;
					_tmp9_ = i;
					_tmp10_ = properties[_tmp9_];
					_tmp11_ = g_object_class_find_property (class_spec, _tmp10_);
					_tmp7_[_tmp8_] = _tmp11_;
					_tmp12_ = _tmp7_[_tmp8_];
					_tmp13_ = properties_list;
					_tmp13__length1 = properties_list_length1;
					_tmp14_ = i;
					_tmp15_ = _tmp13_[_tmp14_];
					if (_tmp15_ == NULL) {
						gint _tmp16_;
						const gchar* _tmp17_;
						GError* _tmp18_;
						_tmp16_ = i;
						_tmp17_ = properties[_tmp16_];
						_tmp18_ = g_error_new (DRTDB_DATABASE_ERROR, DRTDB_DATABASE_ERROR_NAME, "There is no property named '%s'.", _tmp17_);
						_inner_error_ = _tmp18_;
						if (_inner_error_->domain == DRTDB_DATABASE_ERROR) {
							g_propagate_error (error, _inner_error_);
							properties_list = (g_free (properties_list), NULL);
							return NULL;
						} else {
							properties_list = (g_free (properties_list), NULL);
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
							g_clear_error (&_inner_error_);
							return NULL;
						}
					}
				}
			}
		}
	}
	_tmp19_ = properties_list;
	_tmp19__length1 = properties_list_length1;
	if (result_length1) {
		*result_length1 = _tmp19__length1;
	}
	result = _tmp19_;
	return result;
}


/**
 * Convert SQLite error code to DatabaseError
 * 
 * SQLite error codes: [[http://www.sqlite.org/rescode.html]]
 * 
 * Parameters `message`, `sql` and `stm` are optional but add more information
 * to the resulting error message.
 * 
 * @param errno      sqlite error code
 * @param message    error message
 * @param sql        executed sql query
 * @param stm        sqlite statement
 * @return corresponding {@link DatabaseError}
 */
GError*
drtdb_convert_sqlite_error (gint errno,
                            const gchar* message,
                            const gchar* sql,
                            sqlite3_stmt* stm)
{
	GError* result = NULL;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp3_ = NULL;
	gchar* msg = NULL;
	gchar* _tmp4_;
	GError* _tmp5_;
	_tmp0_ = message;
	if (_tmp0_ == NULL) {
		_tmp0_ = "(unknown message)";
	}
	if (stm != NULL) {
		const gchar* _tmp2_;
		_tmp2_ = sqlite3_sql (stm);
		_tmp1_ = _tmp2_;
	} else {
		_tmp1_ = NULL;
	}
	_tmp3_ = sql;
	if (_tmp3_ == NULL) {
		_tmp3_ = _tmp1_;
	}
	_tmp4_ = g_strdup_printf ("SQLite Error %d: %s. |%s|", errno, _tmp0_, _tmp3_);
	msg = _tmp4_;
	_tmp5_ = g_error_new_literal (DRTDB_DATABASE_ERROR, DRTDB_DATABASE_ERROR_GENERAL, msg);
	result = _tmp5_;
	_g_free0 (msg);
	return result;
}


/**
 * Check whether sqlite result code is an error code
 * 
 * @param result_code    sqlite result code
 * @return `true` if the code corresponds to an error, `false` otherwise
 */
inline gboolean
drtdb_is_sql_error (gint result_code)
{
	gboolean result = FALSE;
	switch (result_code) {
		case SQLITE_OK:
		case SQLITE_ROW:
		case SQLITE_DONE:
		{
			result = FALSE;
			return result;
		}
		default:
		{
			result = TRUE;
			return result;
		}
	}
}


/**
 * Throw {@link GLib.IOError} if an operation has been cancelled.
 * 
 * Typical usage:
 * 
 * {{{
 * throw_if_cancelled(cancellable, GLib.Log.METHOD, GLib.Log.FILE, GLib.Log.LINE);
 * }}}
 * 
 * @param cancellable    Cancellation object.
 * @param method         Called method
 * @param file           Source code file
 * @param line           Source code line
 */
void
drtdb_throw_if_cancelled (GCancellable* cancellable,
                          const gchar* method,
                          const gchar* file,
                          gint line,
                          GError** error)
{
	gboolean _tmp0_ = FALSE;
	GError * _inner_error_ = NULL;
	if (cancellable != NULL) {
		_tmp0_ = g_cancellable_is_cancelled (cancellable);
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		GError* _tmp1_;
		_tmp1_ = g_error_new (G_IO_ERROR, G_IO_ERROR_CANCELLED, "Operation was cancelled in %s (%s:%d).", method, file, line);
		_inner_error_ = _tmp1_;
		if (_inner_error_->domain == G_IO_ERROR) {
			g_propagate_error (error, _inner_error_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


/**
 * Escape SQL identifier
 * 
 * @param sql_id    SQL id to escape
 * @return escaped id
 */
static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	if ((*((gchar*) self)) == '\0') {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = (*((gchar*) old)) == '\0';
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
	}
	if (_tmp0_) {
		gchar* _tmp2_;
		_tmp2_ = g_strdup (self);
		result = _tmp2_;
		return result;
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		_tmp3_ = g_regex_escape_string (old, -1);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error_);
		_tmp6_ = _tmp5_;
		_g_free0 (_tmp4_);
		regex = _tmp6_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch5_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp8_ = regex;
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error_);
		_tmp7_ = _tmp9_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_regex_unref0 (regex);
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch5_g_regex_error;
			}
			_g_regex_unref0 (regex);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp10_ = _tmp7_;
		_tmp7_ = NULL;
		result = _tmp10_;
		_g_free0 (_tmp7_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally5;
	__catch5_g_regex_error:
	{
		GError* e = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		g_assert_not_reached ();
		_g_error_free0 (e);
	}
	__finally5:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
}


inline gchar*
drtdb_escape_sql_id (const gchar* sql_id)
{
	gchar* result = NULL;
	gchar* _tmp0_;
	g_return_val_if_fail (sql_id != NULL, NULL);
	_tmp0_ = string_replace (sql_id, "\"", "\"\"");
	result = _tmp0_;
	return result;
}



